#ifndef TMatrix_h
#define TMatrix_h
#include "TVector.h"
class TMatrix {
	public:
		float m[4][4] ;
		TMatrix(void) ;
		TMatrix(float diag) ;
		TMatrix& operator=(const TMatrix&) ;
		TMatrix& operator=(const float) ;
		
		// Friend function operators
		friend TMatrix operator*(const TMatrix&,const TMatrix&) ;
		friend TMatrix operator+(const TMatrix&,const TMatrix&) ;
		friend TMatrix operator-(const TMatrix&,const TMatrix&) ;
		friend TVector operator*(const TMatrix&,const TVector&) ;
		friend void InvertMatrix(const TMatrix&,TMatrix&) ;
		friend void TransposeMatrix(const TMatrix&,TMatrix&) ;
} ;
#endif // TMatrix_h
