#ifndef TVector_h
#define TVector_h


typedef enum { k001,k010,k100,k110,k1_10,k_110,k120,k210,k2_10,k_120,k111,k_1_11,
				k_111,k1_11,k101,k011,k_101,k0_11, kNotSimple } SimpleDirection;


class TVector {
	public:
		float 			a[4] ;
		float 				length() ;
		SimpleDirection 	GetSimpleD();
		TVector(float a1=0.0,float a2=0.0,float a3=0.0,float a4=0.0) ;
		TVector& operator*=(const float) ;
		TVector& operator/=(const float) ;
		TVector& operator+=(const float) ;
		TVector& operator-=(const float) ;
		
	// Friend function operators
		friend TVector operator*(const TVector&,const float) ;
		friend TVector operator/(const TVector&,const float) ;
		friend TVector operator+(const TVector&,const float) ;
		friend TVector operator-(const TVector&,const float) ;
		friend TVector operator*(const TVector&,const TVector&) ;	
		friend float   operator^(const TVector&,const TVector&) ;
		friend TVector operator+(const TVector&,const TVector&) ;	
		friend TVector operator-(const TVector&,const TVector&) ;	
		friend void	NormalizeVector(TVector&) ;
		
} ;
#endif // TVector_h

