C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SIGMA1 (FHK, H, K, NREF, SYMM, IDEF )
C     Let us look for sigma1 definitions
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         include 'Nlimit.h'
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         DIMENSION FHK(*)
         INTEGER IFOUND(NHK2), IDEF(NHK2,60)
         CHARACTER*4 SYMM
         CHARACTER*1 SIGNER
         INTEGER HE(20), KE(20), ISE(20), H(*), K(*)
         DIMENSION SUM(NHK2)
         COMMON /SUMPASS/SUM
         SAVE /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
         INTEGER II1, II2, II3, II4, II5, II6
         REAL RR1, RR2, RR3, RR4
         DOUBLE PRECISION DD1
         LOGICAL LL1, LL2
 
         DO   J=1,NREF
C     Zero array of found values for later
           IFOUND(J) = 0
           SUM(J) = 0.
           IF (H(J) .EQ. 0 .AND. K(J) .EQ. 0) I0 = J
         END DO
 
         II2 = NREF
         DO   J=1,II2
           IF (H(J) .NE. 0 .OR. K(J) .NE. 0) THEN
             IHH = H(J)
             IKK = K(J)
             CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
             RR2 = FHK(J) * FHK(J)
             DO   I1=1,NE
               II4 = ISE(I1)
               LL1 = II4 .EQ. 3
               LL2 = II4 .EQ. 1000
               II5 = HE(I1)
               II6 = KE(I1)
               RR1 = RR2
               DO   I2=I1,NE
                 ISIGN = 0
                 ISIGN1 = 0
                 ISIGN2 = 0
                 IF (II4 * ISE(I2) .EQ. (-1)) ISIGN = 1
                 IF (LL1) ISIGN1 = 1
                 IF (ISE(I2) .EQ. 3) ISIGN2 = 1
                 IF (LL2) ISIGN1 = (-1)
                 IF (ISE(I2) .EQ. 1000) ISIGN2 = (-1)
                 ISIGN1 = ISIGN1 * ISIGN2
                 ITHERE = 0
                 IF (ISIGN .GT. 0) ITHERE = 1
                 IF (ISIGN1 .NE. 0) ITHERE = ISIGN1
                 IF (ITHERE .NE. 0) THEN
C     Note: there may be more cases to include laterc      See if this beam is p
                   IHH = II5 + HE(I2)
                   IKK = II6 + KE(I2)
C     See if this beam is part of the starting set
                   JK = ICHECK (IHH,IKK,H,K,NREF)
                   IF (JK .GT. 0) THEN
C     Store the index, positive for 2pi, -ve for pi
 
C     First, trap found twice - but keep this information for sum at least!
                     II3 = ITHERE * J
                     DO   II1=1,IFOUND(JK)
                       IF (II3 .EQ. IDEF(JK,II1)) GO TO 2001
                     END DO
C     Not there
                     N = IFOUND(JK) + 1
                     IFOUND(JK) = IFOUND(JK) + 1
                     IDEF(JK,N) = ITHERE * J
C     There
 2001                SUM(JK) = SUM(JK) + RR1 * ITHERE
                     IF (I1 .NE. I2) SUM(JK) = SUM(JK) + RR1 * ITHERE
                   END IF
                 END IF
 
C     Done searching this reflection
               END DO
             END DO
           END IF
         END DO
 
         write (10, *) ' '
         WRITE (10, 10)
         WRITE (10, 20)
   20    FORMAT('Sigma-1 Relationships'/
     X      'Beams strongly defined by Sigma-1 relationships might'/
     X      'either be excluded from the starting set or set to 360')
C        WRITE (10, 10)
C     Print out the results
         RR4 = FHK(I0)
         DO   J=1,NREF
           APLUS = 1.
           AMINUS = 1.
           IF (IFOUND(J) .GT. 0) THEN
             WRITE (10, 10)
             WRITE (10, 1) H(J), K(J), FHK(J)
   10        FORMAT('*************************************************')
    1        FORMAT('Beams defining (',I3,',',I3,'), E:',F12.5)
             RR3 = RR4
             DD1 = 0.5D0 * FHK(J)
             DO   I=1,IFOUND(J)
               IND = ABS (IDEF(J,I))
               SIGNER = '+'
               IF (IDEF(J,I) / IND .EQ. (-1)) SIGNER = '-'
C     Look at probability ?
               TERM = DD1 * ((-1.D0) + FHK(IND) * FHK(IND)) / RR3
               PPLUS = 0.5D0 + 0.5D0 * TANH (TERM)
               APLUS = APLUS * PPLUS
               AMINUS = AMINUS * (1.D0 - PPLUS)
               IF(PPLUS.GT.0.9)then
               WRITE(10,2)H(IND),K(IND),FHK(IND),SIGNER,PPLUS,
     X          ' << Large Probability of 360 phase'
               ELSE
               WRITE (10, 2) H(IND), K(IND), FHK(IND), SIGNER, PPLUS
               ENDIF
    2          FORMAT('Beam (',I3,',',I3,') E:',F10.5,' Sign ',A,
     X            ',  Probability ',F6.3,A)
             END DO
C             IF (IFOUND(J) .GT. 1) THEN
C               WRITE (10, 201) SUM(J)
  201          FORMAT('Total squared  ',F10.5)
C             END IF
           END IF
         END DO
         WRITE (10, 10)
         RETURN
       END
 
 
       FUNCTION ICHECK (I1, K1, H, K, NREF )
         INTEGER H(*), K(*)
C     Look to see if the combination of (i1,k1) is part
C     of the data (ignoring 0,0), returning its index
         IF (I1 .EQ. 0 .AND. K1 .EQ. 0) THEN
           ICHECK = (-1)
           RETURN
         END IF
         DO   J=1,NREF
           IF (I1 .EQ. H(J) .AND. K1 .EQ. K(J)) THEN
             ICHECK = J
             RETURN
           END IF
         END DO
         ICHECK = (-1)
         RETURN
       END
 
 
 
 
