      double precision function rgcaler(fhk,fcalc,nref,i)
C     Intensity Fix
C     Use approach that works in refinements, i.e. sum fcalc**2*wt/fobs**2*wt
C     This reduces emphasis on strong, badly measured reflections
      dimension fhk(*),fcalc(*)
      include 'RefineWts.h'
      double precision s2,s4,s5,scL,err
      double precision t1,t2,t3
C       Calculate error-fit in Chi**2 fashion
C       Intensity conservation code
        include 'errref.h'
        INCLUDE 'Iconserve.h'
        INCLUDE 'Iconserve1.h'
C       Calculate error-fit
      err=0d0
      if(multiplicity)then
          npt=0
          do j=1,nref
            t1=ffhk(j)-scL*dble(fcalc(j))*rewt(j)
            err=err+abs(t1)*rmulti(j)
            npt=npt+rmulti(j)
          enddo
       else
          do j=1,nref
            t1=ffhk(j)-scL*dble(fcalc(j))*rewt(j)
            err=err+abs(t1)
          enddo
          npt=nref
      endif
       rgcaler=(err/dble(npt))*chifactor
       return
       end
      real function rgcalers(fhk,fcalc,nref,i)
C     Intensity Fix
C     Use approach that works in refinements, i.e. sum fcalc**2*wt/fobs**2*wt
C     This reduces emphasis on strong, badly measured reflections
      dimension fhk(*),fcalc(*)
      include 'RefineWts.h'
C      real s2,s4,s5,scL,err
C      real t1,t2,t3
C       Calculate error-fit in Chi fashion
C       Intensity conservation code
        INCLUDE 'Iconserves.h'
C       Calculate error-fit
      err=0d0
      do j=1,nref
            t1=ffhk(j)-scL*(fcalc(j))
            err=err+abs(t1)
      enddo
       rgcalers=(err/(nref))
       return
       end

