C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a coyo of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
      double precision function robf3Dn(fhk,nref,
     $  natom,x,y,z,symm,h,k,l,itype,i)
        include 'ffact.h'
        include 'errref.h'
        include 'FastDerdT.h'
        include 'Constraints.h'
      dimension fhk(*),wx(12),wy(12),igotn(20)
      complex*16 amp,amp2,amp3
C      double precision xe(12,natf),ye(12,natf)
      double precision fbump
      integer h(*),k(*),l(*),itype(*)
      dimension x(*),y(*),z(*),fcv(4000)
      double precision f0,rgcalw,p,pi2,u,v,w,piz,ampt(2),ampt3(2)
      character*4 symm
C      complex*16 x2d(12,40,-40:40),y2d(12,40,-40:40),zrod(40,-100:100)
      equivalence (amp,ampt), (ampt3,amp3)
      save f0
        logical centro
        common /ccentr/centro
        save nrefo,ixmax,ixmin,iymax,iymin,izmax,izmin
        data nrefo/0/
        logical robnod,rob_fit,dwref,robfm,nodd5
        common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
        include 'STO111.h'
C       call chinumb(x,y,natom,itype,symm,nchi)
C       chifactor = float(nref)/max(1.,float(nref-nchi))

        do j=1,20
                igotn(j)=0
        enddo
C       Look for centering
        call centered(symm)
        pi2=4.d0*asin(1.0d0)
C

        if(nrefo.ne.nref)then
C       Find ranges to use      
        izmax=0
        ixmax=0
        iymax=0
        ixmin=0
        iymin=0
        izmin=0
        do j=1,nref
                ixmax=max(ixmax,h(j))
                ixmin=min(ixmin,h(j))
                iymax=max(iymax,k(j))
                iymin=min(iymin,k(j))
C               izmax=max(izmax,l(j))
C               izmin=min(izmin,l(j))
        enddo
        nrefo=nref
        endif

C       Expand atoms    
C     if(i.lt.0)f0=0.0
      do n=1,natom
         call asymm(x(n),y(n),ne,wx,wy,symm)
         ii=itype(n)
         if(ii.lt.1)itype(n)=1
         igotn(itype(n))=igotn(itype(n))+ne
           if(symm(1:1).eq.'c')ne=ne/2
         do j=1,ne
                xe(j,n)=wx(j)
                ye(j,n)=wy(j)
         enddo
         ine(n)=ne
C         write(6,*)'Equiv ',natom,ne,symm
      enddo
      
C
C       do j3=izmin,izmax
C               w=j3*pi2
C               do n=1,natom
C                       p=w*dble(z(n))
C                       zrod(n,j3)=cmplx(cos(p),sin(p))
C               enddo
C       enddo
        
C
C       if(centro)then
C       Calculate the x for each atom
C       do j=ixmin,ixmax
C               u=j*pi2
C               do n=1,natom
C                       do j2=1,ine(n)
C                               x2d(j2,n,j)=cos(u*xe(j2,n))
C                       enddo
C               enddo
C       enddo
C
C       Calculate the y for each atom
C       do j=iymin,iymax
C               v=j*pi2
C               do n=1,natom
C                       do j2=1,ine(n)
C                               y2d(j2,n,j)=cos(v*ye(j2,n))
C                       enddo
C               enddo
C       enddo
C       else
C       Calculate the x for each atom
        do j=ixmin,ixmax
                u=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=u*xe(j2,n)
                                x2d(j2,n,j)=cmplx(cos(p),sin(p))
                        enddo
                enddo
        enddo
C
C       Calculate the y for each atom
        do j=iymin,iymax
                v=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=v*ye(j2,n)
                                y2d(j2,n,j)=cmplx(cos(p),sin(p))
                        enddo
                enddo
        enddo
C       endif
C       Now calculate values
        sumfv=0
      do j=1,nref
        amp=0
        do n=1,natom
                amp2=0
                do j2=1,ine(n)
                        amp2=amp2+x2d(j2,n,h(j))*y2d(j2,n,k(j))
                enddo
                if(centro)amp2=dble(amp2)
C               p=rfactb(itype(n),j)
C               amp=amp+amp2*zrod(n,l(j))*dble(rfactb(itype(n),j))
                amp=amp+amp2*dble(rfactb(itype(n),j))
        enddo
C       write(6,*)j,amp
        if(abs(ampt(1)).lt.1d-15.and.abs(ampt(2)).lt.1d-15)then
                fcv(j)=0
        else
                fcv(j)=ampt(1)*ampt(1)+ampt(2)*ampt(2)
        endif
C         Twinning added
        if(twin)then
          amp3=0
          do n=1,natom
                amp2=0
                do j2=1,ine(n)
                        amp2=amp2+x2d(j2,n,k(j))*y2d(j2,n,h(j))
                enddo
                if(centro)amp2=dble(amp2)
                amp3=amp3+amp2*dble(rfactb(itype(n),j))
          enddo
          fcv(j)=(fcv(j)+ampt3(1)*ampt3(1)+ampt3(2)*ampt3(2))*0.5D0
          endif
        sumfv=sumfv+fcv(j)
      enddo
C       Trap no overlap
        if(sumfv.lt.1e-3)then
                robf3Dn=2e5
                return
        endif
        robf3Dn=rgcalw(fhk,fcv,nref,i)

C       Constraints
C       robf3Dn=robf3Dn+snewcon(x,y,z,symm,itype,natom)
C
C       Bumping
        rbump= fbump(x,y,z,natom,symm,itype) * bumpwt
C       Bonding
        rbond= bonderr(x,y,z,symm,natom,itype) * bondwt
        robf3Dn=robf3Dn+ rbond + rbump
        if(chemon)then
C       Accumulate nett valence charge
                ValCharge=BaseCharge
                do j=1,10
                        ValCharge=ValCharge+igotn(j)*ValAtoms(j)
                enddo
C       Penalty function
                rstoich=(1-exp(-abs(ValCharge)*ValPen))*ValW
                robf3Dn=robf3Dn + rstoich * chemwt
        endif
      end

