C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
C program avfit calculates the average fitness in the actual population
 
 
       PROGRAM AVFIT
 
C  nndiv: number of chromosomes in one population
C  fiti: fitness of a chromosome
C  fith: help variable
C  fitav: average fitness of actual population
         INTEGER NNDIV
         REAL FITH, FITI, FITAV
 
         OPEN (1, FILE='helpfile', STATUS='old')
         OPEN (2, FILE='fitfile', STATUS='unknown')
         OPEN (3, FILE='helpfile2', STATUS='unknown')
 
   10    FORMAT(/,I4)
   20    FORMAT(F15.4)
   30    FORMAT(F7.4)
 
 
C======================================================================
C read needed information from file 'helpfile'
C======================================================================
 
C number of actual chromosome?
         READ (1, *) IJUNK, NNDIV
 
C======================================================================
C read fitness of single chromosomes and calculate average fitness
C======================================================================
 
         FITH = 0.
         NF = 0
         DO 100 I=1,NNDIV
           READ (2, *, ERR=101, END=101) FITN
           NF = NF + 1
           FITH = FITH + FITN
  100      CONTINUE
  101    FITAV = FITH / REAL (NF)
 
         WRITE (3, 30) FITAV
 
C======================================================================
 
       END
