      subroutine setup3Db(ih,k,l,fatom,nref,natom,x,y,z,symm,
     $  wts)
      include 'rfact.h'
      include 'FastDers.h'

      dimension x(*),y(*),z(*),wts(*)
      complex fatom(*)
      integer ih(*),k(*),l(*)
      dimension wx(20),wy(20)
      character*4 symm,sympass
      common /passsym/sympass
      save ne
      complex*16 amp,amp2
C      double precision xe(12,80),ye(12,80)
      double precision s1,s2,f0,ampr,ampi,p,pi2,u,v,w,piz
C      complex*16 x2d(-40:40,80,12),y2d(-40:40,80,12)
C      complex*16 zrod(-100:100,60)
        logical centro
        common /ccentr/centro
        common /rsums/izsampl
C
C       Look for centering
        call centered(symm)
        pi2=4.d0*asin(1.0d0)
C         piz=pi2/izsampl
C
      sympass=symm

C       Find ranges to use      
        izmax=0
        ixmax=0
        iymax=0
        ixmin=0
        iymin=0
        izmin=0
        do j=1,nrref
                ixmax=max(ixmax,rh(j))
                ixmin=min(ixmin,rh(j))
                iymax=max(iymax,rk(j))
                iymin=min(iymin,rk(j))
C               izmax=max(izmax,rl(j))
C               izmin=min(izmin,rl(j))
        enddo

C       Expand atoms    
      do n=1,natom
         call asymm(x(n),y(n),ne,wx,wy,symm)
         do j=1,ne
                xe(j,n)=wx(j)
                ye(j,n)=wy(j)
         enddo
         ine(n)=ne
      enddo
C
C       do j3=izmin,izmax
C               w=j3*pi2
C               do n=1,natom
C                       p=w*dble(z(n))
C                       zrod(j3,n)=cmplx(cos(p),sin(p))
C               enddo
C       enddo
        
C
C       Calculate the x for each atom
        do j=ixmin,ixmax
                u=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=u*xe(j2,n)
                                x2d(j,n,j2)=cmplx(cos(p),sin(p))
                        enddo
                enddo
        enddo
C
C       Calculate the y for each atom
        do j=iymin,iymax
                v=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=v*ye(j2,n)
                                y2d(j,n,j2)=cmplx(cos(p),sin(p))
                        enddo
                enddo
        enddo

C     Initialize fatom array      

      jj=0
      do j=1,nrref
        do n=1,natom
                amp2=0
                do j2=1,ine(n)
                        amp2=amp2+x2d(rh(j),n,j2)*y2d(rk(j),n,j2)
                enddo
                if(centro)amp2=dble(amp2)
                jj=jj+1
C               fatom(jj)=amp2*zrod(rl(j),n)
                fatom(jj)=amp2
         enddo
      enddo
      return
      end
