C         XMEAN = ABS (XMEAN) / DBLE (N1 * N2)
C       Let's leave it fixed since anything not 1 is numerical error anyway
         XMEAN = 1.D0 / DBLE (N1 * N2)
C       New constant G constraint
C       Mean = (Number Atoms * Atom Height)/Area
C       Atom Height is essentially constant, independent of size
C       GGMAX is largest G*G, scales as the Area
C       Hence, Multiply by GGMAX to make heights size invariant
C       Reference to 1.1 Angstroms resolution (?)
C
C       Note: might want to use GGMAX*(1.2*1.2) to reference to 1.2 Angstrom resolution
         IF(LGCON)XMEAN=XMEAN*GGMAX*(1.1*1.1)
         XMEANH = XMEAN
C
        FTEMP = XMEAN * 0.5D0
        FTEMPH = FTEMP

C       fs2002 partway atoms-like term -- new default -- removed
C        if ( NOATM ) then
C       Turn off fs2002 stuff
C                ijunk=-1
C               XMEAN = XMEAN / DEXP (1.0D0)
C               FTEMP = FTEMP / DEXP (1.0D0)
C        else if ((.not.centro).and. (.not.lnatm) )THEN
C       Default non Centro-symmetric option -- changed
C                XMEAN = XMEAN / DEXP (1.0D0)
C                FTEMP = FTEMP / DEXP (1.0D0)
C                write(6,*)'Case A ',TMP
C        else if( lnatm ) THEN
C       Case with NATM - make same
        if ( lnatm ) then
                TMP = max(exp(1.0D0),sqrt(FNATM))
                XMEAN = XMEANH / TMP
                FTEMP = FTEMPH / TMP * EXP ( -1.D0)
C                write(6,*)'Case B ',TMP
	endif
         FENTR = FTEMP*EXP ( -1.D0)

C       fs2002 partway atoms-like term -- new default
C        INCLUDE 'EntScales.h'
