        subroutine StatFnorm(ave1,ave2,nref,ntype)
C       Experimental testing for normalization
        include 'controls.h'
        include 'NewStuff.h'
        dimension ave1(*),ave2(*)
	complex sum1(nhk2h),sum2(nhk2h),work
C
C       Initialize random number
        call srand(0)
	ntot=100000
        pi2=2.*acos(-1.)
        do j=1,nref
                ave1(j)=0
                ave2(j)=0
        enddo
        npt=0
        do jj=1,100
	do j=1,ntot
                npt=npt+1
                do k=1,nref
                        sum1(k)=0
                        sum2(k)=0
                enddo
C       Loop over types
		do i1=1,Ntype
C       Loop for number of atoms of each type
                  do i2=1,ncont(i1)
                        a= pi2*rand(1)
                        work=work+cmplx(cos(a),sin(a))
		  enddo
C       Loop over reflections
                   do k=1,nref
                        sum1(k)=sum1(k)+work*ffact(k,i1)
                        sum2(k)=sum2(k)+work*zatom(i1)
                   enddo
                enddo
C
C       Increment averages
                do k=1,nref
		        t1=sum1(k)*conjg(sum1(k))
                        t2=sum2(k)*conjg(sum2(k))
                        ave1(k)=ave1(k)+t1*t2/(t2*t2+1d-10)
                        t1=sqrt(t1)
                        t2=sqrt(t2)
                        ave2(k)=ave2(k)+t1*t2/(t2*t2+1d-10)
                enddo
	enddo
        enddo
C       Renormalize
        do k=1,nref
                ave1(k)=sqrt(ave1(k)/npt)
                ave2(k)=ave2(k)/npt
        enddo
	end
