C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      function goldsearch(ax,bx,cx,est,p1,p2,p3,n,iter)
C      parameter (r=0.61803399,c=1.0-r)
      real*8 p1(*),p2(*),p3(*)
      double precision ax,bx,cx,est,x0,x1,x2,x3,tol
      double precision errval,r,c
      r=0.61803399d0
      c=1.d0-r
      tol=1d-7
      iter=0
      x0=ax
      x3=cx
      if(abs(cx-bx).gt.abs(bx-ax))then
           x1=bx
           x2=bx+c*(cx-bx)
      else
           x2=bx
           x1=bx-c*(bx-ax)
      endif
      f1=errval(p1,p2,p3,n,x1)
      f2=errval(p1,p2,p3,n,x2)
1     if(abs(x3-x0).gt.tol*(abs(x1)+abs(x2)))then
      iter=iter+1
           if(f2.lt.f1)then
                x0=x1
                x1=x2
                x2=r*x1+c*x3
                f0=f1
                f1=f2
                f2=errval(p1,p2,p3,n,x2)
           else
                x3=x2
                x2=x1
                x1=r*x2+c*x0
                f3=f2
                f2=f1
                f1=errval(p1,p2,p3,n,x1)
           endif
      goto 1
      endif
      if(f1.lt.f2)then
           goldsearch=f1
           est=x1
      else
           goldsearch=f2
           est=x2
      endif
      return
      end
      real*8 function errval(f1,f2,f3,n,scale)
      real*8 f1(*),f2(*),f3(*)
      double precision sum,err,scale,sc2
      sum=0.d0
      sc2=scale*scale
      do j=1,n
         err=f1(j)+sc2*f2(j)-scale*f3(j)
         err=abs(err)
         sum=sum+sqrt(err)
      enddo
      errval=sum
C     write(10,*)'Debug ',sum,scale
      return
      end
