C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       FUNCTION TB2D (IH, K, FHK, AHK, AIN, NREF, NCON, CFLAG, SYMM,
     X    NBEAMS, NHK, C, M, IOPT )
C
C
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         dimension fmodel(NHK2),amodel(nhk2)
         INCLUDE 'NewStuff.h'
         INCLUDE 'TModel.h'
         LOGICAL PRINTF,Measured
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
 
         DIMENSION IH(NHK2), K(NHK2), FHK(NHK2), AHK(NHK2), AOLD(NHK2), 
     X   AIN(NHK2)
         DIMENSION FRCALC(NHK2), FICALC(NHK2), ARCALC(NHK2)
         DIMENSION FCALC(NHK2), ACALC(NHK2), AICALC(NHK2)
         DIMENSION WR(NHK2), WI(NHK2)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*)
         COMPLEX*16 W1, W2, RES1, RES2
         DOUBLEPRECISION R1, R2, ASUM, BSUM, BRSUM, BISUM, PI, PI2
         DOUBLEPRECISION SR, SI, FC, ACONV, XR1, XR, ANG, FSQ, ACT
         DOUBLEPRECISION COSAN, SINAN, F, AISUM, ARSUM
         LOGICAL CFLAG
         CHARACTER*4 SYMM
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ 
     X   , /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
         DOUBLEPRECISION Third
         PARAMETER (Third = 1.D0 / 3.D0)
         LOGICAL P3FLAG, LL2, LL3, LL4
         COMPLEX*16 ComplexHalf
         PARAMETER (ComplexHalf = 1.D0/(0.D0,2.D0))
C        Window Rescaling
         Include 'WNorm.h'
         parameter (ACUT=1D-7)
         save fmodel,amodel
C         if(tboth_old)then
C          TB2D = TB2DOLD (IH, K, FHK, AHK, AIN, NREF, NCON, CFLAG, SYMM,
C     X    NBEAMS, NHK, C, M, IOPT )
C          return
C         endif
         CALL CNTRD (SYMM)
         P3FLAG = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
C     Origin for arrays (for consistency with FFT's)
         N1 = M(1)
         N2 = M(2)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1
 
C     Angle conversion scaler
         PI = ASIN (1.D0)
         PI = PI * 2.D0
         PI2 = PI * 2.D0
         ACONV = 180.D0 / PI
 
         IF (PRINTF) WRITE (10, 998) NCON
 
  998    FORMAT('***** START OF ITERATION NUMBER ',I3,2X,'*****'/2X,'H',
     X      2X,'K',4X,'A1',6X,'F1',6X,'A2',6X,'F2',5X,'AOLD',4X,'FOLD',4
     X      X,'ANEW',5X,'FNEW',4X,'Diff')
 
C     Zero estimates for first cycle
         IF (NCON .EQ. 1) THEN
           DO   J=NREF+1,NPAD
             FHK(J) = 0.
             AHK(J) = 0.
             FCALC(J) = 0.
           END DO
         END IF
C     save input values
         DO   J=1,NPAD
           AOLD(J) = AHK(J) * ACONV
           ACALC(J) = 0.
         END DO
 
C     setup in c the symmetry related values
         DO   J=1,M(1)*M(2)
           C(J) = (0., 0.)
         END DO
         FMAX = (-10.)
         II2 = M(1)
         II1 = M(1)
         P3FLAG = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
         IF(modelmode)then
C        ********* Angle definitions for model *********
C         CC18 = CMPLX (0.D0, 1.D0)
         if(.not.gotmodel)then
           call SetupModel(ih,k,l,fmodel,amodel,wts,nref,npad,symm)
           call TMODMASK (IH, K, Fmodel, Amodel, SYMM, C, M )
           gotmodel=.true.
         endif
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FHK(J)
           ANG = AHK(J)
           IF (ISE(1) .EQ. 3 .AND. ABS (AHK(J)) .GT. 1D-4) THEN
C     truncate angle to moduli pi provided that > a cutoff
             IA = NINT (AHK(J) / PI)
             IF (NINT (AHK(J) / PI) .EQ. 0) IA = 2
             ANG = PI * IA
             AHK(J) = PI * IA
           END IF
           IF (IHH .EQ. 0 .AND. IKK .EQ. 0) THEN
             COSAN = 1.
             SINAN = 0.
             F = 1.
           ELSE IF (ABS (ANG) .LT. 1D-4) THEN
             F = 0.
             COSAN = 0.
             SINAN = 0.
           ELSE
             IF (FHK(J) .GT. FMAX) FMAX = FHK(J)
             COSAN = COS (ANG) * FHK(J)
             SINAN = SIN (ANG) * FHK(J)
           END IF
C     Information about symmetry coding of phases
           COSM = FMODEL(J)*COS(AMODEL(J))
           SINM = FMODEL(J)*SIN(AMODEL(J))
           DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
             IF (P3FLAG) THEN
               CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
               IHJJ = IHJJ + N1C
               IKJJ = IKJJ + N2C
             ELSE
               IHJJ = HE(JJ) + N1C
               IKJJ = KE(JJ) + N2C
             END IF
             IND = (IKJJ - 1) * II1 + IHJJ
C            Other is CMPLX( -SINM, COSM)
             IF (ISE(JJ) .LT. 0) THEN
               C(IND) = CMPLX (COSAN+SINM, -SINAN+COSM)
             ELSE IF (ISE(JJ) .EQ. 3) THEN
               C(IND) = CMPLX (COSAN, COSM)
             ELSE IF (ISE(JJ) .EQ. 6) THEN
               C(IND) = CMPLX (-SINM, SINAN)
             ELSE IF (ISE(JJ) .LT. 8) THEN
               C(IND) = CMPLX (COSAN-SINM, SINAN+COSM)
             ELSE IF (ISE(JJ) .LT. 110) THEN
               AWORK = ANG + HE(1) * PI
               C(IND) = F * CMPLX (COS (AWORK), SIN (AWORK))
               AWORK = AMODEL(J) + HE(1) * PI
               C(IND) = C(IND) + FMODEL(J)*CMPLX(-SIN(AWORK),COS(AWORK))
C     X or Y-glide
             ELSE IF (ISE(JJ) .LT. 210) THEN
               C(IND) = -CMPLX (COSAN-SINM, SINAN+COSM)
             ELSE IF (ISE(JJ) .EQ. 300) THEN
               C(IND) = -CMPLX (COSAN+SINM, -SINAN+COSM)
C     p2mg case
             ELSE IF (ISE(JJ) .EQ. 1000) THEN
               C(IND) = -CMPLX (COSAN, COSM)
             ELSE IF (ISE(JJ) .EQ. 2000) THEN
               C(IND) = CMPLX (SINM, -SINAN)
             END IF
           END DO
         END DO
C         write(6,*)'At end of model case'
C
C        ********* Normal Case ********
         else
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FHK(J)
           ANG = AHK(J)
C       Trap ?
           call anglefix(ang,p3flag)
           AHK(J) = ANG
           IF (ISE(1) .EQ. 3 .AND. ABS (ANG) .GT. 1D-4) THEN
C     truncate angle to moduli pi provided that > a cutoff
             IA = NINT (ANG / PI)
             IF (NINT (ANG / PI) .EQ. 0) IA = 2
             ANG = PI * IA
             AHK(J) = PI * IA
             AOLD(J) = AHK(J) * ACONV
           END IF
           IF (IHH .EQ. 0 .AND. IKK .EQ. 0) THEN
             COSAN = 1.D0
             SINAN = 0.D0
             F = 1.D0
             FHK(J) = 1.
             AHK(J) = PI2
             AOLD(J) = 360.
           ELSE IF (ABS (ANG) .LT. ACUT) THEN
             F = 0.D0
             COSAN = 0.D0
             SINAN = 0.D0
           ELSE
             IF (F .GT. FMAX) FMAX = F
             COSAN = COS (ANG) * F
             SINAN = SIN (ANG) * F
           END IF
           DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
             IF (P3FLAG) THEN
               CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
               IHJJ = IHJJ + N1C
               IKJJ = IKJJ + N2C
             ELSE
               IHJJ = HE(JJ) + N1C
               IKJJ = KE(JJ) + N2C
             END IF
             IND = (IKJJ - 1) * II1 + IHJJ
             IF (ISE(JJ) .LT. 0) THEN
               C(IND) = CMPLX (COSAN, -SINAN)
             ELSE IF (ISE(JJ) .EQ. 3) THEN
               C(IND) = CMPLX (COSAN, 0.D0)
             ELSE IF (ISE(JJ) .EQ. 6) THEN
               C(IND) = CMPLX (0.D0, SINAN)
             ELSE IF (ISE(JJ) .LT. 8) THEN
               C(IND) = CMPLX (COSAN, SINAN)
             ELSE IF (ISE(JJ) .LT. 110) THEN
               AWORK = ANG + HE(1) * PI
               C(IND) = F * CMPLX (COS (AWORK), SIN (AWORK))
C     X or Y-glide
             ELSE IF (ISE(JJ) .LT. 210) THEN
               C(IND) = -CMPLX (COSAN, SINAN)
             ELSE IF (ISE(JJ) .EQ. 300) THEN
               C(IND) = -CMPLX (COSAN, -SINAN)
C     p2mg case
             ELSE IF (ISE(JJ) .EQ. 1000) THEN
               C(IND) = -CMPLX (COSAN, 0.D0)
             ELSE IF (ISE(JJ) .EQ. 2000) THEN
               C(IND) = CMPLX (0.D0, -SINAN)
             END IF
           END DO
         END DO
C        ********* End of two cases *********
         endif
 
C     Perform the transformation
C     Negativity constraints via ftune(4)
         X1 = 0.
         XLAM = FTUNE(4) * (1 - EXP (0.5D0 - NCON * 0.5D0))
         X2 = XLAM
C     Model case -- flakey
      if(modelmode)then
C        Setup, then use model
         if(ncon.eq.1)then
         CALL MODELSHARP0(N1,N2,M,C,modelog1)
         else if (.not.modelog2)then
         CALL MODELSHARP(N1,N2,M,C,modelog1)
         else
         CALL MODELSTRONG(N1,N2,M,C,modelog1)
         endif
C         write(6,*)'After modelsharp'
      else
         CALL SHPT2D (N1,N2,M,C,IOPT,X1,X2)
      endif
C         ComplexTwo = CMPLX (0.D0, 2.D0)
 
C     Outer loop for target reflections
         DO 1031 I=1,NPAD
           FRCALC(I) = 0.
           FICALC(I) = 0.
           ARCALC(I) = 0.
           AICALC(I) = 0.
C      if(ih(i).eq.0.and.k(i).eq.0)goto 1031
 
C     Index coding for 2D
C     trap problems with p3 symmetry to give rectangular axes
C           IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           IF( P3FLAG ) THEN
             CALL EQUIV2 (HE,KE,ISE,IH(I),K(I),NE,SYMM)
             W1 = 0.D0
             W2 = 0.D0
             NNN = 0
             DO   JT=1,NE
               IF (ISE(JT) .EQ. 1 .OR. ISE(JT) .EQ. 3) THEN
                 CALL P3EXP (IHJJ,IKJJ,HE(JT),KE(JT))
                 IND1 = (IKJJ + N2C - 1) * N1 + N1C + IHJJ
                 IND2 = (N2C - IKJJ - 1) * N1 - IHJJ + N1C
                 W1 = W1 + C(IND1)
                 W2 = W2 + C(IND2)
                 NNN = NNN + 1
               END IF
             END DO
             W1 = W1 / DBLE (NNN)
             W2 = W2 / DBLE (NNN)
           ELSE
             IND1 = (K(I) + N2C - 1) * N1 + N1C + IH(I)
             IND2 = (N2C - K(I) - 1) * N1 - IH(I) + N1C
             W1 = C(IND1)
             W2 = C(IND2)
           END IF
C
C     Extract two terms from real and imag parts
           RES1 = (W1 + CONJG (W2)) * 0.5D0
           RES2 = (W1 - CONJG (W2)) * ComplexHalf

           ARSUM = RES1
           BRSUM = real(AIMAG (RES1))
           AISUM = RES2
           BISUM = real(AIMAG (RES2))
 
           FSQ = ARSUM * ARSUM + BRSUM * BRSUM
           IF (FSQ .GT. 1D-12) THEN
             FRCALC(I) = SQRT (FSQ)
             ANG = ATAN2 (BRSUM, ARSUM)
             call anglefix ( ang, p3flag )
             ARCALC(I) = ANG
             IF (ARCALC(I) .LT. 1D-2) ARCALC(I) = ARCALC(I) + PI2
           END IF
           FSQ = AISUM * AISUM + BISUM * BISUM
           IF (FSQ .GT. 1D-12) THEN
             FICALC(I) = SQRT (FSQ)
             ANG = ATAN2 (BISUM, AISUM)
             call anglefix ( ang, p3flag )
             AICALC(I) = ANG
             IF (AICALC(I) .LT. 1D-2) AICALC(I) = AICALC(I) + PI2
           END IF
C       Save values for pre-scaling
           WR(J) = COS (ARCALC(J) - AHK(J))
           WI(J) = COS (AICALC(J) - AHK(J))
           IF (AOLD(J) .LT. ACUT) THEN
             WI(J) = 1.
             WR(J) = 1.
           END IF

 1031      CONTINUE

C     These values are important
C     If the predicted value is too large or too small, it is
C     probably incorrect.  If it is too large, reverse it; if
C       it is too small, ignore it.
C       Note: Over-relaxation will take care of inverted signs,
C       but not too large values.
         SCL0 = 0.25D0
         SCU0 = 0.35D0
         SCN0 = 2.
         IF (FSTEST(5) .GT. 0.D0) SCN0 = FSTEST(5)
         IF (FSTEST(6) .GT. 0.D0) SCL0 = FSTEST(6)
         IF (FSTEST(7) .GT. 0.D0) SCU0 = FSTEST(7)
         SDEV = 0.5D0
         IF (FSTEST(8) .GT. 0.D0) SDEV = 1.D0 / FSTEST(8)
         DEV = EXP (NCON * SDEV - SDEV)
         SCU = SCU0 * DEV
         SCL = SCL0 / DEV
         SCN = SCN0 * DEV
         FLOW = 0.
         NDEV = 4
         IF (FSTEST(9) .GT. 1) NDEV = NINT (FSTEST(9))
         IF (NCON .LT. NDEV) FLOW = FMAX * 0.1D0 / DEV
         LL2 = NCON .LT. NDEV
C
         Measured=.true.
         DO   J=1,NPAD
           CALL EQUIV2 (HE,KE,ISE,IH(J),K(J),NE,SYMM)
           FPRED = FHK(J) * SCL
           FPRED2 = FHK(J) * SCU
           FPREDN = FHK(J) * SCN
C          Turn off trapping for unmeasured reflections
           if(J.gt.nref)Measured=.false.
           WR(J) = COS (ARCALC(J) - AHK(J))
           WI(J) = COS (AICALC(J) - AHK(J))
           IF (AOLD(J) .LT. ACUT) THEN
             WI(J) = 1.
             WR(J) = 1.
           END IF
C     Only trap the first three cycles, and measured
           IF (LL2 .and. Measured ) THEN
             IF (FHK(J) .LT. FLOW .AND. abs(AIN(J)) .LT. ACUT) THEN
C     Too small for predicting a new value, set to zero
               FRCALC(J) = 0.
               FICALC(J) = 0.
               ARCALC(J) = 0.
               AICALC(J) = 0.
               WI(J) = 1.
               WR(J) = 1.
             ELSE IF (AOLD(J) .LT. ACUT) THEN
               IF (FRCALC(J) .GT. FPREDN) THEN
C     Over-prediction by a lot, -ve to avoid overconsistency
                 ARCALC(J) = ARCALC(J) + PI
                 AICALC(J) = AICALC(J) + PI
               ELSE IF (FRCALC(J) .LT. FPRED .OR. FRCALC(J) .GT. FPRED2
     X            ) THEN
C     Too small/large for predicting a new value, set to zero
                 FRCALC(J) = 0.
                 ARCALC(J) = 0.
                 FICALC(J) = 0.
                 AICALC(J) = 0.
                 WR(J) = 1.
                 WI(J) = 1.
               END IF
             END IF
           END IF
         END DO
 
C     calculate error terms
C     Entropy
         CALL ERRNT2 (FHK,FRCALC,WR,NREF,IH,K,SCLR,AOLD)
         ER1 = SFERR2
C     Positivity
         CALL ERRNT2 (FHK,FICALC,WI,NREF,IH,K,SCLI,AOLD)
         EI1 = SFERR2
         EC1 = SFERR2
         SCALER = ABS (SCLR)
         SCALEI = ABS (SCLI)
         SFERR2 = ER1
         SFERR1 = EI1

C     Different cases
C         write(10,*)'Debug FTUNE(2) ',ftune(2)
         IF (FTUNE(2) .LT. 1) THEN
C     Equal weighting
           SR = 0.5D0 * (1.D0 + EXP (-(NCON - 1.D0) * Third))
           SI = 0.5D0 * (1.D0 - EXP (-(NCON - 1.D0) * Third))
         ELSE IF (FTUNE(2) .LT. 2) THEN
C     Scale with FOM
           SR = EI1 / (EI1 + ER1)
           SI = ER1 / (EI1 + ER1)
C         ELSE IF (FTUNE(2) .LT. 3) THEN
C     Double up positivity term
C           SR = EI1 * 2.D0 / (EI1 * 2.D0 + ER1)
C           SI = ER1 / (EI1 * 2.D0 + ER1)
         ELSE IF (FTUNE(2) .LT. 4) THEN
C     Consistency checker
           SR = 1.D0
           SI = 0.D0
         ELSE IF (FTUNE(2) .LT. 5) THEN
C     Just positivity
           SR = 0.D0
           SI = 1.D0
         ELSE IF (FTUNE(2) .LT. 6) THEN
C     2/3 Entropy, 1/3 Positivity, varying
           SR = (2.D0 + EXP (-(NCON - 1.D0) * Third)) *Third
           SI = ABS (SR - 1.D0)
         ELSE IF (FTUNE(2) .LT. 7) THEN
C     2/3 Entropy, 1/3 Positivity, fixed
           SI = Third
           SR = 1.D0 - Third
         ELSE IF (FTUNE(2) .LT. 8) THEN
C     0.5 Entropy, 0.5 Positivity
           SI = 0.25D0 + 0.25D0 * (1.D0 - EXP (-(NCON - 1.D0) * Third))
           SR = 1.D0 - SI
C        ELSE IF (FTUNE(2) .LT. 9) THEN
C           SR = SCALER * 0.5D0
C           SI = 1.D0 - SR
C         ELSE IF (FTUNE(2) .LT. 10) THEN
C     Make positivity 1
C           SR = SCALER
C           SI = 1.D0 - SR
         ELSE
C     Default
C     2/3 Entropy, 1/3 Positivity, varying
           SR = (2.D0 + EXP (-(NCON - 1.D0) * Third)) *Third
           SI = ABS (SR - 1.D0)
         END IF
 
         XR1 = ABS (FTUNE(1))
         XR3 = FTUNE(3)
C     Automatic case, maybe not trustworthy
         IF (FTUNE(3) .GT. 10.D0) XR3 = FTUNE(3) - 10.D0
         IF (XR3 .LT. -0.01D0) XR3 = 0.5D0
         IF (FTUNE(1) .GT. 99.D0) THEN
C
           XX = ABS (FTUNE(3)) * (1 - EXP (-(NCON - 1.D0) * Third))
           XX = 1 + XX
           AT = XX + SR * (1 - XX)
           BT = XX * (2 - SR)
           IF (AT .LT. 1D-2) THEN
             XR1 = 1.D0
           ELSE
             XR1 = BT / AT
           END IF
           IF (XR1 .GT. 1.95D0) XR1 = 1.95D0
         ELSE
           IF (XR1 .GT. 10.D0) THEN
             XR1 = XR1 + INT (XR1 * 0.1D0) * (-10)
             IF (XR1 .GT. 10.D0) XR1 = XR1 - 10
             IF (XR1 .LT. 0.D0) XR1 = 10.D0 + XR1
             T=(1.D0 - EXP (-(NCON - 1.D0) / XR1))
             XR1 = 1 + XR3 * T
             IF (XR1 .LT. 0) XR1 = 0.1D0
           END IF
         END IF
         XR = XR1 - 1.D0
C         write(10,*)'Debug 3',XR,XR1
         S1 = 0.
         S3 = 0.
         SANG3 = 0.
         LL3 = .NOT.CFLAG

         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
C     if(ihh.eq.0.and.ikk.eq.0)goto 1051
C     Rescaling of calculated
           FRCALC(J) = FRCALC(J) * SCALER
           FICALC(J) = FICALC(J) * SCALEI
 
C     Combine the two for new values
           R1 = FRCALC(J) * COS (ARCALC(J)) * SR + FICALC(J) * COS (
     X        AICALC(J)) * SI
           R2 = FRCALC(J) * SIN (ARCALC(J)) * SR + FICALC(J) * SIN (
     X        AICALC(J)) * SI
           FC = R1 * R1 + R2 * R2
           IF (FC .GT. 1D-12) THEN
             FCALC(J) = SQRT (FC)
             ANG = ATAN2 (R2, R1)
             call anglefix(ang,p3flag)
             ACALC(J) = ANG 
C            ACALC(J) = ATAN2 (R2, R1)
             IF (ACALC(J) .LT. 1D-2) ACALC(J) = ACALC(J) + PI2
           ELSE
             FC = 0
             FCALC(J) = 0.
             ACALC(J) = 0.
           END IF

C       Recale here ?
           WR(J) = COS (ACALC(J) - AHK(J))
           IF (AOLD(J) .LT. ACUT) THEN
             WR(J) = 1.
           END IF
        ENDDO
         CALL ERRNT2 (FHK,FCALC,WR,NREF,IH,K,SCLT,AOLD)

         SCALET = ABS (SCLT)
C         write(6,*)'Combination Scale',sclt
         SFERR2 = ER1
         SFERR1 = EI1
C
C        Parameters for Luke-Burke-Lyon method

        DO J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           FCALC(J) = FCALC(J)*SCALET
           FC = FCALC(J)
           FCNEW = FC
 
C     Set new values
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
C     Fixed beam ?
           IF (ABS (AIN(J)) .GT. 1D-3 .AND. LL3) THEN
             AHK(J) = AIN(J) / ACONV
             IF (ISE(1) .EQ. 3) THEN
C           truncate angle to moduli pi provided that > a cutoff
               IA = NINT (AHK(J) / PI)
               IF (IA .EQ. 0) IA = 2
               AHK(J) = PI * IA
             END IF
           ELSE IF (AOLD(J) .GT. 1D-2) THEN
C     Beam was set previously
             ANG = AHK(J)
             call anglefix(ang,p3flag)
             TR1 = FHK(J) * COS (ANG)
             TR2 = FHK(J) * SIN (ANG)
             R1 = FCALC(J) * COS (ACALC(J)) * XR1 - TR1 * XR
             R2 = FCALC(J) * SIN (ACALC(J)) * XR1 - TR2 * XR

             IF ((ABS (R1) .LT. 1D-5) .AND. (ABS (R2) .LT. 1D-5)) THEN
               AHK(J) = 0.
               FCNEW = 0.
             ELSE
               FCNEW = sqrt( R1*R1+R2*R2)
               ANG = ATAN2 (R2, R1)
               call anglefix(ang,p3flag)
               AHK(J) = ANG
               IF (AHK(J) .LT. 1D-2) AHK(J) = AHK(J) + PI2
C              Symmetry fix
               IF (ISE(1) .EQ. 3) THEN
C              truncate angle to moduli pi provided that > a cutoff
                 IA = NINT (AHK(J) / PI)
                 IF (IA .EQ. 0) IA = 2
                 AHK(J) = PI * IA
               END IF
             END IF
           ELSE IF (FC .GT. 1D-12) THEN
C     Not set before
             ANG = ACALC(J)
             call anglefix(ang,p3flag)
             AHK(J) = ANG
             IF (AHK(J) .LT. 1D-2) AHK(J) = AHK(J) + PI2
C           Symmetry fix
             IF (ISE(1) .EQ. 3) THEN
C           truncate angle to moduli pi provided that > a cutoff
               IA = NINT (AHK(J) / PI)
               IF (IA .EQ. 0) IA = 2
               AHK(J) = PI * IA
             END IF
           END IF
 
           AR = ARCALC(J) * ACONV
           AI = AICALC(J) * ACONV
           AC = AHK(J) * ACONV
C     Reduce difference to smallest value with multivaluedness
           DELTA = AC - AOLD(J)
           DELTA1 = ABS (360 + DELTA)
           DELTA2 = ABS (DELTA - 360)
           DELTA = ABS (DELTA)
           IF (DELTA .LT. DELTA1 .AND. DELTA .LT. DELTA2) THEN
             DEL = AC - AOLD(J)
           ELSE IF (DELTA1 .LT. DELTA2) THEN
             DEL = 360.D0 + AC - AOLD(J)
           ELSE
             DEL = AC - 360.D0 - AOLD(J)
           END IF
           IF (ABS (ABS (DEL) - 180.D0) .LT. 1D-3) DEL = 180.
C     Trap undefined to 360
           IF (ABS (AOLD(J)) .LT. ACUT .AND. ABS (AC - 360) .LT. 1D-3)
     X        DEL = 360.
 
C     some sums for monitoring
           S1 = S1 + FHK(J)
           S3 = S3 + FHK(J) * DEL * DEL
 
C     Take all values for drift
           SANG3 = SANG3 + DEL * DEL
 
           IF (PRINTF) THEN
           IF(J.eq.NREF+1)WRITE (10, 1035)
             WRITE (10, 4) IH(J), K(J), AR, FRCALC(J), AI, FICALC(J),
     X          AOLD(J), FHK(J), AC, FCALC(J), DEL
    4        FORMAT(2I3,4(F8.3,F8.4),F8.3,F9.4)
           END IF
C          Set unmeasured
           if(J .GT. NREF)FHK(J)=FCNEW
         END DO
 1035      FORMAT('**** Estimated Reflections')
C     X        /2X,'H',2X,'K',5X,'Fnew',5
C     X        X,'Anew',5X,'Fest',5X,'Aest',5X,'Fold',5X,'Aold',5X,'DAng'
C     X        ,5X,'DFHK')

         IF (MAX0 (NREF, 0) .GT. 0) THEN
           TB2D = SQRT (SANG3 / MAX0 (NREF, 0))
         ELSE
           TB2D = 10.
         END IF
         IF (S3 .LT. 1D-5) THEN
           ANGERR = 0.
         ELSE
           ANGERR = SQRT (S3 / S1)
         END IF
 
         IF (PRINTF) THEN
           WRITE (10, 901) ' Phase Relaxation: ', XR1, ' Positivity ', 1
     X         + XLAM
           WRITE (10, 901) ' Scales of Entropy:', SCLR, ' Positivity:',
     X        SCLI,' Combination ',Scalet
           WRITE (10, 901) ' Weight of Entropy:', SR, ' Positivity:', SI
  901      FORMAT(A,F10.5,A,F10.5,A,F10.5)
         END IF
C       Test adding an RMS rescale for unknown reflections
C        IF(PATTC.GT.-5.)THEN
        DO I=1,NREF
                WI(I)=1
        ENDDO
C        ENDIF
        SFERR2_USE = SFERR2
        CALL ERRNT2 (FHK,FCALC,WI,NREF,IH,K,SCALE,AOLD)
        SFERR2 = SFERR2_USE
        if(printf)write(10,*)'Unmeasured Rescale ',scale
        DO I=NREF+1,NPAD
                FHK(I)=FHK(I)*SCALE
                FCALC(I)=FCALC(I)*SCALE
        ENDDO
         RETURN
       END
C
        subroutine anglefix(ang,p3flag)
        logical p3flag,init
        real*8 ang,f120,f240,pi,pi2
C
        data init/.true./
        save init,f120,f240,pi,pi2
        if(init)then
                pi=acos(-1.0d0)
                pi2=2.d0*pi
                f120=pi*2.d0/3.d0
                f240=pi*4.d0/3.d0
                init=.false.
        endif
        ijunk=-1
        if(ijunk.lt.0)return
        IF(P3FLAG)then
C       Trap angles very close to 120,240
        if(abs(ang-f120).lt.1d-4)ang=f120
        if(abs(ang-f240).lt.1d-4)ang=f240
        endif
C       Fix 180,360
        if(abs(ang-pi).lt.1d-4)ang=pi
        if(abs(ang-pi2).lt.1d-4)ang=pi2
        return
        end
C       include 'tboth2Dold.f'
