C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
C
C
C       Sort the seeds into order, returning top
      subroutine sortseed(x,y,z,itype,fgot,nat,errg,zatom)
      dimension x(*),y(*),itype(*),fgot(*),z(*)
      dimension work(200),iwork(200),zatom(*)
      character*4 symm,sftemp
        include 'SeedDef.h'
C        dimension xb(Nsatm1),yb(Nsatm1),zb(Nsatm1),ib(Nsatm1)
        dimension xw(Nsatm1,100),yw(Nsatm1,100),zw(Nsatm1,100)
        dimension iw(Nsatm1,100),nw(100),fomw(100)
        logical there
        include 'Sfacts.h'
C
C       Go through the seeds and compare against current
C       First, purge the seeds
        if(nsd.eq.0)return
        do j=1,nsd
           work(j)=fomseed(j)
           iwork(j)=j
C           write(10,*)j,work(j)
        enddo
        call sortag(work,nsd,iwork)
        inquire(file='search.lst',exist=there)
        if(there)call unlink('search.lst',iostat)
        open(unit=13,file='search.lst')
        nsd=min(100,nsd)
        do ii=1,nsd
                i=iwork(ii)
                natt=ntsd(i)
                write(13,30)'REM Test ',ii,' G-of-Fit ',work(ii),
     X          fomseed(i)
                write(10,30)'REM Seed ',ii,' G-of-Fit ',work(ii),
     X          fomseed(i)
30              format(a,i3,a,2f10.4,4f12.7)
                do j=1,natt
                        xw(j,ii)=xsd(j,i)
                        yw(j,ii)=ysd(j,i)
                        zw(j,ii)=zsd(j,i)
                        iw(j,ii)=isd(j,i)
                        itmp=iw(j,ii)
                        sftemp=sfacts(itmp)
                        isf2=2
                        if(sftemp(2:2).eq.' ')isf2=1
                        if(j.lt.10)then
                          write(13,101)sftemp(1:isf2),j,xw(j,ii),
     1                    yw(j,ii),zw(j,ii),zatom(itmp),0.05
                        else
                          write(13,111)sftemp(1:isf2),j,xw(j,ii),
     1                    yw(j,ii),zw(j,ii),zatom(itmp),0.05
                        endif
                enddo
                nw(ii)=ntsd(i)
                fomw(ii)=fomseed(i)
        enddo

        do i=1,nsd
                natt=nw(i)
                do j=1,natt
                        xsd(j,i)=xw(j,i)
                        ysd(j,i)=yw(j,i)
                        zsd(j,i)=zw(j,i)
                        isd(j,i)=iw(j,i)
                enddo
                ntsd(i)=nw(i)
                fomseed(i)=fomw(i)
        enddo
        close(unit=13)
        nat=ntsd(1)
        errg=fomseed(1)
        do j=1,nat
                x(j)=xsd(j,1)
                y(j)=ysd(j,1)
                z(j)=zsd(j,1)
                itype(j)=isd(j,1)
                fgot(j)=zatom(itype(j))
        enddo
        return
101     format(a,i1,'  1 ',4f10.6,2x,2f8.3)
111     format(a,i2,' 1 ',4f10.6,2x,2f8.3)
        end
C
C     Just sort seeds into order, returning nothing
      subroutine seedsort2(ijunk)
      dimension work(200),iwork(200)
        include 'SeedDef.h'
        dimension xw(Nsatm1,100),yw(Nsatm1,100),zw(Nsatm1,100)
        dimension iw(Nsatm1,100),nw(100),fomw(100)
C
        if(nsd.eq.0)return
        do j=1,nsd
           work(j)=fomseed(j)
           iwork(j)=j
        enddo
        call sortag(work,nsd,iwork)
        nsd=min(100,nsd)
        do ii=1,nsd
                i=iwork(ii)
                natt=ntsd(i)
                do j=1,natt
                        xw(j,ii)=xsd(j,i)
                        yw(j,ii)=ysd(j,i)
                        zw(j,ii)=zsd(j,i)
                        iw(j,ii)=isd(j,i)
                        itmp=iw(j,ii)
                enddo
                nw(ii)=ntsd(i)
                fomw(ii)=fomseed(i)
        enddo

        do i=1,nsd
                natt=nw(i)
                do j=1,natt
                        xsd(j,i)=xw(j,i)
                        ysd(j,i)=yw(j,i)
                        zsd(j,i)=zw(j,i)
                        isd(j,i)=iw(j,i)
                enddo
                ntsd(i)=nw(i)
                fomseed(i)=fomw(i)
        enddo
        return
        end
