      subroutine fprint(NSET,NRNG)
C
C     Printout
C     Input
C            F          Array of measurements
C            NSET       Number of Sets
C            NRNG       Range to scan
C            SCL        Scaling
C
C
      implicit real*8 (a-h,o-z)
      include 'msizes.h'
      character*17 vals(nsmax),vwts(nsmax),blank
      blank='                '
C
      DO n=1,nset
         WSET(N)=0
      enddo
      open(unit=13,file='RawData.txt')
      write(13,*)'Raw Values, rescale with Biweight for each'
C      open(unit=14,file='RawWts.txt')
      do j=-Nxmax,Nxmax
           do k=-Nymax,Nymax
              N=0
              do i=1,NSET
                vals(i)=blank
                vwts(i)=blank
                if( F(i,j,k).gt.-1)then
                        N=N+1
                        write(vals(i),10)F(i,j,k)*scl(i),wt(i,j,k)
C                       write(vwts(i),11)wt(i,j,k)
10                      format(F8.2,F7.2,' |')
11                      format(F8.5)
                endif
              enddo
C             Robust estimation if there are enough pts
              IF(N.GE.4)THEN
                   write(13,100)j,k,(vals(i),i=1,nset)
C                   write(14,100)j,k,(vwts(i),i=1,nset)
100                format(2i4,' |',20a)
              endif
           enddo
      enddo
      return
      end
