        implicit real*8 (a-h,o-z)
        include 'msizes.h'
        character*50 filen(NSMAX),ftmp,argin
        character*80 argfile
        dimension SCOLD(NSMAX),SC2(NSMAX)
        character*4 symm
        logical test1,test2,test3,test4,show,troot,rt3,rt5
        logical atend
        save /pass1/,/pass2/,/pass3/
        data  troot/.false./, atend/.true./
        real*4 X(NSMAX),X0(NSMAX),FMIN
C        real*8 MACHEP,H0, feval,X(20)
        external feval, feval2
        logical init, centered , biter
        common /ceval/berr,power,init
C
C       Workspace
C       Output
        integer Hout(5000),Kout(5000),rmode,NNPT(5000)
        dimension Fout(5000),Eout(5000), startscl(NSMAX),SOUT(5000)
        dimension XHOLD(50,50),XVHOLD(50),BNPT(5000)
        real*4  WORK(5000)
        integer IWORK(5000)
C
        biter = .false.
        ntries=-1
        ipivot=0
        call getarg(1,argin)
        if((argin(1:2).eq.'-h').or.(argin(1:6).eq.'--help'))goto 9001
C
C       Control file
        if(argin(1:2).eq.'-f')then
             call getarg(2,argfile)
             if(argfile(1:1).ne.' ')then
                open(unit=10,file=argfile)
             else
                open(unit=10,file='DataControl')
             endif
        else
            open(unit=10,file='DataControl')
        endif
C       Number of sets, range (should be 2D), bulk lattice
        read(10,1,err=990,end=990)argfile
        lath=2000
        latk=2000
        read(argfile,*,err=991,end=991)NSET
        read(argfile,*,err=220,end=220)Nset,LATH,LATK
220     if(lath.lt.1)lath=2000
        if(latk.lt.1)latk=2000
C        write(6,*)'Check ',lath,latk
        read(10,*)alat,blat,gamma,resolution
C       Convert to reciprocal
        gamma=180-gamma
C       Convert to radians
        pi2=asin(1.0d0)
        gamma=gamma*pi2/90
C       Reciprocal space units
C       A.a = B.b = 1 ; A.b=B.a=0
C       A.a = |A||a|cos(pi/2-gamma)
        arec=1.D0/(cos(pi2-gamma)*alat)
        brec=1.D0/(cos(pi2-gamma)*blat)
        aar=arec*arec
        bbr=brec*brec
        abr=2.*cos(gamma)*arec*brec
        write(6,*)'Reciprocal cell units ',1.D0/arec,1.D0/brec,
     1  gamma,cos(gamma)
C        write(6,*)'Trap ',aar,bbr,abr,resolution
        read(10,1,err=992,end=992)symm
        centered=.false.
        if(symm(1:1) .eq. 'c')centered=.true.
        istr=lnblnk(symm)
C       UG, we may have an issue with the intrinsics here (semper hacks)
C       Might need LEN_TRIM on some systems (g95, ifort)
C       write(*,*)'Trap ',istr
        if(istr .eq. 2)symm(3:4)='  '
        NS2=NSET-1
        NSIZE=NRNG
        do n=1,nset
           read(10,1,err=993,end=993)filen(n)
           wset(n)=0
        enddo
C       A value to turn off the checking
        if((lath.lt.2).and.(latk.lt.2))then
                lat=2000
                lath=2000
                latk=2000
        endif
C       Anything else ?
        rmode=7
        show=.false.
        rt3=.false.
        rt5=.false.
        atend=.true.
C       Value for normal errors -- not with current code!
        biscale=4.685
C       Value which seems better for NU data anyway
        biscale=2.0
        poweruse=-1.D0
119     read(10,1,err=99,end=99)ftmp

        if(ftmp(1:4).eq.'SHOW')then
                show=.true.
        else if(ftmp(1:5).eq.'INTEN')then
                troot=.true.
        else if(ftmp(1:5).eq.'POWER')then
                read(ftmp(6:50),*)poweruse
        else if(ftmp(1:6).eq.'CENSOR')then
                read(ftmp(7:50),*)biscale
                if(biscale .gt. 6)biscale=2.0
                if(biscale .lt. 1)biscale=2.0
        else if(ftmp(1:3).eq.'rt3')then
                rt3=.true.
                lath=2000
                latk=2000
                write(6,*)'This is a Rt3xRt3-R30 System'
        else if(ftmp(1:3).eq.'rt5')then
                rt5=.true.
                lath=2000
                latk=2000
                write(6,*)'This is a Rt5xRt5-R26 System'
        else if(ftmp(1:5).eq.'PINIT')then
                atend=.false.
                write(6,*)'Purging of bulk spots at start'
        else if(ftmp(1:5).eq.'BITER')then
                biter=.true.
                rmode=9
                biscale=4.685
                read(ftmp(6:50),*,err=101,end=101)bw
                biscale=bw
101             continue
                write(6,*)'Iterative biweights used'
        else if(ftmp(1:5).eq.'BWEIG')then
                biter=.true.
                rmode=10
                biscale=4.685
                read(ftmp(6:50),*,err=102,end=102)bw
                biscale=bw
102             continue
                write(6,*)'Iterative biweights used with scale'
        endif
        goto 119
99      continue
        if(atend)write(6,*)'Purging of bulk spots at end'
C
C       Find the maximum relevant ranges
        nxmax=-1
        nymax=-1
        rrmax=-1
C       write(6,*)'Lpars ',aar,bbr,abr
C       write(6,*)'resolution ',resolution,nrmax        
        do j=-nrmax,nrmax
           do k=-nrmax,nrmax
              rr=j*j*aar+k*k*bbr+j*k*abr
              if(rr.gt.1d-8)then
                rr=sqrt(rr)
                if((1.D0/rr) .gt. resolution)then
C                  write(6,*)rr,j,k
                   rad(j,k)=rr
                   if(abs(j).gt.nxmax)nxmax=abs(j)
                   if(abs(k).gt.nymax)nymax=abs(k)
                   if(rr.gt.rrmax)rrmax=rr
                endif
              endif
           enddo
        enddo
        write(6,*)'Maximum range for x ',-nxmax,
     1  ' to ',nxmax
        if(lath.lt.200)
     1     write(6,*)'Skipping multiples of ',lath,' along x'
        write(6,*)'Maximum range for y ',-nymax,
     1  ' to ',nymax
        if(latk.lt.200)
     1     write(6,*)'Skipping multiples of ',latk,' along y'
        nxmax=min(nxmax+1,nrmax)
        nymax=min(nymax+1,nrmax)
        nrng=max(nxmax,nymax)
        nsize=nrng
        do i=1,NSMAX
        do j=-nrmax,nrmax
           do k=-nrmax,nrmax
              F(i,j,k)=-99
              WT(i,j,k)=1
           enddo
        enddo
        enddo
C       write(6,*)'Hello 1'
C       Read in the data
        ixbig=-1
        iybig=-1
        do i=1,NSET
           open(unit=10,file=filen(i))
           read(10,1)argfile
1          format(a)
C          Is the first line a title?
           read(argfile,*,err=3001,end=3001)i1,i2,i3,amp
C          I guess it is
           rewind(unit=10)
3001       continue
           do jj=1,9999
              read(10,*,err=10,end=10)i1,i2,i3,amp
              if(abs(i1).gt.ixbig)ixbig=i1
              if(abs(i2).gt.iybig)iybig=i2
              rr=i1*i1*aar+i2*i2*bbr+i1*i2*abr
C             In case 0,0 is there
              if(rr.gt.1d-8)then
                rr=sqrt(rr)
              else
                rr=1d-5
              endif
C              write(77,*)i1,i2,1./rr,amp
              if(amp.lt.1d-8)amp=0
              if((amp.lt.1d-8).and.(troot))amp=sqrt(amp)
C             Check if h,k is within specified resolution
              test1=((1.D0/rr).ge.resolution)
C             Check if h,k are on the (rectangular) bulk lattice              
              test2=(lath*(i1/lath).ne.i1).or.(latk*(i2/latk).ne.i2)
C             Check if h,k are too far away from origin              
              test3=(abs(i1).lt.nrmax).and.(abs(i2).lt.nrmax)
              test4=.true.
C             Remove 1x1 reflections for a rt3 system              
              if(rt3)then
                do nn=-nrmax,nrmax
                  if((i1+3*nn).eq.i2)test4=.false.
                enddo
              endif
C             Remove 1x1 reflections for a rt5 system  
              if(rt5)then
                do nn=-nrmax,nrmax
                  if(mod(i1,2).eq.0.and.i2.eq.(i1/2+5*nn))test4=.false.
                  if(i1.eq.0.and.i2.eq.(i1/2+5*nn))test4=.false. 
C                 if(abs(mod(i1,2)).eq.1.and.i2.eq.(i1-1)/2+3+5*nn)test4=.false.                  
                  if(abs(mod(i1,2)).eq.1)then
                    if(i2.eq.(i1-1)/2+3+5*nn)test4=.false. 
                  endif                   
                enddo
              endif
C             Skip inappropriate reflections for centered cases
              if(centered)then
                ii=i1+i2
                if(2*(ii/2) .ne. ii)test3=.false.
              endif
C             Over-ride purges if atend is set
              if(atend)then
                           test2=.true.
                           test4=.true.
              endif
C             Accept the data point if above conditions are met                 
              if(test1 .and. test2 .and. test3 .and. test4)then
                 F(i,i1,i2)=amp
              endif
           enddo
10      continue
        enddo
C
C       write(6,*)'Hello 2 ',ipivot
C       *********** Initial scaling ***************
C       Set the pivot point if not already set
        if(ipivot.eq.0)IPIVOT=NSET/2
C       Try with 4 points down
        IM=min(NSET,3)
        DO J=IM,2,-1
           MINPTS=J
           call  noweight(NSET,NRNG,MINPTS,IPIVOT,IFAIL)
           if(ifail.eq.0)goto 20
        enddo
        write(6,*)'Cannot scale data, no common points for all sets'
        if(NSET.EQ.1)then
                scl(1)=1
                goto 1000
        endif
        stop
20      continue
C       write(6,*)'Hello 3'
        BIFACT=9
        write(6,*)'Scaling when there are more than ',MINPTS, 
     1  ' common points'
C        write(6,*)'Pivoting about set ',ipivot,' ',filen(ipivot)
        snorm=scl(1)
        do j=1,NSET
           write(6,*)'Square Scales',j,scl(j)/snorm
           scold(j)=scl(j)
           SC2(j)=scl(j)
           startscl(j)=scl(j)/snorm
        enddo
        N=NSET-1
C       write(6,*)N
        do j=1,NSET-1
                X0(J)=startscl(J+1)
        enddo
           if(symm(1:2).eq.'p6'.or.symm(1:2).eq.'p4' .or.
     X     symm(1:2).eq.'p3')then
              ixbig=max(ixbig,iybig)
              iybig=ixbig
           endif
        write(6,*)' '
        if(poweruse .lt. 0.0)then
           write(6,*)'Scanning to look for appropriate fit power'
           ip=0
           do power=2.0,0.99,-0.05
              ip=ip+1
              call UNCMIN (N,X0,FEVAL,X,FMIN,INFO,WORK,5000)
              write(6,66)power,fmin
66            format('Power for fit ',F8.2,' Residue ',F10.4)
              do j=1,NSET-1
                 X0(J)=X(j)
                 XHOLD(J,IP)=X(J)
              enddo
              XVHOLD(IP)=power
           enddo
           write(6,67)
67         format('If there is a minimum in the residual, use this'/
     1            'Otherwise, a value of 1.0 is suggested'
     2            /'Please enter a power for the fitting _' ,$)
           read(5,*)power
           diff=1e6
           do np=1,ip
              dd=abs(power-xvhold(np))
              if(dd .lt. diff)then
                    diff=dd
                    do j=1,nset-1
                       X0(j)=XHOLD(J,NP)
                    enddo
              endif
           enddo
        else
           write(6,*)'Adjust fit parameters slowly ...'
           do power=2.0,poweruse,-0.15
              call UNCMIN (N,X0,FEVAL,X,FMIN,INFO,WORK,5000)
              do j=1,NSET-1
                 X0(J)=X(j)
              enddo
           enddo
           power=poweruse
        endif
        call UNCMIN (N,X0,FEVAL,X,FMIN,INFO,WORK,5000)
        write(6,66)power,fmin
        SCL(1)=snorm
        do J=2,NSET
           SCL(J)=X(J-1)*SNORM
        ENDDO
C        do j=1,NSET
C           write(6,*)'Robust Scales',j,scl(j)/snorm
C           scold(j)=scl(j)
C           SC2(j)=scl(j)
C           startscl(j)=scl(j)/snorm
C        enddo

C       Rescale to 1st
1000    snorm=scl(1)
C        write(6,663)
C663     format('Done')
        do j=1,nset
           scl(j)=scl(j)*10.d0/snorm
           change = abs(0.1D0*scl(j)-startscl(j))/startscl(j)
           if(change .gt. 0.25)then
               write(6,*)'Robust Scale ',j,SCL(J)*0.1d0,
     X         ' *** WARNING, this changed a lot'
           else
               write(6,*)'Final Scale ',j,SCL(J)*0.1D0
           endif
        enddo

        call frobust(FOUT,EOUT,HOUT,KOUT,NOUT,SOUT,NNPT,BNPT,NSET,
     X  NRNG,SYMM,rmode,biscale)
        call fprint(nset,nrng)
        open(unit=17,file='Nrobust.hkl')
        open(unit=18,file='Nfull.hkl')
        open(unit=19,file='Bulk.hkl')
C       Sort the data
        rmax=-1
        DO N=1,NOUT
             iwork(N)=N
             I1=hout(n)
             I2=kout(n)
             rr=i1*i1*aar+i2*i2*bbr+i1*i2*abr
             work(N)=rr
             if(rr .gt. rmax)rmax=rr
        ENDDO
        DO N=1,NOUT
             work(N)=work(N)/rmax
        ENDDO
        call sortag(work,nout,iwork)
        R1est=0
        Rsum = 0
        rlow = 1.0
        write(6,*)' '
        DO Nsort=1,NOUT
             N = iwork(Nsort)
             I1=hout(n)
             I2=kout(n)
             rr=i1*i1*aar+i2*i2*bbr+i1*i2*abr
             rr=sqrt(rr)
C             Check if h,k are on the (rectangular) bulk lattice

              test4=.true.
C             Remove 1x1 reflections for a rt3 system
              if(rt3)then
                do nn=-nrmax,nrmax
                  if((i1+3*nn).eq.i2)test4=.false.
                enddo
C               test2=test4
C             Remove 1x1 reflections for a rt5 system
              else if(rt5)then
                do nn=-nrmax,nrmax
                  if(mod(i1,2).eq.0.and.i2.eq.(i1/2+5*nn))test4=.false.
                  if(i1.eq.0.and.i2.eq.(i1/2+5*nn))test4=.false.
C                 if(abs(mod(i1,2)).eq.1.and.i2.eq.(i1-1)/2+3+5*nn)test4=.false.
                  if(abs(mod(i1,2)).eq.1)then
                    if(i2.eq.(i1-1)/2+3+5*nn)test4=.false.
                  endif
                enddo
C               test2=test4
              else
                test4=((lath*(I1/lath).ne.I1).or.(latk*(I2/latk).ne.I2))
              endif

             if (.not.test4)then
                write(19,172)HOUT(N),KOUT(N),0,FOUT(N),EOUT(N),NNPT(N)
     X           ,BNPT(N),SOUT(N),rr
             else
                write(17,171)HOUT(N),KOUT(N),0,FOUT(N),EOUT(N),rr
                write(18,172)HOUT(N),KOUT(N),0,FOUT(N),EOUT(N),NNPT(N)
     X           ,BNPT(N),SOUT(N),rr
                 if(BNPT(N).LT.0.5*NNPT(N))
     X               write(6,*)'Warning: ',hout(n),kout(n),' has too ',
     X               'few point -- increase biweight scaling term'
                 rsum=rsum+fout(n)
                 r1est=r1est+eout(n)
             endif
             if(1./rr.le.rlow)then
                write(6,173)rlow,r1est/rsum
                rlow=rlow-0.1
173             format(' R1 Estimate to resolution of ',F5.1,
     X          ' is ',F6.4)
             endif
171          format(3i4,F15.9,' 0 ',F15.9,'   G ',F12.6)
172          format(3i4,2F15.9,'   PTS ',i4,'   Biweight ',F8.3,
     X        '   Mean Err ',F12.6,'   G  ',2F12.6)
        enddo
        write(6,*)' '
        write(6,*)'Estimated R1 value for all beams ',r1est/rsum
        write(6,*)' '
        write(6,*)'WARNING: No computer code is foolproof'
        write(6,*)'Check the results'
        write(6,*)'Average.txt has robust averaging for equivalent'
        write(6,*)'AllData.hkl has robust equivalents on lines'
        write(6,*)'RawData.txt has raw, rescaled values'
        write(6,*)'RawWts.txt  has the weights for RawData.txt'
        write(6,*)'Nrobust.hkl is outputvalues, Nfull.hkl',
     1  ' for refinement'
        write(6,*)'Consider changing CENSOR, currently ',biscale
C         write(6,*)NSET
        call exit(0)
990     write(6,*)'Error reading from control file'
        stop
991     write(6,*)'Error reading Nset, Nrng, Lat'
        stop
992     write(6,*)'Error reading symmetry'
        stop
993     write(6,*)'Error reading file name ',n
        stop
9001    write(6,9010)
9010    format('Syntax: mergehkl -h (--help) -f XYZ'/
     X   'Code to merge datasets with more than 4 common measurements'/
     1   'Requires a file which can be specified by -f, which '/
     2   'defaults to DataControl'//
     3   'The format of this file is:'//
     4   'NSets SkipH, SkipK   (Free Format, integers)'/
     5   '      NSets  Number of different micrographs'/
     6   '      SkipH  Values along H to skip, e.g. for a surface'/
     7   '      SkipK  Values along K to skip, e.g. for a surface'/
     8   '      If SkipH, SkipK are 0 or absent, this is not used'/)
        write(6,9020)
9020    format(
     1   'A B Gamma Resolution (Free Format, angle in degrees)'/
     2   '      Two dimensional unit cell parameters'/
     3   '      Resolution in Angstroms controls how far out averaging'/
     4   '      is performed'//
     5   'symmetry              (4 characters, lower case)'/
     6   '      Two dimensional space group for averaging'//
     7   'File1                 (File name 1)'/
     8   '      Has H, K, L F(h,k,l) in order (L is ignored)'/
     9   '      Repeat this Nsets times')
        write(6,9030)
9030    format(/
     1   'OPTIONS               (characters, upper case)'/
     2   '      This can be any combination of, on seperate lines'/
     3   '      CENSOR X Use with a number for X, to trim outliers'/
     4   '               Weights (1-[2*Err/(Range*Censor)]**2)**2'/
     5   '               With default of 2, ends have weight=0.25'/ 
     4   '               Change with care (experiment)' /
     X   '      BITER  X Does an iterative autoscaling biweight'/
     X   '               with CENSOR=X, default 4.685 if X is omitted'/
     X   '      BWEIG  X Similar to BITER, but adds an approximate '/
     X   '               term for the relative scaling of the data'/
     9   '      INTEN    Initial data is I''s, not F''s that edm uses'/
     X   '               Use this only for importing data'/
     X   '               Note: output will be F''s'/
     X   '      rt3      Use this flag if your reconstruction is'/
     X   '               of the type Root3xRoot3-R30'/
     X   '      rt5      Use this flag if your reconstruction is'/
     X   '               of the type Root5xRoot5-R26.2'/
     X   '      PINIT    Skips bulk reflections up front'/
     X   '               Default is to seperate them at the end'/
     X   '      POWER X  Use X as power for fit -- skips the scan'/
     9   '      SHOW     Provides a little more output')
        write(6,9040)
9040    format(/'For instance, this would be an example file for a'/
     1   '(3x3) cell with 4 measurements to 0.7 Angstroms & p6mm'/
     X   'symmetry, with CENSOR=3.0 '//
     2   '4 3 3 '/
     3   '10.5 10.5 120 0.7'/
     4   'p6mm'/
     5   'MyFile_1.hkl'/
     6   'MyFile_2.hkl'/
     7   'MyFile_3.hkl'/
     8   'MyFile_4.hkl'/
     9   'CENSOR 3.0')
        call exit(0)
        end
        
        include '../Divergence/sortag.f'
C       include 'frobust.f'
C       include 'noweight.f'
C       include 'fweight1.f'
C       include 'fweight2.f'
C       include 'fprint.f'
C       include 'weight1.f'
C       include 'weight2.f'
C       include 'matder.f'
C       include 'minverse.f'
C       include 'equiv2.f'
C       include 'Errors.f'
C        include 'feval.f'
C        include 'uncmin.f'
