/*
 * utils.h
 */
#include <stdarg.h> /* for va_list */

#define sq(x)	((x)*(x))
#define PI		3.141592653589793
#define MAX2(x, y) ((x) > (y) ? (x) : (y))
#define MIN2(x, y) ((x) < (y) ? (x) : (y))

FILE *fopen_chk_rmode(char *filename);
FILE *fopen_chk_wmode(char *filename);
void two_fprintf(FILE *fp, FILE *fp2, char *fmt,...);
int str_to_fs(int max_num, char *str, double x[]);
char *remove_extention(char *filename);
char *rm_cr(char *str);
char *comment_skip_fgets(int n, char *buf, FILE *fp);
void findmaxmin(int n, double *x, double *xmax, double *xmin);
void findmaxmin2(int nx, int ny, double **x, double *xmax, double *xmin);
double machine_eps(void);
double quadratic_interpol(
  int ik, double h_shift, double *intensity, int num_k_points, double *bh
  );
void d_heapsort(int n, double a[], int index[]);
void d_heapsort_ascend(int n, double a[], int index[]);
void i_heapsort(int n, int a[], int index[]);
