#ifndef __TStructureRefinementAnnealingPage__
#define __TStructureRefinementAnnealingPage__

#include "TPage.h"

class TStructureRefinementAnnealingPage : public TPage {
	public:
		TStructureRefinementAnnealingPage(TWindow *window = nil) ;
		~TStructureRefinementAnnealingPage() ;
		void	Draw() ;
		void	DoMouseDownInObject(TObject *obj,Point *pt) ;
	private:
		void			Initialize() ;
		TButton			*mSetActiveElements ;
		TButton			*mSetFitAreaAndAtoms ;
		TButton			*mSetChemicalConstraints ;
		TButton			*mSetBondValences ;
		TRadioButton	*mCCCRealSpace ;
		TRadioButton	*mChiSquare ;
		TRadioButton	*mFTAmplitudes ;
		TButton			*mRefine ;
		TButton			*mCancel ;

		TButton			*mHelp ;

		TCheckBox		*mCompareImageFit ;
		TCheckBox		*mUseBondDistances ;
		TCheckBox		*mUseBondStrengths ;
		TCheckBox		*mCreateLogFile ;

		TEditText		*mMaxShift ;
		TEditText		*mStartingTemperature ;
		TEditText		*mEndingTemperature ;
		TEditText		*mFractionalChange ;
		TEditText		*mAttemptsPerTemp ;
		TEditText		*mNumSuccessfulAttempts ;

} ;

#endif //__TStructureRefinementAnnealingPage__

