// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
long CTRLCFLG ;
#define TRUE 1
#define FALSE 0
#include "errors.h"
void enableast() ;
// -----------------------------------------------------------------
// These set of routines work to trap the signal Cntrl_C such that
// the user can abandon a calculation with predictable results	
// ----------------------------------------------------------------- 


// -----------------------------------------------------------------
// Tests a flag that set by the CONTROL/C  routine, and if that 
// flag is set, returns .TRUE. and clears the flag.         
// -----------------------------------------------------------------
#include "types.h"
Boolean	ControlCDown() ;
void cntrlctrap(int i) ;
extern Boolean  gNoGUI ;

long abandn() {
	if (gNoGUI) return 0 ;
	
	// if (CTRLCFLG)
	if (ControlCDown())
	{
		gAbortStatus = TRUE ;
		CTRLCFLG = FALSE ;
		return(1) ;
	}
	else
		return(0) ;
}
#include <signal.h>
// -----------------------------------------------------------------
//  Enables the AST routine for trapping if CNTRL_C is pressed
// -----------------------------------------------------------------
void enableast() {
	signal(SIGINT,cntrlctrap) ;  
}

// -----------------------------------------------------------------
// Sets a flag CTRLCFLG when entered, for ABANDN to find   
// -----------------------------------------------------------------
void cntrlctrap(int i) {

	CTRLCFLG = TRUE ;
	/* Reenable CTRL/C AST */
	enableast() ;
}
