// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "menudef.h"
#include "devices.h"
#include "globals.h"
#include "funcdefs.h"
void fill_area(long xlow,long ylow,long xhi,long yhi) {
	long	x1,y1,x2,y2,width,height ;
	Rect	theRect ;

	x1 = xlow ;
	y1 = Terminal.yres - yhi ;
	x2 = xhi ;
	y2 = Terminal.yres - ylow ;
	x1 /= 2 ;
	y1 /= 2 ;
	x2 /= 2 ;
	y2 /= 2 ;
	width = x2 - x1 + 1 ;
	height = y2 - y1 + 1 ;
	SetRect(&theRect,x1,y1,x1+width,y1+height) ;
	FillRect(&theRect) ;
}
