// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include "funcdefs.h"
#include "devices.h"
#include "globals.h"
#include "menudef.h"
long GetMouseClickPosition(long *x,long *y) ;
long get_event() {
  /*******************************************************************/
  /* this subroutine finds the command that was selected             */
  /* ,returns an integer indicating the number within the current    */
  /* menu and sets the gCurrentButton to point to the particular event     */
  /*******************************************************************/

    long i,j ;
    long x,y ;
    long help_flag ;

    j = -1 ;
    do  {   /* Until the cursorposition correspond to a valid request */
    	do  {	/*  Keep doing as long as the help flag is -1 */
    		/*  -1 indicates improper cursor report     */
            help_flag = GetMouseClickPosition(&x,&y) ;
    	}
    	while (help_flag == -1) ;

    	/* Search through the list of items in the menu to see check  */
    	/* for a picked event                                         */
    	i = 0 ; /* Reset the counter */
    	for (gCurrentButton=(*gCurrentMenu);*gCurrentButton!=&null;gCurrentButton++) {
        	if (x<=(*gCurrentButton)->xh && x>= (*gCurrentButton)->xl
            		&& y<=(*gCurrentButton)->yh && y>=(*gCurrentButton)->yl)  {
          		/* Found the event that was picked  */
          		if (help_flag) {
					pr_help_msg(*gCurrentButton) ;
					return(1) ;
				}
				else {
					j = i ;
					return(j) ;
				}
        	}
        	i++ ;
      	}
    }
    while(j == -1) ;
    return 0;
}
long GetMouseClickPosition(long *x,long *y) {
    XEvent event ;
    Rect tRect ;
    long ix,iy ;

    while (1) {
	XNextEvent(gDisplay,&event) ;
	switch(event.type) {
		case ButtonPress:
  		if (event.xexpose.window == gControlWindow->GetXWindow()) {
			/* This is the control window  	*/
			ix = event.xbutton.x ;
			iy = event.xbutton.y ;
			ix *= 2 ;
			iy *= 2 ;
			iy = Terminal.yres - iy ;
    			*x = ix ;
    			*y = iy ;
    			return(0) ;
			break ;
    		default: break ;
    		}
	}
    }
}
