// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
/********************************************************************/
/* Invoked by set BLACK-WHITE. Prompts for endpoints of the mapping */
/*  line                                                            */
/********************************************************************/
void set_blkwht(long xo,long yo,long xm,long ym) {

	extern float CNTRST,BRITE ;
	float x1,x2,y1,y2 ;
	long ix1,iy1,ix2,iy2 ;

	eraser(0,0,1020,32) ;
	REVERSE_VIDEO ;
	temdtx(100,10,
		" Pos.the cursor on start. point of the contrast curve ! ") ;
	NORMAL_VIDEO ;
	temdxw(&ix1,&iy1) ;
	eraser(100,0,1020,32) ;
	x1 = (float)(ix1-xo)/(xm-xo) ;
	y1 = (float)(iy1-yo)/(ym-yo) ;
	REVERSE_VIDEO ;
	temdtx(100,10,
		" Pos. the cursor on end point of the contrast curve  ") ;
	NORMAL_VIDEO ;
	temdxw(&ix2,&iy2) ;
	eraser(100,0,1020,32) ;
	x2 = (float)(ix2-xo)/(xm-xo) ;
	y2 = (float)(iy2-yo)/(ym-yo) ;
	if ((x2-x1) == 0.) printf("\n CRASHING ....... ") ;
	CNTRST = (y2-y1)/(x2-x1) ;
	if (CNTRST < 0.)
		BRITE = (y2-CNTRST*x2)/(1.-CNTRST) ;
	else
		BRITE = (y2+CNTRST*(1.-x2))/(1.+CNTRST) ;
}      

