#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
#include "filenames.h"
extern long LAYERED ;
char progname[10] ;
#include "TFileViewDialog.h"
extern FILE *filep ;
// ---------------------------------------------------------------------
// View the print file generated during calculation of the phasegrating
// and the exit wavefunction(s)
// ---------------------------------------------------------------------
void view_o_file() {


	on_highlight() ;
	gCurrentCommand = gCurrentButton ;
	off_highlight() ;
	eraser(0,120,1020,160) ;
	TFileViewDialog *fileViewDialog ;

	
	if (!LAYERED) {
		do {
			REVERSE_VIDEO ;
			temdtx(0,130,
			          " View output from which program (PHSGRT/MSLICE) ? : ") ;
			ReadString(progname,10) ; 
			eraser(0,120,1020,160) ;
		} while (!(*progname=='p' || *progname=='P' ||
		        *progname=='m' || *progname=='M')) ;
	}
	else
		*progname = 'm' ;
		
	// Got valid filename
	NORMAL_VIDEO ;

	char	filename[256] ;
	if (*progname=='p' || *progname=='P')
		strcpy(filename,flname.pprint) ;
	else if (*progname=='m' || *progname=='M')
		strcpy(filename,flname.mprint) ;

	fileViewDialog = new TFileViewDialog(filename) ;

	if (!fileViewDialog->IsValid()) {
		delete fileViewDialog ;
		char otext[256] ;
		sprintf(otext,"Failed to load the file %s",filename) ;
		PutMessage(otext) ;
	}
	/*
	filep = fopen(filename,"r") ;
	// Check to see if the opening of the file was successful 
	if (filep == NULL) 
		err_seq(7) ;
	else
		view_outfile(filep) ;
	*/
}

