#ifndef __TMenubar_H__
#define __TMenubar_H__
#include "TMenu.h"

class TMenuBar {
	public:
		TMenuBar(TPane *pane,short width,short height=20) ;
		~TMenuBar() ;
		void	AddMenu(TMenu *menu) ;
		short	GetWidth() { return mWidth ; } ;
		short	GetHeight() { return mHeight ; } ;
		TMenu	*GetMenu(Point *loc) ;
		void 	Draw() ;
		void	DrawMenuTitle(TMenu *menu,Boolean state) ;
		TCommand 	DoMouseDown(Point *where) ;
		friend	class TApplicationWindow ;
	private:
    		int 	mHeight ;
    		int 	mWidth ;
    		uLong	mBkColor ;
    		uLong	mFgColor ;
    		int		mNumMenus ;
    		TMenu	*mMenus ;
    		TPane	*mWindowPane ;
} ;

#endif // __TMenubar_H__ 
