        real*8 function fbump2(x,y,z,dx,dy,dz,symm,natm,ind,itype)
        include 'controls.h'
        include 'Atoms.h'
        dimension x(*),y(*),z(*),itype(*)
        character*4 symm
        dimension xw(natf*2),yw(natf*2),zw(natf*2)
        real*8 fbump
C       INCLUDE 'base_atoms.h'
C       if(.not.bumper)then
C               fbump2=0
C               return
C       endif
        do j=1,natm
                xw(j)=x(j)
                yw(j)=y(j)
C               zw(j)=z(j)
                zw(j)=0
        enddo
        xw(ind)=xw(ind)+dx
        yw(ind)=yw(ind)+dy
C       zw(ind)=zw(ind)+dz
        zw(ind)=0
        fbump2=fbump(xw,yw,zw,natm,symm,itype)
        return
        end
        
        real*8 function fbump(x,y,z,natm,symm,itype)
        include 'controls.h'
        include 'errref.h'
C       Evaluate anti-bumping
        dimension x(*),y(*),z(*),itype(*)
        dimension xe(20),ye(20)
        character*4 symm
        real*8 f,r,dx,dy,dz,bc,bumpL,bbb,ff
        real*8 dist2Dvd, dist3Dvd
C       INCLUDE 'base_atoms.h'
C       save ientry
C       data ientry/0/
C       logical entdeb
C       if(.not.bumper)then
C               fbump=0
C               return
C       endif
C       entdeb=.false.  
C               ientry=ientry+1
C       if(ientry.lt.120)then
C               entdeb=.true.
C       endif
        f=0
C       First, between symmetry related atoms
C       This is legit in ALL cases
        pi=2.d0*asin(1.d0)
        do j=1,natm
        call asymm(x(j),y(j),ne,xe,ye,symm)
C       Bumping values for this atom to itself
          bump=bumpa(itype(j),itype(j))
          bumpL=bump*0.5d0
          bbb=bump*bump
          bc=pi/bumpL
          bc2=pi/bump
          bc3=0.5d0*pi/bumpL
          dz=0
C         
        do kk=2,ne
                dx=x(j)-xe(kk)
                dy=y(j)-ye(kk)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                r=dist2dvd(dx,dy)
C               r=dist3dvd(dx,dy,dz             
                if(r.lt.bbb)then
                if(r.gt.1d-4)r=sqrt(r)
                if(r.le.bump)then
                        if(r.le.bumpL)then
                          ff=2.d0*sin(r*bc3)
                        else
                          ff=(1+cos((r-bumpL)*bc))
                        endif
                        f=f+ff
                endif
                endif
        enddo
        enddo
C       Now between non-symmetry atoms if bumping set
        if(.not.bumper)goto 100
                
        do j=1,natm-1
        call asymm(x(j),y(j),ne,xe,ye,symm)
        do k=j+1,natm
C       Bumping values for the two atoms
          bump=bumpa(itype(j),itype(k))
          if(bump .gt. 1d-5)then
            bbb=bump*bump
C         
C        dz=z(k)-z(j)
C        dz=dz-nint(dz)
            dz=0
            do kk=1,ne
                dx=x(k)-xe(kk)
                dy=y(k)-ye(kk)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                r=dist2dvd(dx,dy)
C               r=dist3Dvd(dx,dy,dz)
                if(r.lt.bbb)then
                        ff=(1-r/bbb)
                        f=f+ff

                endif
            enddo
           endif
        enddo

        enddo
100     fbump=f*3.D0
C       Make it larger for Chi**2 or K-L
C       if(robfm)then
C           fbump=fbump*10
C        else
C           fbump=fbump*2
C        endif
C       write(17,*)'Bumping magnitude ',fbump,ientry
        return
        end

        real function fbumps(x,y,z,natm,symm,itype)
        include 'controls.h'
        include 'errref.h'
C       Evaluate anti-bumping
        dimension x(*),y(*),z(*),itype(*)
        dimension xe(20),ye(20)
        character*4 symm
C       real a,b,c,aa,bb,cc,f,r,dx,dy,dz,ab,bc,bumpL,bbb,ff
        real dist2Dv, dist3Dv
C       INCLUDE 'base_atoms.h'

        f=0
C       First, between symmetry related atoms
C       This is legit in ALL cases
        pi=2.d0*asin(1.d0)
        do j=1,natm
        call asymm(x(j),y(j),ne,xe,ye,symm)
C       Bumping values for this atom to itself
          bump=bumpa(itype(j),itype(j))
          bumpL=bump*0.5d0
          bbb=bump*bump
          bc=pi/bumpL
          bc2=pi/bump
          bc3=0.5d0*pi/bumpL
          dz=0
C       
        do kk=2,ne
                dx=x(j)-xe(kk)
                dy=y(j)-ye(kk)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                r=dist2dv(dx,dy)
C               r=dist3dv(dx,dy,dz              
                if(r.lt.bbb)then
                if(r.gt.1d-4)r=sqrt(r)
                if(r.le.bump)then
                        if(r.le.bumpL)then
                          ff=2.d0*sin(r*bc3)
                        else
                          ff=(1+cos((r-bumpL)*bc))
                        endif
C       if(entdeb)then
C       write(17,*)'B ',x(j),xe(kk),y(j),ye(kk),dx,dy,r
C       write(17,*)'C ',ff,f            
C       endif           
                        f=f+ff
                endif
                endif
        enddo
        enddo
C       Now between non-symmetry atoms if bumping set
        if(.not.bumper)goto 100
                
        do j=1,natm-1
        call asymm(x(j),y(j),ne,xe,ye,symm)
        do k=j+1,natm
C       Bumping values for the two atoms
          bump=bumpa(itype(j),itype(k))
          if(bump .gt. 1D-5)then
            bbb=(bump*bump)

C       
C        dz=z(k)-z(j)
C        dz=dz-nint(dz)
           dz=0
           do kk=1,ne
                dx=x(k)-xe(kk)
                dy=y(k)-ye(kk)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                r=dist2dv(dx,dy)
C               r=dist3Dv(dx,dy,dz)
                if(r.lt.bbb)then
                        ff=(1-r/bbb)
                        f=f+ff
                endif
           enddo
         endif
        enddo


        enddo
100     fbumps=f*3.D0
C       Make it larger for Chi**2 or K-L
C       if(erron.gt.0)then
C           fbumps=fbumps*10
C        else
C           fbumps=fbumps*2
C        endif
C       write(17,*)'Bumping magnitude ',fbump,ientry
        return
        end

                
