C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       PROGRAM CNVRTS
 
         CHARACTER*1 JUNK
         CHARACTER*8 DUMMY2
         CHARACTER*72 LINE
         CHARACTER*78 FILEN
         REAL PHAS(200), INTNSE, DUMMY, ERROR
         INTEGER H, K, L, NBEAMS, N, INDIVC
         LOGICAL ERRON 
         CALL GETARG (1,FILEN)
         JN = 1
         DO   J=1,78
           IF (FILEN(J:J) .EQ. ' ') GO TO 101
           JN = JN + 1
         END DO
  101    FILEN(JN:JN + 3) = '.ext'
         OPEN (9, FILE=FILEN(1:JN + 3))
         OPEN (10, FILE='control')
         FILEN(JN:JN + 3) = '.hkl'
         OPEN (11, FILE=FILEN(1:JN + 3))
         OPEN (12, FILE='solutions.tran')
         OPEN (13, FILE='temp')
 
   10    FORMAT(2I4,F10.6)
   20    FORMAT(7I3,F4.1)
   30    FORMAT(A72)
   40    FORMAT(A8,200F9.4)
   50    FORMAT(3I4,F12.8,F10.2,F10.5)
   60    FORMAT(I4,F9.6,200F9.4)
 
         N = 0
         DO   J=1,9999
           READ (11, '(a)', END=100) JUNK
           N = N + 1
         END DO
  100    CONTINUE
         REWIND (11)
 
C        Do we have the error in the .hkl file ?
         ERRON= .FALSE.
         READ(11,30)LINE
         READ(LINE,*,ERR=102,END=102)i1,i2,i3,t1,t2,t3
C        If this worked, errors are present
         ERRON = .TRUE.
102      REWIND (11)
         READ (10, *) NPARAM
         READ (13, *) INDIVC
         DO   I=1,INDIVC-1
           READ (12, 201) JUNK
201        format(a)
         END DO
         READ (12, 40) DUMMY2, (PHAS(I), I=1,NPARAM)
 
C      read (11,30) line
C      write (9,30) line
C      read (11,30) line
C      write (9,30) line
C      read (11,30) line
C     Changed by ldm to just transfer the line, no changes
C      write (9,20) nbeams,ncy,-1,4,4,-1,-1,1.0
C      write(9,30) line
 
         DO   J=1,NPARAM
           ERR = 0
           IF(ERRON)THEN
           READ (11,* ) H, K, L, INTNSE, DUMMY, ERR
           ELSE
           READ (11, *) H, K, L, INTNSE, DUMMY
           ENDIF
           IF (H .EQ. 0 .AND. K .EQ. 0) PHAS(J) = 0.
           WRITE (9, 50) H, K, L, INTNSE, PHAS(J), ERR
         END DO
 
         DO   J=1,999
           ERR = 0
           IF(ERRON)THEN
           READ (11,*,END=200) H, K, L, INTNSE, DUMMY, ERR
           ELSE
           READ (11,*,END=200) H, K, L, INTNSE, DUMMY
           ENDIF
           WRITE (9, 50) H, K, L, INTNSE, DUMMY, ERR
         END DO
  200    CONTINUE
 
       END
