      cratio=1
      diff_search=1
      pi2=4.d0*asin(1.0d0)
        pi=2.d0*asin(1.0d0)
C      natom=intget('Use how many atoms',natom,EDM_ON)
        natom_in=natom
C     write(6,79)'Use how many atoms'
C     read(5,*)natom
      call settyp(itype,fgot,natom,zatom)
C       Base level
        if(diff_search.gt.0)then
      call refine3Dn(fhk,ih,k,l,natom,x,y,z,itype,nref,
     $  symm,n1,n2,n3,errg2,ewts,10)
              best=errg2
              nbest=natom
              do j=1,natom
                 xbest(j)=x(j)
                 ybest(j)=y(j)
                 zbest(j)=z(j)
                 ob(j)=fgot(j)
              enddo
                  write(6,*)'Base R-Factor ',errg2
        endif
C     Save the input atomic positions
      do j=1,natom
         xhold(j)=x(j)
         yhold(j)=y(j)
         zhold(j)=z(j)
         ohold(j)=fgot(j)
      enddo
C       Bond-Difference Map ?
        ibdiff=-1
        if(ibdiff.gt.0)then
C       call bonddif(f,n1,n2,n3,cell,x,y,z,symm,itype,natom)
C       cratio=1
        else

C     First, get scale from prfit.h
C       %include 'prfit3.h'
C       write(6,*)'Calling calcfhk'
      call calcfhk(ih,k,l,ftrueh,ahk,fcalc,acalc,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,symm)
C
C     Now, calculate the unmeasured beams, rescaled
C       write(6,*)'Calling calcufhk'
        call calcufhk(ih,k,l,fcalc,acalc,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,npad,symm)
C       Note: this returns the values divided by wts & f0
C       Difference map is on real potential
        do j=1,npad
           fcalc(j)=fcalc(j)*wts(j)
        enddo
C     Find the max of current model
C       write(6,*)'Calling treset'
C#ifdef 2D
C        call treset3D(IH,K,L,fcalc,acalc,NREF,symm,nhk,f,m)
C#else
          CALL TRS2D (IH,K,FCALC,ACALC,NREF,SYMM,NHK,F,M)
C#endif
C     Convert to real space to get a maximum
C       write(6,*)'Calling toreal'
C       call toreal0(f,n1,n2,n3,cumax,wmask)
      CALL FFT2DN (F)
           CUMAX = (-100.)
           JK = 0
           MF = (-1)
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               JK = JK + 1
               NF = -NF
               FTEMP = F(JK*2-1) * NF
               IF (FTEMP .GT. CUMAX) CUMAX = FTEMP
             END DO
           END DO
        iplus=-1
C       if(quo.ne.'+'.and.iplus.gt.0)then
C       write(6,*)'Difference map creation, classic form'
C     Put difference map into fcalc
C          do j=1,nref
C             fcalc(j)=ftrueh(j)-fcalc(j)
C             if(fcalc(j).lt.1e-6)then
C                fcalc(j)=-fcalc(j)
C                acalc(j)=acalc(j)+pi
C             endif
C            if(acalc(j).lt.0.05)acalc(j)=acalc(j)+pi2
C          enddo
C          do j=nref+1,npad
C             fcalc(j)=fhk(j)*wts(j)-fcalc(j)
C             if(fcalc(j).lt.1e-6)then
C               fcalc(j)=-fcalc(j)
C               acalc(j)=acalc(j)+pi
C             endif
C            if(acalc(j).lt.0.05)acalc(j)=acalc(j)+pi2
C          enddo
C       else
C       Subtraction form
C
C       Unmeasured, use current estimate
          do j=nref+1,npad
                ftrueh(j)=fhk(j)*wts(j)
          enddo
C       Subtract model from the current estimate into fcalc
          do j=1,npad
                        ang=ahk(j)
                        amp=ftrueh(j)*cmplx(cos(ang),sin(ang))
                        ang=acalc(j)
                        amp2=fcalc(j)*cmplx(cos(ang),sin(ang))
                        amp=amp-amp2
                        creal=amp
                        cimag=aimag(amp)
                        fsq=creal*creal+cimag*cimag
                        if(fsq.gt.1e-8)then
                                fcalc(j)=sqrt(fsq)
                                ang=atan2(cimag,creal)
                                if(ang.lt.1e-2)ang=ang+pi2
                                acalc(j)=ang
                        else
                                fcalc(j)=0
                                acalc(j)=0
                        endif
                enddo
C       endif   

C      fcalc(nref)=1

C     Save current model for first cycle
      write(6,*)'Saving difference map'
C     Reset (for safety) vv
C     Reset (for safety) vv
           CALL TRS2D (IH,K,FCALC,ACALC,NREF,SYMM,NHK,VV,M)
           CALL PIMG2DN (VV,F,IH,K,FCALC,ACALC,NREF,SYMM,TITLE)
C     Reset (for safety) vv and f
           CALL TRS2D (IH,K,FCALC,ACALC,NREF,SYMM,NHK,F,M)
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,VV,M)

C     Convert to real space
           CALL FFT2DN (F)
           CDMAX = -CUMAX
           JK = 0
           MF = (-1)
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               JK = JK + 1
               NF = -NF
               F(JK) = F(JK*2-1) * NF
               IF (F(JK) .GT. CDMAX) CDMAX = F(JK)
             END DO
           END DO
C
           CRATIO = CDMAX / CUMAX
      write(6,*)'Largest peaks is ',100*cratio,'% of model'
      endif
C       ?????
C     Debug output
C     call debpic(f,n1,n2,.false.)
      a=cell(1)
      b=cell(2)
      cll=cell(3)
      dx=(a*a/float(n1*n1))
      dy=(b*b/float(n2*n2))
      dz=(cll*cll/float(n3*n3))
c     Distance tolerance, in Angstroms
      tol=1.0
      nty=0
      do j=1,20
         if(zatom(j).gt.-0.1)then
            nty=nty+1
         endif
      enddo
      do j1=1,nty
      do j2=j1,nty
      tol=min(tol,bumpa(j1,j2))
      enddo
      enddo
      tol=max(1.35,tol*.8)
      tola=1
      close(unit=9)
      ntot=50
      if(symm(1:2).eq.'p3'.or.symm(1:2).eq.'p6')ntot=ntot*2
      cut=acut
C      call peaks3Da(f,fgot,i1,i2,i3,n1,n2,n3,ntot,tola
C     $  ,symm,dx,dy,dz,cut)
      CALL PKS2DA (F,FGOT,I1,I2,N1,N2,NTOT,TOL,SYMM,DX,DY,CUT)
      open(unit=2,file='difference.lst')
C
C      call peaksp3D(x,y,z,i1,i2,i3,f,n1,n2,n3,
C     $  ntot,fgot,symm,cm,tol)
      TOL=max(tol,0.75)
      CALL PKSP2D (X,Y,I1,I2,F,N1,N2,NTOT,FGOT,SYMM,CM,TOL)
C       We have a sorted peak list, heights FGOT*Cratio
C       Remove those too small
        typmin=zatom(1)
        do j=2,ntypes
                typmin=min(typmin,zatom(j))
        enddo
        typmin=typmin*0.5D0
        NTOTUSE=0
        DO J=1,NTOT
                IF(FGOT(j).ge.typmin)NTOTUSE=NTOTUSE+1
        enddo
        NTOT=NTOTUSE        
           do J=1,ntot
              z(j)=0.
           enddo
C          Reduce peaks
           call redatoms(x,y,z,fgot,ntot,symm)
c       eliminate atoms too close to existing ones (except in 2D)
        j=0
1001    j=j+1
        do jj=1,natom
                call asymm(xhold(jj),yhold(jj),ne,xe,ye,symm)
C               dz=z(j)-zhold(jj)
                dz=0
                do n=1,ne
                dx=x(j)-xe(n)
                dy=y(j)-ye(n)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                if(dist3d(dx,dy,dz,1.25).and.n3.ne.1)then
C       Atom j is "bad", shuffle down
                        ntot=ntot-1
                        if(ntot.ge.j)then
                                do jk=j,ntot
                                        x(jk)=x(jk+1)
                                        y(jk)=y(jk+1)
                                        z(jk)=z(jk+1)
                                enddo
                        j=j-1
                        goto 1001
                        endif
                endif
                enddo
        enddo
        if(j.lt.ntot)goto 1001

C       The largest peak is the first
C       Remove any which are less than 1/3 of it
C       Also remove peaks which are unrealistically small
C       Except for the bond-difference map!
        ntot2t=0
        do j=1,ntot
        fgot(j)=fgot(j)*cratio
        if(((fgot(j).gt.fgot(1)/3.).and.(fgot(j).gt.0.1))
     1  .or.(ibdiff.gt.0).or.(j.lt.3))
     2  ntot2t=ntot2t+1
        enddo
        
      write(6,*)'Found ',ntot2t,' atoms (skipped ',ntot-ntot2t,')'
        ntot=ntot2t
      do j=1,ntot
        z(j)=0
C       Add up to 15 to the "hunt" list
        if(nht.gt.450)nht=450
        if(j.le.10)then
                nht=nht+1
                xht(nht)=x(j)
                yht(nht)=y(j)
                zht(nht)=z(j)
        endif
      if(z(j).gt.-900.)then
      if(j.lt.10)then
         write(2,2)'Q',j,x(j),y(j),z(j),fgot(j),0.05
      else
         write(2,21)'Q',j,x(j),y(j),z(j),fgot(j),0.05
      endif
      endif
      enddo
      close(unit=2)
C       Purge the hunting list of duplicates within 0.75 Angstrom
        call phunt(xht,yht,zht,nht,0.75,symm)
        write(6,*)'Holding on to ',nht,' hunting atoms'
C     Reset F and vv
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,F,M)
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,VV,M)
C     Jump out for QUOIN='1'
           IF(QUOIN.eq.'1') then
                do j=1,natom
                        x(j)=xhold(j)
                        y(j)=yhold(j)
C                        z(j)=zhold(j)
                        fgot(j)=ohold(j)
                enddo
                goto 7100
           endif       
C        call treset3D(IH,K,L,FHK,AHK,NREF,symm,nhk,f,m)
C        call treset3D(IH,K,L,FHK,AHK,NREF,symm,nhk,vv,m)
C
C       Skip the search ?
        if(diff_search.lt.0)goto 7100
C     Now run a search over the top X sites, to see which is the
C     best to include
      ntypes=0
      do j=1,20
         if(zatom(j).gt.-0.1)then
            ntypes=ntypes+1
         endif
      enddo
C      best=1e8
      ntyy=ntypes
      if(ntypes.eq.1)then
        zatom(1)=1
        ntyy=1
        ztemp(1)=1
      else
      write(6,79)' Limit the search type (Y/N=Def)'
      read(5,7102,err=7100,end=7100)quo
      if(quo.eq.'y'.or.quo.eq.'Y')then
      nttt=0
      do j=1,20
         if(zatom(j).gt.-0.1)then
         nttt=nttt+1
         write(6,*)'Type ',sfacts(j),' Z*occ ',zatom(j)
         endif
      enddo
      ntyy=intget('Use how many types',nttt,EDM_ON)
      if(ntyy.lt.0)goto 7100
         write(6,*)'Enter z*occ for each'
         read(5,*)(ztemp(j),j=1,ntyy)
      else
      do j1=1,ntyy
        ztemp(j1)=zatom(j1)
      enddo
      endif
      endif
      jbest=1
C       Flags for an improvement & the number of tries
        nbtry=0
1991    ifbetter=-1
        nspeak=min(ntot,6)
C       The peak to look at
        do jp1=1,nspeak
                nat4=natom+1
                xw(nat4)=x(jp1)
                yw(nat4)=y(jp1)
                zw(nat4)=z(jp1)
C               It's type
                do j1=1,ntyy
                        ow(nat4)=ztemp(j1)
                do j=1,natom
                                xw(j)=xhold(j)
                                yw(j)=yhold(j)
                                zw(j)=zhold(j)
                                ow(j)=ohold(j)
                enddo
C       Refine
      call settyp(itype,ow,nat4,zatom)
      call refine3Dn(fhk,ih,k,l,nat4,xw,yw,zw,itype,nref,
     $  symm,n1,n2,n3,errg2,ewts,10)
                        if(errg2.lt.best)then
                                ifbetter=1
                                best=errg2
                                nbest=nat4
                                jbest=jp1
                                do j=1,nbest
                                        xbest(j)=xw(j)
                                        ybest(j)=yw(j)
                                        zbest(j)=zw(j)
                                        ob(j)=ow(j)
                                enddo
              write(6,*)'Better solution... ',best,nat4,' atoms'
                        endif
                        if(errg2.lt.best*2)then
C       Add it to the seeds
                        call  addseed(xw,yw,zw,itype,nat4,errg2)
                        endif
                enddo
        enddo
C       If we improved, let's try again!
        if(ifbetter.gt.0)then
                nbtry=nbtry+1
                if(nbtry.lt.3)then
C                       Update the peak list
                        do j=jbest,ntot-1
                                x(j)=x(j+1)
                                y(j)=y(j+1)
                                z(j)=z(j+1)
                        enddo
                        ntot=ntot-1
C                       Update the positions
                        do j=1,nbest
                                xhold(j)=xbest(j)
                                yhold(j)=ybest(j)
                                zhold(j)=0
                                ohold(j)=ob(j)
                        enddo
                        natom=nbest
                goto 1991
                endif
        endif
      if(nbest.eq.natom_in)write(6,*)'No improvement possible'
        natom=nbest
        do j=1,natom
              x(j)=xbest(j)
              y(j)=ybest(j)
              z(j)=zbest(j)
              fgot(j)=ob(j)
C             write(6,*)'Deb ',j,x(j),y(j),fgot(j)
        enddo
        call settyp(itype,fgot,natom,zatom)
