      pi2=4.d0*asin(1.0d0)
        pi=2.d0*asin(1.0d0)
      natom=intget('Use how many atoms',natom,EDM_ON)
C     write(6,79)'Use how many atoms'
C     read(5,*)natom
      call settyp(itype,fgot,natom,zatom)
C       Base level
        if(diff_search.gt.0)then
      call refine3Dd(fhk,ih,k,l,natom,x,y,z,itype,nref,
     $  rsymm,n1,n2,n3,errg2,wts,10)
              best=errg2
              nbest=natom
              do j=1,natom
                 xbest(j)=x(j)
                 ybest(j)=y(j)
                 zbest(j)=z(j)
                 ob(j)=fgot(j)
              enddo
                  write(6,*)'Base R-Factor ',errg2
        endif
C     Save the input atomic positions
      do j=1,natom
         xhold(j)=x(j)
         yhold(j)=y(j)
         zhold(j)=z(j)
         ohold(j)=fgot(j)
      enddo
C       Bond-Difference Map ?
        if(ibdiff.gt.0)then
        call bonddif(f,n1,n2,n3,cell,x,y,z,symm,itype,natom)
        cratio=1
        else

C     First, get scale from prfit.h
C       %include 'prfit3.h'
D       write(6,*)'Calling calcfhk'
      call calcfhk(ih,k,l,ftrueh,ahk,fcalc,acalc,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,symm)
C
C     Now, calculate the unmeasured beams, rescaled
D       write(6,*)'Calling calcufhk'
        call calcufhk(ih,k,l,fcalc,acalc,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,npad,symm)

C     Find the max of current model
D       write(6,*)'Calling treset'
        call treset3D(IH,K,L,fcalc,acalc,NREF,symm,nhk,f,m)
C     Convert to real space to get a maximum
D       write(6,*)'Calling toreal'
        call toreal0(f,n1,n2,n3,cumax,wmask)

        if(quo.ne.'+' )then        
D       write(6,*)'Difference map creation'
C     Put difference map into fcalc
      do j=1,nref
         fcalc(j)=ftrueh(j)-fcalc(j)
         if(fcalc(j).lt.1e-6)then
                fcalc(j)=-fcalc(j)
                acalc(j)=acalc(j)+pi
         endif
        if(acalc(j).lt.0.05)acalc(j)=acalc(j)+pi2
      enddo
      do j=nref+1,npad
         fcalc(j)=fhk(j)-fcalc(j)
         if(fcalc(j).lt.1e-6)then
                fcalc(j)=-fcalc(j)
                acalc(j)=acalc(j)+pi
         endif
        if(acalc(j).lt.0.05)acalc(j)=acalc(j)+pi2
      enddo
        else
C       Subtract model from the current estimate into fcalc
                do j=nref+1,npad
                        ftrueh(j)=fhk(j)
                enddo
                do j=1,npad
                        ang=ahk(j)
                        amp=ftrueh(j)*cmplx(cos(ang),sin(ang))
                        ang=acalc(j)
                        amp2=fcalc(j)*cmplx(cos(ang),sin(ang))
                        amp=amp-amp2
                        creal=amp
                        cimag=imag(amp)
                        fsq=creal*creal+cimag*cimag
                        if(fsq.gt.1e-8)then
                                fcalc(j)=sqrt(fsq)
                                ang=atan2(cimag,creal)
                                if(ang.lt.1e-2)ang=ang+pi2
                                acalc(j)=ang
                        else
                                fcalc(j)=0
                                acalc(j)=0
                        endif
                enddo
        endif   

      fcalc(nref)=1
C       Set to zero h=k=0 reflections
        do j=nref,npad
                if(ih(j).eq.0.and.k(j).eq.0)fcalc(j)=0
        enddo
C     Save current model for first cycle
      if(fsemp)write(6,*)'Saving difference map'
C     Reset (for safety) vv
      if(fsemp)call treset3D(IH,K,L,fcalc,acalc,NREF,symm,nhk,vv,m)
      if(fsemp)call pimage3D(vv,IH,K,l,fcalc,acalc,npad,symm,title,m)
C     Reset (for safety) vv and f
        call treset3D(IH,K,L,fcalc,acalc,NREF,symm,nhk,f,m)
        call treset3D(IH,K,L,FHK,AHK,NREF,symm,nhk,vv,m)

C     Convert to real space
D       write(6,*)'Going to real with map'
        call toreal0(f,n1,n2,n3,cdmax,wmask)
      call treset3D(IH,K,L,FHK,AHK,NREF,symm,nhk,vv,m)
C
      cratio=cdmax/cumax
      write(6,*)'Largest peaks is ',100*cratio,'% of model'
      endif
C     Debug output
C     call debpic(f,n1,n2,.false.)
      a=cell(1)
      b=cell(2)
      cll=cell(3)
      dx=(a*a/float(n1*n1))
      dy=(b*b/float(n2*n2))
      dz=(cll*cll/float(n3*n3))
c     Distance tolerance, in Angstroms
      tol=1.0
      nty=0
      do j=1,20
         if(zatom(j).gt.-0.1)then
            nty=nty+1
         endif
      enddo
      do j1=1,nty
      do j2=j1,nty
      tol=min(tol,bumpa(j1,j2))
      enddo
      enddo
      tol=max(1.35,tol*.8)
      tola=1
      close(unit=9)
      ntot=50
      if(symm(1:2).eq.'p3'.or.symm(1:2).eq.'p6')ntot=ntot*2
      cut=1./10.
      call peaks3Da(f,fgot,i1,i2,i3,n1,n2,n3,ntot,tola
     $  ,symm,dx,dy,dz,cut)
      open(unit=2,file='difference.lst')
C
      call peaksp3D(x,y,z,i1,i2,i3,f,n1,n2,n3,
     $  ntot,fgot,symm,cm,tol)

c       eliminate atoms too close to existing ones (except in 2D)
        j=0
1001    j=j+1
        do jj=1,natom
                call asymm(xhold(jj),yhold(jj),ne,xe,ye,symm)
                dz=z(j)-zhold(jj)
                do n=1,ne
                dx=x(j)-xe(n)
                dy=y(j)-ye(n)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                if(dist3d(dx,dy,dz,1.25).and.n3.ne.1)then
C       Atom j is "bad", shuffle down
                        ntot=ntot-1
                        if(ntot.ge.j)then
                                do jk=j,ntot
                                        x(jk)=x(jk+1)
                                        y(jk)=y(jk+1)
                                        z(jk)=z(jk+1)
                                enddo
                        j=j-1
                        goto 1001
                        endif
                endif
                enddo
        enddo
        if(j.lt.ntot)goto 1001
c       Look at connectivity if appropriate
        if(.not.conn.and.raddif.gt.0)goto 1092
        j=0
        conup=abs(raddif)*1.25
        conup=max(conup,3.0)
1091    j=j+1
        iclose=-1
        do jj=1,natom
                call asymm(xhold(jj),yhold(jj),ne,xe,ye,symm)
                dz=z(j)-zhold(jj)
                do nn=1,ne
                dx=x(j)-xe(nn)
                dy=y(j)-ye(nn)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                if(dist3d(dx,dy,dz,conup))iclose=1
                enddo
        enddo
        if(iclose.lt.0)then
C       Not connected, purge the atoms
                ntot=ntot-1
                if(ntot.ge.j)then
                        do jk=j,ntot
                                x(jk)=x(jk+1)
                                y(jk)=y(jk+1)
                                z(jk)=z(jk+1)
                        enddo
                j=j-1
                goto 1091
                endif
        endif
        if(j.lt.ntot)goto 1091
1092    continue

C       The largest peak is the first
C       Remove any which are less than 1/3 of it
C       Also remove peaks which are unrealistically small
C       Except for the bond-difference map!
        ntot2t=0
        do j=1,ntot
        fgot(j)=fgot(j)*cratio
        if(((fgot(j).gt.fgot(1)/3.).and.(fgot(j).gt.0.1))
     1  .or.(ibdiff.gt.0).or.(j.lt.3))
     2  ntot2t=ntot2t+1
        enddo
        
      write(6,*)'Found ',ntot2t,' atoms (skipped ',ntot-ntot2t,')'
        ntot=ntot2t
      do j=1,ntot
C       Add up to 15 to the "hunt" list
        if(nht.gt.450)nht=450
        if(j.le.10)then
                nht=nht+1
                xht(nht)=x(j)
                yht(nht)=y(j)
                zht(nht)=z(j)
        endif
      if(z(j).gt.-900.)then
      if(j.lt.10)then
         write(2,2)'Q',j,x(j),y(j),z(j),fgot(j),0.05
      else
         write(2,21)'Q',j,x(j),y(j),z(j),fgot(j),0.05
      endif
      endif
      enddo
      close(unit=2)
C       Purge the hunting list of duplicates within 0.75 Angstrom
        call phunt(xht,yht,zht,nht,0.75,symm)
        write(6,*)'Holding on to ',nht,' hunting atoms'
C     Reset F and vv
        call treset3D(IH,K,L,FHK,AHK,NREF,symm,nhk,f,m)
        call treset3D(IH,K,L,FHK,AHK,NREF,symm,nhk,vv,m)
C
C       Skip the search ?
        if(diff_search.lt.0)goto 7100
C     Now run a search over the top X sites, to see which is the
C     best to include
      ntypes=0
      do j=1,20
         if(zatom(j).gt.-0.1)then
            ntypes=ntypes+1
         endif
      enddo
C      best=1e8
      ntyy=ntypes
      if(ntypes.eq.1)then
        zatom(1)=1
        ntyy=1
        ztemp(1)=1
      else
      write(6,79)' Limit the search type (Y/N=Def)'
      read(5,7102,err=7100,end=7100)quo
      if(quo.eq.'y'.or.quo.eq.'Y')then
      nttt=0
      do j=1,20
         if(zatom(j).gt.-0.1)then
         nttt=nttt+1
         write(6,*)'Type ',sfacts(j),' Z*occ ',zatom(j)
         endif
      enddo
      ntyy=intget('Use how many types',nttt,EDM_ON)
      if(ntyy.lt.0)goto 7100
         write(6,*)'Enter z*occ for each'
         read(5,*)(ztemp(j),j=1,ntyy)
      else
      do j1=1,ntyy
        ztemp(j1)=zatom(j1)
      enddo
      endif
      endif
C       Flags for an improvement & the number of tries
        nbtry=0
1991    ifbetter=-1
        nspeak=min(ntot,6)
C       The peak to look at
        do jp1=1,nspeak
                nat4=natom+1
                xw(nat4)=x(jp1)
                yw(nat4)=y(jp1)
                zw(nat4)=z(jp1)
C               It's type
                do j1=1,ntyy
                        ow(nat4)=ztemp(j1)
                do j=1,natom
                                xw(j)=xhold(j)
                                yw(j)=yhold(j)
                                zw(j)=zhold(j)
                                ow(j)=ohold(j)
                enddo
C       Refine
      call settyp(itype,ow,nat4,zatom)
      call refine3Dd(fhk,ih,k,l,nat4,xw,yw,zw,itype,nref,
     $  rsymm,n1,n2,n3,errg2,wts,10)
                        if(errg2.lt.best)then
                                ifbetter=1
                                best=errg2
                                nbest=nat4
                                jbest=jp1
                                do j=1,nbest
                                        xbest(j)=xw(j)
                                        ybest(j)=yw(j)
                                        zbest(j)=zw(j)
                                        ob(j)=ow(j)
                                enddo
              write(6,*)'Better solution... ',best,nat4,' atoms'
                        endif
                        if(errg2.lt.best*1.15)then
C       Add it to the front of the seeds
                        call  addfseed(xw,yw,zw,itype,nat4,errg2)                       
                        endif
                enddo
        enddo
C       If we improved, let's try again!
        if(ifbetter.gt.0)then
                nbtry=nbtry+1
                if(nbtry.lt.3)then
C                       Update the peak list
                        do j=jbest,ntot-1
                                x(j)=x(j+1)
                                y(j)=y(j+1)
                                z(j)=z(j+1)
                        enddo
                        ntot=ntot-1
C                       Update the positions
                        do j=1,nbest
                                xhold(j)=xbest(j)
                                yhold(j)=ybest(j)
                                zhold(j)=zbest(j)
                                ohold(j)=ob(j)
                        enddo
                        natom=nbest
                goto 1991
                endif
        endif
      if(nbest.eq.natom)write(6,*)'No improvement possible'
        natom=nbest
        do j=1,natom
              x(j)=xbest(j)
              y(j)=ybest(j)
              z(j)=zbest(j)
              fgot(j)=ob(j)
        enddo
        call settyp(itype,fgot,natom,zatom)
