         
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
C     For a given location, line search along direction
      subroutine aline3Dn(fhk,nref,natom,h,k,l,stemp,ndw,dwref,
     $  x,y,z,symm,sx,sy,sz,step,er0,eold,itype,itries)
        include 'Xray.h'
        dimension fhk(*)
        dimension x(*),y(*),z(*),stemp(*),tempfin(12)
        dimension sx(*),sy(*),sz(*),itype(*)
        character*4 symm
        logical debug
        common /fscom43/slw1,slw2,secval,debug,basecut
        dimension xw(200),yw(200),zw(200),xe(12),ye(12)
      integer h(*),k(*),l(*)
      logical dist2D,dwref
        double precision robf3Dn,err0,err,e1,e2,e3,ebest
        dimension hw(1),kw(1),lw(1)
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
        save ne
        dimension svals(100),evals(100)

        nsval=0        
        if(dwref)then
                do j=1,ndw
                        tempf(j)=abs(tempf(j))
                        tempfin(j)=tempf(j)
                enddo
        endif
C     initial value
      itries=1
      err0=robf3Dn(fhk,nref,natom,
     $  x,y,z,symm,h,k,l,itype,1)
         eold=err0
         ifail=-5
         sbest=0
        nsval=nsval+1
        svals(nsval)=0
        evals(nsval)=err0
     
C     First step
        stin=step/3.
        step=step*0.5
        s1=0
        s2=0
        e1=err0
        e2=err0
          ebest=err0
10      do j=1,natom
         xw(j)=x(j)+sx(j)*step
         yw(j)=y(j)+sy(j)*step
C         zw(j)=z(j)+sz(j)*step
         zw(j)=0
      enddo
      if(dwref)then
        do j=1,ndw
                tempf(j)=tempfin(j)+stemp(j)*step
                if(tempf(j).lt.0.15)tempf(j)=0.15
                if(tempf(j).gt.6)tempf(j)=6
                tempf(j)=abs(tempf(j))
        enddo
        call GEN3DR(xe,HW,KW,LW,NTREF,xray)
C       write(14,*)'DW ',ndw,(tempf(j),j=1,ndw)
      endif

        err=robf3Dn(fhk,nref,natom,
     $  xw,yw,zw,symm,h,k,l,itype,1)
        nsval=nsval+1
        svals(nsval)=step
        evals(nsval)=err
        if(debug)write(14,*)'Step ',step,' Error ',err,err0
        itries=itries+1
        if(err.lt.err0)then
              ifail=1
C       Shuffle 3 locations
                s1=s2
                e1=e2
                s2=step
                e2=err
                sbest=step
                    ebest=err
C
              err0=err
              stin=stin*2.5
              step=step+stin
              goto 10
        else if(ifail.eq.-5)then
C       It was larger, so switch around
                        s1=step
                        e1=err
                        s2=0
                        e2=err0
                        ifail=ifail+1
                        step=-step/2.
                        stin=-stin/2.
                        goto 10
C         else if(ifail.eq.-4)then
C       It has to be between the three
C                       s3=step
C                       e3=err
C               ifail=ifail+1
        endif
C       It is now bracketed between s1,s2 and current location s3
C       Respective errors are e1,e2,e3
C       If we have walked OK there, try intermediary point
                s3=step
                e3=err
                step=s2
                ibracket=0
1000            st1=s2-s1
                st2=s2-s3
                stt=0.5*(st1*st1*(e2-e3)-st2*st2*(e2-e1))
                stt=s2-stt/(st1*(e2-e3)-st2*(e2-e1))
                slw=min(s1,s3,s2)
                sup=max(s1,s3,s2)
        if(debug)write(14,*)'Bracketing ',s1,s2,s3,stt,e1,e2,e3
C       Different approach ?
        call minptsg(svals,evals,nsval,stt,ifl)
C
1001            if(stt.lt.slw.or.stt.gt.sup)then
                                step=sbest
                                err=ebest
                                goto 100
                    endif
                do j=1,natom
                        xw(j)=x(j)+sx(j)*stt
                        yw(j)=y(j)+sy(j)*stt
C                       zw(j)=z(j)+sz(j)*stt
                        zw(j)=0
                enddo
                if(dwref)then
                        do j=1,ndw
                        tempf(j)=tempfin(j)+stemp(j)*stt
                        if(tempf(j).lt.0.15)tempf(j)=0.15
                        if(tempf(j).gt.6.0)tempf(j)=6.0
                        tempf(j)=abs(tempf(j))
                        enddo
                        call GEN3DR(xe,HW,KW,LW,NTREF,xray)
C       write(14,*)'DW 2',ndw,(tempf(j),j=1,ndw)
                endif
                err=robf3Dn(fhk,nref,natom,
     $          xw,yw,zw,symm,h,k,l,itype,1)
                nsval=nsval+1
                svals(nsval)=stt
                evals(nsval)=err
        if(debug)write(14,*)'BStep ',stt,' Error ',err,err0,ifail
                itries=itries+1
                if(err.lt.err0)then
                        step=stt
                        err0=err
                        sbest=step
                        ebest=err
C       Try one more ? - not worth it!
C                       if(ibracket.lt.1)then
C                       ibracket=2
c                       if(stt.gt.s2)then
C       Between s2 & s3, so replace s1
C                               s1=stt
C                               e1=err
C                               goto 1000
C                       else 
C                               s3=stt
C                               e3=err
C                               goto 1000
C                       endif
C                       endif
                else
                if(ifail.lt.0)then
C       We get here if we failed!
C       Contract both
                        ifail=ifail+1
                        s1=s1/2.5
                        do j=1,natom
                                xw(j)=x(j)+sx(j)*s1
                                yw(j)=y(j)+sy(j)*s1
C                               zw(j)=z(j)+sz(j)*s1
                                zw(j)=0
                        enddo
                if(dwref)then
                        do j=1,ndw
                        tempf(j)=tempfin(j)+stemp(j)*s1
                        if(tempf(j).lt.0.15)tempf(j)=0.15
                        if(tempf(j).gt.6.0)tempf(j)=6.0
                        tempf(j)=abs(tempf(j))
                        enddo
                        call GEN3DR(xe,HW,KW,LW,NTREF,xray)
C       write(14,*)'DW 2b',ndw,(tempf(j),j=1,ndw)
                endif
                        e1=robf3Dn(fhk,nref,natom,
     $                  xw,yw,zw,symm,h,k,l,itype,1)
                nsval=nsval+1
                svals(nsval)=s1
                evals(nsval)=e1
                if(debug)write(14,*)'Contracted 1 ',e1,s1
                        if(e1.lt.ebest)then
                                ebest=e1
                                sbest=s1
                        endif
                        s3=s3/2.5
                        do j=1,natom
                                xw(j)=x(j)+sx(j)*s3
                                yw(j)=y(j)+sy(j)*s3
C                               zw(j)=z(j)+sz(j)*s3
                                zw(j)=0
                        enddo
                if(dwref)then
                        do j=1,ndw
                        tempf(j)=tempfin(j)+stemp(j)*s3
                        if(tempf(j).lt.0.15)tempf(j)=0.15
                        if(tempf(j).gt.6.0)tempf(j)=6.0
                        tempf(j)=abs(tempf(j))
                        enddo
                        call GEN3DR(xe,HW,KW,LW,NTREF,xray)
C       write(14,*)'DW 2c',ndw,(tempf(j),j=1,ndw)
                endif
                        e3=robf3Dn(fhk,nref,natom,
     $                  xw,yw,zw,symm,h,k,l,itype,1)
                nsval=nsval+1
                svals(nsval)=s3
                evals(nsval)=e3
                if(debug)write(14,*)'Contracted 3 ',e3,s3
                        if(e3.lt.ebest)then
                                ebest=e3
                                sbest=s3
                        endif
                        goto 1000
                else
                step=sbest
                        err=ebest
                endif
            endif
C     Done
100      do j=1,natom
         x(j)=x(j)+step*sx(j)
         y(j)=y(j)+step*sy(j)
C         z(j)=z(j)+step*sz(j)
         z(j)=0
      enddo
        if(dwref)then
                do j=1,ndw
                tempf(j)=tempfin(j)+stemp(j)*step
                if(tempf(j).lt.0.15)tempf(j)=0.15
                if(tempf(j).gt.6.0)tempf(j)=6.0
                tempf(j)=abs(tempf(j))
                enddo
                call GEN3DR(xe,HW,KW,LW,NTREF,xray)
C       write(14,*)'DW 3',ndw,(tempf(j),j=1,ndw)
        endif
      er0=err0
      return
      end
