C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
C     Reduce, approximately, to an asymmetric unit
C     Base this on smallest, positive x,y
       SUBROUTINE ASUWNT (X, Y, SYMM )
       DIMENSION XE(20), YE(20)
       CHARACTER*4 SYMM
C       entry asyunit
      dmin=1e6
        x=x-int(x)
        y=y-int(y)
        if(x.lt.0)x=x+1
        if(y.lt.0)y=y+1
        xb=x
        yb=y
      do 10 ix=-1,1
      do 10 iy=-1,1
      xw=x+ix
      yw=y+iy
      call asymm(xw,yw,ne,xe,ye,symm)
C
      do 10 j=1,ne
      if(xe(j).lt.-1e-4)goto 10
      if(ye(j).lt.-1e-4)goto 10
      r=xe(j)*xe(j)+ye(j)*ye(j)
      if(r.gt.dmin)then
C       Too far, don't use
        goto 10
      else if(r.lt.dmin)then
C       Smaller, use
         dmin=r
         xb=xe(j)
         yb=ye(j)
      else
C       The same, use smaller xb
         if(xe(j).lt.xb)then
            xb=xe(j)
            yb=ye(j)
         endif
      endif
10      continue
      if(dmin.gt.1e5)return
      x=xb
      y=yb
      return
      END
