C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine peaksp3D(xo,yo,zo,i1,i2,i3,f,n1,n2,n3,
     $  ntot,fc,symm,cm,tol)
C     Convert positions to x,y values
      dimension x(500),y(500),z(500),f(*),fgot(500),fc(*)
      dimension xo(*),yo(*),zo(*),xe(20),ye(20)
      dimension i1(*),i2(*),i3(*),peak(-4:4,-4:4,-4:4)
      dimension work(500),ind(500)
      character*4 symm
      logical cm, dist3D, twoD, specx, specy,trouble
      save ne,peak
      
C     Convert to heights and x,y,z
      ngot=0
      fmax=-99
      twoD=.false.
      if(n3.eq.1)twoD=.true.
C       write(6,*)'Peaksp3D ',twoD,ntot
      do 4 j=1,ntot
902   xf=float(i1(j)-1)/float(n1)
      yf=float(i2(j)-1)/float(n2)
      zf=float(i3(j)-1)/float(n3)
C       write(6,*)'Atom ',xf,yf,zf,i1(j),i2(j),i3(j),j
      if(symm.eq.'p2mm'.or.symm.eq.'c2mm')then
         if(xf.gt.0.5001)goto 4
         if(yf.gt.0.5001)goto 4
      endif
      if(symm.eq.'c2mm')then
         if((xf.eq.0.5).and.(yf.eq.0.5))goto 4
      endif
C       Cleanup symmetry points
      if(specx(xf,yf,symm))inod=1
      if(specy(xf,yf,symm))inod=1
        call cleaner(xf,yf,symm,1.0)
C     Local 3x3 search
      sump=0.0
        cx=0
        cy=0
        cz=0
        sum=0
C       write(6,*)'Trap 1'
        if(twoD)then
        rr=2.4*2.4
        j3=i3(j)
C       write(6,*)'Trap 2'
        do jj1=-4,4
         do jj2=-4,4
            j1=i1(j)+jj1
            j2=i2(j)+jj2
            pp=fadd3D(f,j1,j2,j3,n1,n2,n3)
            pp=max(pp,0.)
C               Square - since we do in 3D (?)
                pq=pp*pp
            r=jj1*jj1+jj2*jj2
                if(r.gt.rr)goto 9011
                sum=sum+pq
                cx=cx+pq*jj1
                cy=cy+pq*jj2
9011            continue
            peak(jj1,jj2,0)=pp
            enddo
        enddo        
        else
C       write(6,*)'Trap 3 !!!', twoD
        sup=sqrt(float(n1*n2*n3))
        rr=3.3*3.3
        do jj1=-4,4
         j1=i1(j)+jj1
         do jj2=-4,4
         j2=i2(j)+jj2
            do jj3=-4,4
            j3=i3(j)+jj3
            pp=fadd3D(f,j1,j2,j3,n1,n2,n3)*sup
            pp=max(pp,0.)
                r=jj1*jj1+jj2*jj2+jj3*jj3
                if(r.gt.rr)goto 901
                        pq=pp*pp
                        sum=sum+pq
                        cx=cx+pq*jj1
                        cy=cy+pq*jj2
                        cz=cz+pq*jj3
901             continue
            peak(jj1,jj2,jj3)=pp
            enddo
         enddo
        enddo
        endif
C       write(6,*)' At one',cx,cy,cz,sum
        if(twoD)cz=0
        cx=cx/sum
        cy=cy/sum
        cz=cz/sum
        if(abs(cx).gt.0.51)then
C       write(19,*)'Shift x by ',cx,i1(j),i2(j),i3(j)
                i1(j)=i1(j)+nint(cx/abs(cx))
                if(i1(j).lt.1)i1(j)=i1(j)+n1
                if(i1(j).gt.n1)i1(j)=i1(j)-n1
                goto 902
        endif
        if(abs(cy).gt.0.51)then
C       write(19,*)'Shift y by ',cy,i1(j),i2(j),i3(j)
                i2(j)=i2(j)+nint(cy/abs(cy))
                if(i2(j).lt.1)i2(j)=i2(j)+n2
                if(i2(j).gt.n2)i2(j)=i2(j)-n2
                goto 902
        endif
         if(abs(cz).gt.0.51.and.(.not.twoD))then
C       write(19,*)'Shift z by ',cz,i1(j),i2(j),i3(j)
                i3(j)=i3(j)+nint(cz/abs(cz))
                if(i3(j).lt.1)i3(j)=i3(j)+n3
                if(i3(j).gt.n3)i3(j)=i3(j)-n3
                goto 902
        endif
      if(twoD)then
        call lmin2Dn(delx,dely,peak,sump)
        delz=0
        zf=0
      else
        call lmin3Dn(delx,dely,delz,peak,sump,trouble)
C       if(trouble)then
C       write(19,*)'Atom ',xf,yf,zf,i1(j),i2(j),i3(j),j
C       write(19,*)'Problem: ',delx,dely,delz
C       do j1=-4,4
C       do j2=-4,4
C       write(19,199)j1,j2,(peak(j1,j2,j3),j3=-4,4)
C199    format(2i2,' ',9f8.5)
C       enddo
C       enddo
C       endif
      endif
      ngot=ngot+1
C       Cleanup symmetry points
      xf=xf+delx/float(n1)
      yf=yf+dely/float(n2)
      zf=zf+delz/float(n3)
      if(specx(xf,yf,symm))inod=1
      if(specy(xf,yf,symm))inod=1
        call cleaner(xf,yf,symm,1.0)
      x(ngot)=xf
      y(ngot)=yf
      z(ngot)=zf
C       write(19,*)' At 2',xf,yf,zf,delx,dely,delz,sump
c      fgot(ngot)=val
      fgot(ngot)=sump
      if(sump.gt.fmax)fmax=sump
4      continue
C
C     Rescale, and resort
C       write(6,*)' At 3'
      do j=1,ngot
              fgot(j)=fgot(j)/fmax
              work(j)=1./(1.+fgot(j))
              ind(j)=j
              xo(j)=x(j)
              yo(j)=y(j)
              zo(j)=z(j)
              fc(j)=fgot(j)
      enddo
        call sortag(work,ngot,ind)
        do j=1,ngot
              l=ind(j)
              x(j)=xo(l)
              y(j)=yo(l)
              z(j)=zo(l)
              fgot(j)=fc(l)
        enddo

C       write(6,*)' At 4'
C     Convert p3/p6 back to unit cell
      if(symm(1:2).eq.'p3'.or.symm(1:2).eq.'p6')then
         do j=1,ngot
            xr=(x(j)+y(j))
            yr=(y(j)-x(j))
            x(j)=xr-int(xr)
            y(j)=yr-int(xr)
         enddo
      endif

C     Cleanup atoms close to symmetry points
      do jj=1,2
      do j=1,ngot
      call asyunit(x(j),y(j),symm)
        call cleaner(x(j),y(j),symm,1.0)
      enddo
      enddo

C       write(6,*)' At 5'

C     Remove duplicates by a double-search
        do j=1,ngot
                call asyunit(x(j),y(j),symm)
        enddo
      do j=1,ngot-1
      if(fgot(j).lt.-0.1)goto 10
      call asymm(x(j),y(j),ne,xe,ye,symm)
      do k=j+1,ngot
         if(fgot(k).lt.-0.1)goto 11
C       Could use dx=dx-nint(dx) instead of loops - not critical
         do ix=-1,1
         do iy=-1,1
         dz=z(j)-z(k)
         do jj=1,ne
            dx=x(k)-xe(jj)+ix
            dy=y(k)-ye(jj)+iy
         if(dist3D(dx,dy,dz,tol))then
C       write(19,*)'Removing ',x(k),y(k),z(k),dx,dy,dz
            fgot(k)=-1
            goto 11
         endif
         enddo
                enddo
                enddo
11      continue
        enddo
10      continue
        enddo
C
C       write(6,*)' At 6'
C     Now output
      ntot=0
      fmax=fgot(1)
      do j=1,ngot
C       Note: in p3 perhaps the wrong way around ?
        if(symm(1:2).eq.'p3')then
                x(j)=-x(j)
                y(j)=-y(j)
        endif
      if(fgot(j).gt.0)then
         ntot=ntot+1
         fc(ntot)=fgot(j)/fmax
         call asyunit(x(j),y(j),symm)
         if(abs(x(j)).lt.1e-4)x(j)=0
         if(abs(y(j)).lt.1e-4)y(j)=0
         xo(ntot)=x(j)
         yo(ntot)=y(j)
         zo(ntot)=z(j)
      endif
      enddo
      return
      end
      function fadd3D(f,k1,k2,k3,n1,n2,n3)
      dimension f(*) 
      j1=k1
      j2=k2
      j3=k3  
      if(j1.lt.1)j1=j1+n1
      if(j2.lt.1)j2=j2+n2
      if(j3.lt.1)j3=j3+n3
      if(j1.gt.n1)j1=j1-n1
      if(j2.gt.n2)j2=j2-n2
      if(j3.gt.n3)j3=j3-n3
             jk=(j3-1)*n2*n1+(j2-1)*n1+j1
             fadd3D=f(jk)
             return
             end

C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine lmin3D(x,y,z,b,val)
C     given a 3x3 array a, finds the local maximum,
C     returns the expected value there
      dimension b(-1:1,-1:1,-1:1),a(-1:1,-1:1)

        sum=0
        cx=0
        cy=0
        cz=0
        do i1=-1,1
        do i2=-1,1
        do i3=-1,1
                sum=sum+b(i1,i2,i3)
                cx=cx+b(i1,i2,i3)*i1
                cy=cy+b(i1,i2,i3)*i2
                cz=cz+b(i1,i2,i3)*i3
        enddo
        enddo
        enddo
        cx=cx/sum
        cy=cy/sum
        cz=cz/sum
        if(abs(cx).gt.0.9)cx=cx/abs(cx)
        if(abs(cy).gt.0.9)cy=cy/abs(cy)
        if(abs(cz).gt.0.9)cz=cz/abs(cz)
        include 'lmin3D.h'
        if(abs(x).gt.0.9)x=cx
        if(abs(y).gt.0.9)y=cy
        if(abs(z).gt.0.9)z=cz
      return
      end
C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine lmin3Dn(x,y,z,b,f,trouble)
C     given a 7x7 array a, finds the local maximum,
C     returns the expected value there
      dimension b(-4:4,-4:4,-4:4)
      logical trouble
      trouble=.false.
      call lmin3Dt(x,y,z,b,val,trouble)
      if(x.lt.0)then
        ix1=-1
        dx1=abs(x)
      else
        ix1=0
        dx1=1-x
      endif
      if(y.lt.0)then
        iy1=-1
        dy1=abs(y)
      else
        iy1=0
        dy1=1-y
      endif
       if(z.lt.0)then
        iz1=-1
        dz1=abs(y)
      else
        iz1=0
        dz1=1-z
      endif
      ix2=ix1+1
      iy2=iy1+1
      iz2=iz1+1
      dx2=1-dx1
      dy2=1-dy1
      dz2=1-dz1
      f=0
      rr=3.3*3.3
      do i1=-3,3
      do i2=-3,3
      do i3=-3,3
         r=i1*i1+i2*i2+i3*i3
         if(r.lt.rr)then
        f1=b(ix1+i1,iy1+i2,iz1+i3)*dx1+b(ix2+i1,iy1+i2,iz1+i3)*dx2
        f2=b(ix1+i1,iy2+i2,iz1+i3)*dx1+b(ix2+i1,iy2+i2,iz1+i3)*dx2
        f11=f1*dy1+f2*dy2
        f1=b(ix1+i1,iy1+i2,iz2+i3)*dx1+b(ix2+i1,iy1+i2,iz2+i3)*dx2
        f2=b(ix1+i1,iy2+i2,iz2+i3)*dx1+b(ix2+i1,iy2+i2,iz2+i3)*dx2
        f22=f1*dy1+f2*dy2
        f0=f11*dz1+f22*dz2
        dx=dx+f0*i1
        dy=dy+f0*i2
        dz=dz+f0*i3
        f=f+f0
        endif
      enddo
      enddo
      enddo
      return
      end

      subroutine lmin3Dt(x,y,z,b,val,ptrouble)
C     given a 3x3 array a, finds the local maximum,
C     returns the expected value there
      dimension b(-4:4,-4:4,-4:4),a(-1:1,-1:1)
      logical ptrouble

        cx=0
        cy=0
        cz=0
        sum=0
        rr=3.3*3.3
        do i1=-4,4
        do i2=-4,4
        do i3=-4,4
                r=i1*i1+i2*i2+i3*i3
                if(r.gt.rr)goto 901
                pq=b(i1,i2,i3)
                sum=sum+pq
                cx=cx+pq*i1
                cy=cy+pq*i2
                cz=cz+pq*i3
901     continue
        enddo
        enddo
        enddo
        cx=cx/sum
        cy=cy/sum
        cz=cz/sum
        x=cx
        y=cy
        z=cz
        goto 902
        cxo=cx
        cyo=cy
        czo=cz
        if(abs(cx).gt.0.999)then
                write(10,*)'cx too large ',cx
                cx=cx/abs(cx)
                ptrouble=.true.
        endif
         if(abs(cy).gt.0.999)then
                write(10,*)'cy too large ',cy
                cy=cy/abs(cy)
                ptrouble=.true.
        endif
        if(abs(cz).gt.0.999)then
                write(10,*)'cz too large ',cz
                cz=cx/abs(cz)
                ptrouble=.true.
        endif
        include 'lmin3D.h'
902     if(abs(x).gt.0.999)then
                write(10,*)'x too large ',x,cx,cxo
C               ptrouble=.true.
                if(abs(x).gt.1.5)x=cx
        endif
         if(abs(y).gt.0.999)then
                write(10,*)'y too large ',y,cy,cyo
C               ptrouble=.true.
                if(abs(y).gt.1.5)y=cy
        endif
        if(abs(z).gt.0.999)then
                write(10,*)'z too large ',z,cz,czo
C               ptrouble=.true.
                if(abs(z).gt.1.5)z=cz
        endif

      return
      end
        
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine lmin2Dn(x,y,b,f)
C     given a 7x7 array a, finds the local maximum,
C     returns the expected value there
      dimension b(-4:4,-4:4,-4:4)
      logical trouble
      trouble=.false.
      call lmin2Dt(x,y,b,val)
      if(x.lt.0)then
        ix1=-1
        dx1=abs(x)
      else
        ix1=0
        dx1=1-x
      endif
      if(y.lt.0)then
        iy1=-1
        dy1=abs(y)
      else
        iy1=0
        dy1=1-y
      endif
      ix2=ix1+1
      iy2=iy1+1
      dx2=1-dx1
      dy2=1-dy1
      f=0
      rr=3.3*3.3
      do i1=-3,3
      do i2=-3,3
         r=i1*i1+i2*i2
         if(r.lt.rr)then
        f1=b(ix1+i1,iy1+i2,0)*dx1+b(ix2+i1,iy1+i2,0)*dx2
        f2=b(ix1+i1,iy2+i2,0)*dx1+b(ix2+i1,iy2+i2,0)*dx2
        f0=f1*dy1+f2*dy2
        dx=dx+f0*i1
        dy=dy+f0*i2
        f=f+f0
        endif
      enddo
      enddo
      return
      end

      subroutine lmin2Dt(x,y,b,val)
C     given a 3x3 array a, finds the local maximum,
C     returns the expected value there
      dimension b(-4:4,-4:4,-4:4),a(-1:1,-1:1)

        cx=0
        cy=0
        sum=0
        rr=3.3*3.3
        do i1=-4,4
        do i2=-4,4
                r=i1*i1+i2*i2
                if(r.gt.rr)goto 901
                sum=sum+b(i1,i2,0)
                cx=cx+b(i1,i2,0)*i1
                cy=cy+b(i1,i2,0)*i2
901     continue
        enddo
        enddo
        cx=cx/sum
        cy=cy/sum
        x=cx
        y=cy
C        goto 902
        cxo=cx
        cyo=cy
        if(abs(cx).gt.0.999)then
                write(10,*)'cx too large ',cx
                cx=cx/abs(cx)
        endif
         if(abs(cy).gt.0.999)then
                write(10,*)'cy too large ',cy
                cy=cy/abs(cy)
        endif
        do i1=-1,1
        do i2=-1,1
                a(i1,i2)=b(i1,i2,0)
        enddo
        enddo
      dxx=1./3.*(a(1,1)-2.*a(0,1)+a(-1,1)+a(1,0)
     $     -2.*a(0,0)+a(-1,0)+a(1,-1)-2.*a(0,-1)+a(-1,-1))
      dyy=1./3.*(a(1,1)-2.*a(1,0)+a(1,-1)+a(0,1)
     $     -2.*a(0,0)+a(0,-1)+a(-1,1)-2.*a(-1,0)+a(-1,-1))
      dxy=0.25*(a(1,1)-a(1,-1)-a(-1,1)+a(-1,-1))
C      dxy=-0.5*(a(1,0)+a(-1,0)+a(0,1)+a(0,-1)
C     $ -2*a(0,0)-a(1,1)-a(-1,-1))
      dx=0.5*(a(1,0)-a(-1,0))
      dy=0.5*(a(0,1)-a(0,-1))
      det=(dxx*dyy-dxy*dxy)
      if(abs(det).lt.1e-10)then
           x=cx
           y=cy
C       write(6,*)'Failing det for x,y'
           goto 10
      endif
      x=-(dyy*dx-dxy*dy)/det
      y=-(-dxy*dx+dxx*dy)/det
10    continue
        if(abs(x).gt.0.999)then
                write(10,*)'x too large ',x,cx,cxo
                x=x/abs(x)
        endif
         if(abs(y).gt.0.999)then
                write(10,*)'y too large ',y,cy,cyo
                y=y/abs(y)
        endif

      return
      end

