C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ESHP2D (N1, N2, M, C, IOPT, POSRSCL )
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         INCLUDE 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
         COMPLEX C(*)
         REAL*8 X, XMEAN, FTEMP
         INTEGER M(3), N1, N2, IOPT
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
 
C     Do a negative FFT
         CALL FFT2DN (C)
 
C           Correction for the origin shift
C           Quench any imaginary component as a rounding error
         XMEAN = 0.
         MF = (-1)
         JK = 0
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
C
             NF = -NF
             X = C(JK)
             X = X * DBLE(NF)
             C(JK) = X
             XMEAN = XMEAN + X
           END DO
         END DO
         XMEAN = XMEAN / DBLE (N1 * N2)
         FTEMP = XMEAN * 0.5D0
C       Adding something similar to fs2002 for non-centro case
C        if(.not.centro)then
C                XMEAN = XMEAN / DEXP (1.d0)
C                FTEMP = XMEAN / DEXP (1.D0)
C        endif
C     X*ln(X) case
         MF = (-1)
         JK = 0
C        S1 = 0
C        S2 = 0
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             X = DBLE (C(JK)) / XMEAN
C            S1 = S1 + X*X
             IF (X .LT. 1D-10) THEN
               XT = 0.
             ELSE
               XT = X * LOG (X)
C              S2 = S2 + X*X
             END IF
             C(JK) = XT * DBLE(NF) * FTEMP
           END DO
         END DO
         CALL FFT2DP (C)
C         Write(10,*)'Positivity rescale ',S1/S2
         POSRSCL=1
         RETURN
       END
