C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE BOPT (PCOR, SYMM, MMODE, IOPT, PMASK, PCORM, XRAY,
     X    TITLE, NITER, CVAR )
 
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
 
         CHARACTER*1 YON
         LOGICAL PMASK, XRAY
         CHARACTER*80 TITLE
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
 
         CHARACTER*4 SYMM
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ ,
     X   /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/ 
 
         YON = ' '
C     read(5,1)yon
    1    FORMAT(A)
         MODE = 4
         IOPT = 12
         PCOR = 1.
         PCORM = 1.
         PMASK = .TRUE.
         PWMASK = .FALSE.
         PWACC = .TRUE.
         WT2ON = .FALSE.
         PRINTF = .FALSE.
 
C     Get stuff via getin
         CALL GETIN (SYMM,XRAY,TITLE,PMASK,PCOR,NITER,CVAR,PRINTF)
         WRITE (10, 1) ' '
 
         WRITE (10, 1) '**************** Options ******************'
         WRITE (6, 1) '**************** Options ******************'
    3    FORMAT(A,I3)
    2    FORMAT(A,F8.3)
         IF (XRAY) THEN
           WRITE (10, 1) 'X-ray Scattering Factors Used'
         ELSE
           WRITE (10, 1) 'Electron Scattering Factors Used'
         END IF
         WRITE (10, 1) 'Using Unitary Structure Factors'
         WRITE (6, 1) 'Using Unitary Structure Factors'
         IF (PMASK) THEN
C           write(10,1)'Window Function Used'
C           write(6,1)'Window Function Used'
           WRITE (10, 1) 'Iterative Window Analysis'
           WRITE (6, 1) 'Iterative Window Analysis'
         ELSE
           WRITE (10, 1) 'No Window Function Used'
           WRITE (6, 1) 'No Window Function Used'
         END IF
         IF (FOM2) THEN
           IF (PCOR .GT. 1D-3) THEN
             WRITE (10, 1) 'L2 fitting of Unitary S.F.'
             WRITE (6, 1) 'L2 fitting of Unitary S.F.'
           ELSE
             WRITE (10, 1) 'L2 fitting of Raw S.F.'
             WRITE (6, 1) 'L2 fitting of Raw S.F.'
           END IF
         ELSE
           IF (PCOR .GT. 1D-3) THEN
             WRITE (10, 1) 'Robust fitting of Unitary S.F.'
             WRITE (6, 1) 'Robust fitting of Unitary S.F.'
           ELSE
             WRITE (10, 1) 'Robust fitting of Raw S.F.'
             WRITE (6, 1) 'Robust fitting of Raw S.F.'
           END IF
         END IF
 
         IF (ATNUM .GT. 1) THEN
           WRITE (10, 2) 'Constraining Number atoms > ', ATNUM
           WRITE (6, 2) 'Constraining Number atoms > ', ATNUM
C       Correct atoms constraint for p3
           IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
             IF (ATNUM .GT. 1) ATNUM = ATNUM * 2
           END IF
         END IF
         IF (PATTC .GT. 1) THEN
           WRITE (10, 2) 'Test code ', PATTC
           WRITE (6, 2) 'Test code', PATTC
         END IF
C     Save iopt into iiopt for miscellaneous usage
 
 
C     write(6,2)'Mode code ',ftune(2)
C     write(10,2)'Mode code ',ftune(2)
         IF (FTUNE(2) .LT. 1) THEN
           WRITE (6, 1) 'Equal weight Entropy/Positivity'
           WRITE (10, 1) 'Equal weight Entropy/Positivity'
         ELSE IF (FTUNE(2) .LT. 2) THEN
           WRITE (6, 1) 'FOM scaling weight Entropy/Positivity'
           WRITE (10, 1) 'FOM scaling weight Entropy/Positivity'
         ELSE IF (FTUNE(2) .LT. 3) THEN
           WRITE (6, 1) 'FOM scaling Entropy/Positivity Enhanced'
           WRITE (10, 1) 'FOM scaling Entropy/Positivity Enhanced'
         ELSE IF (FTUNE(2) .LT. 4) THEN
           WRITE (6, 1) 'Entropy Mode'
           WRITE (10, 1) 'Entropy Mode'
         ELSE IF (FTUNE(2) .LT. 5) THEN
           WRITE (6, 1) 'Positivity Mode'
           WRITE (10, 1) 'Positivity Mode'
         ELSE IF (FTUNE(2) .LT. 6) THEN
           WRITE (6, 1) '2/3 Entropy, 1/3 Positivity'
           WRITE (10, 1) '2/3 Entropy, 1/3 Positivity'
         ELSE 
           WRITE (6, 1) 'Unknown Option, check code'
           WRITE (10, 1) 'Unknown Option, check code'
C           FTUNE(2) = 3.1D0
         END IF
C           write(10,2)'Phasing Lambda code   ',ftune(1)
C           write(6,2)'Phasing Lambda code   ',ftune(1)
         XR1 = ABS (FTUNE(1))
         IF (XR1 .GT. 10.D0) THEN
           XR1 = XR1 + INT (XR1 * 0.1D0) * (-10)
           IF (XR1 .GT. 10.D0) XR1 = XR1 - 10
           IF (XR1 .LT. 0.D0) XR1 = 10.D0 + XR1
         END IF
         IF (ABS (FTUNE(1)) .LT. 10) THEN
           WRITE (6, 4) 'Phasing Lambda ', 1 + FTUNE(3)
           WRITE (10, 4) 'Phasing Lambda ', 1 + FTUNE(3)
         ELSE IF (FTUNE(1) .GT. 99) THEN
           WRITE (6, 4) 'Phasing Lambda ', 1 + FTUNE(3)
           WRITE (10, 4) 'Phasing Lambda ', 1 + FTUNE(3)
           WRITE (10, 4) 'Automatic Turnon'
           WRITE (6, 4) 'Automatic Turnon'
         ELSE
           WRITE (6, 4) 'Phasing Lambda ', 1 + FTUNE(3), '-', FTUNE(3),
     X        'exp(-[n-2.5]/', XR1, ')'
           WRITE (10, 4) 'Phasing Lambda ', 1 + FTUNE(3), '-', FTUNE(3)
     X        , 'exp(-[n-2.5]/', XR1, ')'
         END IF
    4    FORMAT(A,F5.3,A,F5.3,A,F5.3,A)
         WRITE (10, 2) 'Positivity Lambda     ', 1 + FTUNE(4)
         WRITE (6, 2) 'Positivity Lambda     ', 1 + FTUNE(4)
         CLOSE (UNIT=15)
         WRITE (10, 1) '*******************************************'
         WRITE (6, 1) '*******************************************'
         WRITE (10, 1) ' '
         WRITE (6, 1) ' '
         RETURN
       END
 
