C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       function TPatt (IH, K, FHK, NREF, SYMM, C, M,mode)
C
C
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         logical p3flag 
C     For tuning
         COMMON /PADCMM/NPAD
         DIMENSION IH(NHK2), K(NHK2), FHK(NHK2)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*)
         real*8 W1
         CHARACTER*4 SYMM

C     Origin for arrays (for consistency with FFT's)
         N1 = M(1)
         N2 = M(2)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1

C        DO IP=1,5 
         DO   J=1,N1*N2
              C(J) = 0.D0
         END DO
         p3flag =  SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FHK(J)*FHK(J)
           do jj=1,ne
C     trap problems with p3 symmetry to give rectangular axes
           ihjj=he(jj)
           ikjj=ke(jj)
           if(p3flag)call p3exp(ihjj,ikjj,he(jj),ke(jj))
           ihjj=ihjj+n1c
           ikjj=ikjj+n2c
           ind=(ikjj-1)*n1+ihjj
           C(ind)=f
           END DO
         ENDDO
 
         CALL SPOS (N1,N2,M,C)
C     Outer loop for target reflections
         pres=0.
         psum=0
         nuse=nref
         if(mode .eq. 1)nuse=0
         DO I=1,NPAD
C       Average over equivalent reflections
         call equiv2(he,ke,ise,ih(i),k(i),ne,symm)
         w1=0.
         nnn=0
         do jt=1,ne
           ihjj=he(jt)
           ikjj=ke(jt)
C     trap problems with p3 symmetry to give rectangular axes
         if(P3FLAG)call p3exp(ihjj,ikjj,he(jt),ke(jt))
          ih1=ihjj+n1c
          ik1=ikjj+n2c
          ind=(ik1-1)*n1+ih1
          w1=w1+c(ind)
          nnn=nnn+1
         enddo
         if(w1 .gt. 1D-10)then
                w1=sqrt(w1/dble(nnn))
         else
                w1=0
         endif
C         write(10,*)ih(i),k(i),w1,fhk(i),nnn
         if(i .ne. nref)then
                pres=pres+abs(fhk(i)-w1)
                psum=psum+fhk(i)
         endif
         if(i.gt.nuse)fhk(i)=w1
C        ENDDO
C
        enddo
        tpatt = pres/psum*10
C        write(10,*)'Patterson Residue ',pres/(npad-nlow+1)
        return
        end
       SUBROUTINE SPOS (N1, N2, M, C)
C
C      Evaluate the window for a simple MaxEnt term
C      Also return the window width as arad
C
         INTEGER M(3), N1, N2
         REAL*8 XI, BCUT
         COMPLEX C(*) 
         BCUT = 1.d0/dble(n1*n2)
C
C     Do a negative FFT
         CALL FFT2DN (C)
C
         MF = (-1)
         JK = 0
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO J=1,N1
             JK=JK+1
             NF = -NF
             XI = C(JK)
             IF(NF .LT. 0)then
                XI = min(0.d0,XI)
C                IF(XI .gt. -BCUT)XI=0
             ELSE
                XI = max(0.d0,XI)
C                IF(XI .lt. BCUT) XI=0
             ENDIF
           END DO
         END DO
         CALL FFT2DP (C)
         RETURN
       END

