	program average(filen)
C
C  Copyright (c) 2003 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
        implicit real*8 (a-h,o-z)
	character*80 filen
	character*4 symm
	integer he(20),ke(20),ise(20)
C	dimension vals(20)
	parameter (nb=80)
	dimension data(-nb:nb,-nb:nb)
	dimension err(-nb:nb,-nb:nb)
        dimension datan(2000),ihn(2000),ikn(2000)
        dimension error(2000),ngot(2000)
        dimension wrk1(40),wrk2(40)
	data=-1
	err=0
	open(unit=10,file=filen)
	open(unit=11,file='output.dat')
        nold=0
        nnew=0
	do j=1,99999
	read(10,*,end=20,err=20)i1,i2,i3,f,e
	if(abs(i1).gt.nb)goto 9991
	if(abs(i2).gt.nb)goto 9991
	data(i1,i2)=f
	err(i1,i2)=e
        nold=nold+1
	enddo
20	write(6,1)'Enter Symmetry'
1	format(a,' _',$)
	read(5,2)symm
2	format(a)
	if(symm.eq.'p6mm')then
		i1low=0
		i1up=nb
		icode=1
	else
		write(6,*)'Need to write limits!'
		call exit(0)
	endif
	do j=0,nb
	 do k=0,j
	  if(data(j,k).gt.-0.5)then
C	  Find equivalent reflections
	  i1=j
	  i2=k
	  call equiv2(he,ke,ise,i1,i2,ne,symm)
	  m=0
	  s1=0
	  s2=0
	  sm=0
	  do n=1,ne
	 	t=data(he(n),ke(n))
	 	e=err(he(n),ke(n))
	 	if(t.gt.-0.5)then
	 		s1=s1+t/e
	 		s2=s2+1.D0/e
	 		data(he(n),ke(n))=-1
	 		m=m+1
                        wrk1(m)=t
                        wrk2(m)=e
	 	endif
	  enddo
          nnew=nnew+1
          val=s1/s2
          er=sqrt(dble(m))/s2
	  datan(nnew)=val
	  error(nnew)=er
C       Chi trap
        if(m.gt.1)then
                s1=0
                do i=1,m
                        s1=s1+abs(val-wrk1(i))/wrk2(i)
                enddo
                s2=max(1.d0,s1/m)
                error(nnew)=error(nnew)*s2
        endif
          ihn(nnew)=j
          ikn(nnew)=k
          ngot(nnew)=m
        endif
        enddo
        enddo
C        rscale=sqrt(dble(nold/nnew))
        do j=1,nnew
C        error(j)=error(j)*rscale
	  write(11,10)ihn(j),ikn(j),0,datan(j),0,error(j),
     1    ngot(j)
	  enddo
10	format(3i4,f16.7,f8.1,f16.7,i4)
	stop
9991	write(6,*)'Dying, beams too far out!'
	end
	include 'centered.f'
		 
	
