#include "TFileViewDialog.h"
#include <string.h>																		
extern	void PutMessage(char *) ;
extern	void ProcessModalEvent(XEvent *event) ;	
		
TFileViewDialog::TFileViewDialog(char *filename) :TXForm(filename) {

	DefineForm() ;
	fl_set_object_callback(mReturn,TFileViewDialog::DoClick,(long)this) ;

	mPlacement = FL_PLACE_CENTERFREE ;
	mBorder = FL_FULLBORDER ;
	strcpy(mFileName,filename) ;

	if (Load()) {
		Show() ;
	}
	else 
		mIsValid = false ;
}

void	TFileViewDialog::DefineForm() {
	FL_OBJECT *obj;

	mXForm->mForm = fl_bgn_form(FL_NO_BOX, 500, 315);
	obj = fl_add_box(FL_UP_BOX,0,0,500,315,"");
	mReturn = fl_add_button(FL_NORMAL_BUTTON,410,280,80,25,"Close");
	mFileView = fl_add_browser(FL_NORMAL_BROWSER,10,10,480,260,"");
	fl_end_form();
	mXForm->mForm->fdui = mXForm ;
	fl_set_clipping(0,0,500, 315) ;

}

Boolean	TFileViewDialog::Load() {
	return (fl_load_browser(mFileView,mFileName)) ;
}


void 	TFileViewDialog::DoClick(FL_OBJECT *obj,long arg) {
	TFileViewDialog	*theForm = (TFileViewDialog *)arg ;

	if (obj == theForm->mReturn) {
		delete theForm ;
	}
}

TFileViewDialog::~TFileViewDialog() {
}
