#ifndef __TRefineParametersPage_H
#define __TRefineParametersPage_H
#include "TWindow.h"
#include "TPage.h"
#include "TButton.h"

class	TRefineParametersPage : public TPage {
	public:
		TRefineParametersPage(TWindow *window = nil) ;
		~TRefineParametersPage() ;
		void	Initialize() ;
		void	Draw() ;
		void	DoMouseDownInObject(TObject *obj,Point *pt) ;
	private:

		TButton			*mSetComparisonRegion ;
		TButton			*mRefine ;
		TButton			*mCancel ;
		TRadioButton	*mCCC ;
		TRadioButton	*mChiSquare ;
		TRadioButton	*mFourierAmplitudes ;

		TCheckBox		*mCreateLogFile ;

		TButton			*mHelp ;

		TCheckBox		*mThickness ;
		TCheckBox		*mDefocus ;
		TCheckBox		*mCs ;
		TCheckBox		*mDelta ;
		TCheckBox		*mConvergence ;
		TCheckBox		*mCrystalTilt ;
		TCheckBox		*m2FoldAstigmatism ;
		TCheckBox		*m3FoldAstigmatism ;


		TEditText		*mStartingTemp ;
		TEditText		*mEndingTemp ;
		TEditText		*mFraction ;
		TEditText		*mAttemptsPerTemp ;
		TEditText		*mSuccesfulAttempts ;

		TEditText		*mStartThickness ;
		TEditText		*mStartDefocus ;
		TEditText		*mStartingCs ;
		TEditText		*mStartingDelta ;
		TEditText		*mStartingConvergence ;

		TEditText		*mDeltaThickness ;
		TEditText		*mDeltaDefocus ;
		TEditText		*mDeltaCs ;
		TEditText		*mDeltaDelta ;
		TEditText		*mDeltaConvergence ;

		TEditText		*mStartCrystalTiltValue ;
		TEditText		*mStartCrystalTiltAngle ;
		TEditText		*mDeltaCrystalTiltValue ;
		TEditText		*mStarting2FAstigValue ;
		TEditText		*mStarting2FAstigAngle ;
		TEditText		*mDelta2FAstigValue ;
		TEditText		*mStarting3FAstigValue ;
		TEditText		*mStarting3FAstigAngle ;
		TEditText		*mDelta3FAstigValue ;

} ;

#endif

