#ifndef __COMMANDS__
#define __COMMANDS__
#include "layers.h"
#include "types.h"
/* Declare functions */
void DisplayQuantitativeMenu() ;
void LoadExperimentalImage() ;
void LoadStandardDeviationImage() ;
void CompareWithSimulation() ;
void ShowCompareAndRefineParameterPage() ;
void ShowCompareAndRefineStructurePage() ;
void ReturnFromQuantitativeMenu() ;
long semdat() ;
long semdet() ;
void set_elfactors() ;
void set_xrayfactors() ;
void SetNormalMontage() ;
void set_halftone() ;
void set_solid() ;
void SetCustomMontage() ;
void SetPrintToPrinter() ;
void SetPrintToFile() ;
void SetAsciiFile() ;
void SetBinaryFile() ;
void SetSubPhase() ;
void SetNoSubPhase() ;
void set_recipspace() ;
void set_realspace() ;
void set_quantitative_menu() ;
void set_laswrit_cntrst() ;
void set_diffpt_cntr() ;
void set_toleranse() ;
void set_dp_theta() ;
void SetNoOverLayAtoms() ;
void SetOverLayAtoms() ;
void run_help() ;
void ret_switch() ;
void set_erase() ;
void set_noerase() ;
void set_montage() ;
void set_nomontage() ;
void set_mont_space() ;
void set_nomont_space() ;
void set_titles() ;
void set_notitles() ;
void set_aperture() ;
void set_noaperture() ;
void set_ctf_autoscale() ;
void set_ctf_absscale() ;
void set_abs_scale() ;
void set_auto_scale() ;
void set_ampl_autoscale() ;
void set_ampl_absscale() ;
void SetDisplayValues() ;
void SetPrintValues() ;
void set_req_pos() ;
void set_noreq_pos() ;
void fb_crt_erase() ;
void set_pseudo_slice() ;
void set_ull_slice() ;
void set_min_int() ;
void set_min_fft_int() ;
void set_camera_length() ;
void ret_switch() ;
void fb_crt_erim() ;
void fb_crt_ergra() ;
void fb_crt_store_image() ;
void fb_crt_wr_txt() ;
void fb_crt_mod_lut() ;
void fb_crt_dir() ;
void fb_crt_display() ;
void fb_crt_index() ;
void fb_crt_screen() ;
void fb_crt_laser() ;
void r_stemdxw() ;
void set_min_int() ;
void change_par() ;
void modify_par(long) ;
void show_at() ;
void show_so() ;
void run_phsgrt() ;
void run_mslice() ;
void run_image() ;
void r_display() ;
void chng_at() ;
void del_at() ;
void r_upd_rename() ;
void r_upd() ;
void r_no_upd() ;
double get_float() ;
long get_int() ;
void add_at() ;
void ret_at() ;
void fw_at() ;
void rw_at() ;
void chng_so() ;
void add_so() ;
void del_so() ;
void fw_so() ;
void rw_so() ;
void ret_so() ;
void run_ampli() ;
void run_prog() ;
void terminateNcemss() ;
void displ_atoms() ;
void view_o_file() ;
void r_diff() ;
void r_pot() ;
void r_exwf() ;
void r_image() ;
void r_hist() ;
void r_adj_cntrst() ;
void adj_cntrst() ;
void r_filter() ;
void r_add_unit_cells() ;
void add_unit_cells() ;
void r_zoom() ;
void zoom_c() ;
void r_histeq() ;
void r_expim() ;
void cel_persp() ;
void cel_nopersp() ;
void nucel_persp() ;
void nucel_nopersp() ;
void r_cancel() ;
void r_exe() ;
void r_fft() ;
void r_fftinv() ;
void mod_atom(long) ;
void vu_std_cell() ;
void vu_new_cell() ;
void r_atom3d() ;
void dis_at() ;
void r_ret5() ;
void r_ret6() ;
void r_ret7() ;
void r_ret8() ;
void r_dsply() ;
void run_ctfplot() ;
void displ_hist() ;
void histeq() ;
void ret_basis() ;
void inccntr() ;
void deccntr() ;
void filter() ;
void cfft() ;
void cfftinv() ;
void dsply() ;
void GetPotential() ;
void GetExitWave() ;
void diffr() ;
void dispfft() ;
void modify_cntrst() ;
void r_page() ;
void r_ret8() ;
void GetImage() ;
void r_terminal() ;
void r_lp() ;
void r_semper() ;
void fb_crt_toggle() ;
void UsePoolFile() ;
void DoNotUsePoolFile() ;
void getxim() ;
void action1() ;
void show_basis() ;
void show_symop() ;
void mod_symop(long) ;
void r_def_layer() ;
void r_del_layer() ;
void r_deposit() ; 
void r_insert() ;
void r_remove() ;
void r_repeat() ;
void mod_pg() ;
void rem_pg() ;
void r_reset() ;
void r_ret_lay() ;
void r_v_comp() ;
void r_v_pgfls() ;
void r_unass() ;
void ret_cnstrct() ;
void add_x_unit_cells() ;
void add_y_unit_cells() ;
void dis_new_cell() ;
void r_sngl_layered() ;
void r_disp_files() ;
void r_exit() ;
void r_fl_exit() ;
void r_prev_page() ;
void r_next_page() ;
void r_old_fl() ;
void r_new_fl() ;
void set_file() ;
void SetDirectory() ;
void r_loc_fls() ;
void r_com_fls() ;
void r_lay_fls() ;

/* Define all the commands that NCEMSS can run */
/* -----------------------------------------------------------------------*/

/* Main parameter menu */
/* ------------------- Begin MAIN INFORMATIONAL Menu ---------------------*/
COMMAND ch_par    = {4,60,155,115,"CHANGE",
   "First hit activates the variables above for change. Second hit deactivates"
       ,(FPVI)change_par} ;
COMMAND run_p     = {4,0,155,55,"RUN",
     "To start the calculation of the image, starting with the first program \
affected by any changes",(FPVI)run_prog} ;
COMMAND c_basis   = {160,60,385,115,"SHOW BASIS",
   "Display of coordinates of basis atoms and symmetry operators",(FPVI)show_basis} ;
COMMAND c_v_pg    = {160,60,385,115," NO FUNCTION",
                     "Presently unassigned",(FPVI)r_unass} ;
COMMAND c_atoms   = {160,0,385,55,"SHOW ATOMS",
    "Display of coordinates of all atoms and drawing of unit cells",(FPVI)show_at} ;
COMMAND run_pg    = {390,60,545,115,"PHSGRT",
                    "To start the calculation of the integrated potential"
                     ,(FPVI)run_phsgrt} ;
COMMAND run_ms    = {390,0,545,55,"MSLICE",
     "Calculate the electron wacefunction at the exit surface of the specimen",
                     (FPVI)run_mslice} ;
COMMAND run_im    = {550,60,715,115,"IMAGE",
    "Compute the image from the exit wave function taking account of the lens",
                     (FPVI)run_image} ;
COMMAND run_a     = {550,0,715,55,"AMPLIT",
        "Display of calculated amplitudes and phases vs thickness if requested"
                     ,(FPVI)run_ampli} ;
COMMAND v_file    = {720,0,885,55,"VIEW FILE",
                   "View the informational output file from PHSGRT or, MSLICE "
                     ,(FPVI)view_o_file} ;
COMMAND c_display = {720,60,885,115,"DISPLAY",
          "Display of the computed image,Diffr.Pt.,Potential,etc.",(FPVI)r_display} ;
COMMAND run_ctf   = {890,60,1015,115,"CTF",
   "Plots the Contrast Transfer Function for current settings of Cs,Def.,etc.",
                     (FPVI)run_ctfplot} ;
COMMAND exit_p    = {890,0,1015,55,"RETURN"," Return to previous menu ",
                     (FPVI)terminateNcemss} ;
/* ------------------- End MAIN INFORMATIONAL Menu ---------------------*/
/* In addition the following commands substitute in Construct PG seq. menu ---*/
COMMAND c_v_comp  = {160,0,385,55,"SET COMPOS.",
                    "View and modify the sequence of individual PG layers",
                     (FPVI)r_v_comp} ;
COMMAND c_unass   = {390,60,545,115,"NO FUNC.",
                    " Presently unassigned"
                     ,(FPVI)r_unass} ;
COMMAND c_num_lay = {4,570,475,596,"Number of unique layers : ","",
                            (FPVI)modify_par} ;
COMMAND c_num_slc = {520,570,1000,596,"Total number of slices : ","",
                     (FPVI)modify_par} ;
COMMAND c_lay_names = {4,540,475,566,"Layer names : ","",(FPVI)modify_par} ;
COMMAND c_lay_thick = {520,540,475,566,"Layer thick. : ","",(FPVI)modify_par} ;
/* ------------------- End MAIN INFORMATIONAL LAYERED Menu ----------------*/

/* ------------------- Begin SHOW ATOMS menu ----------------------*/
COMMAND ch_at     = {4,0,145,55,"CHANGE",
"First hit activates the variables above for change. Second hit deactivates"
                     ,(FPVI)chng_at} ;
COMMAND ad_at     = {150,0,305,55,"ADD",
                    " Add an atom , Atom gets added to the end of the list "
                     ,(FPVI)add_at} ;
COMMAND de_at    = {310,0,445,55,"DELETE"," To delete an atom ",(FPVI)del_at} ;
COMMAND sh_at     = {4,0,420,55,"DISPLAY",
                 "Drawing of the unit cell from different directions",(FPVI)dis_at} ;
COMMAND re_at     = {855,0,1010,55,"RETURN",
                     "Return to main menu",(FPVI)ret_at} ;
COMMAND fwd_at    = {870,640,1010,702,"PAGE +",
                     "Display of the next 20 atom positions ",(FPVI)fw_at} ;
COMMAND rwd_at    = {870,538,1010,600,"PAGE -",
                     "Display of the previous 20 atom positions ",(FPVI)rw_at} ;
COMMAND c_page    = {870,436,1010,498,"PAGE #",
                     "Display of atom positions on page specified ",(FPVI)r_page} ;
/* -------------------- End SHOW ATOMS menu -------------------------*/
COMMAND re_basis   = {855,0,1010,55,"RETURN",
                     "Return to main menu",(FPVI)ret_basis} ;

/* -------------------- Begin DISPLAY UNIT CELLS Menu ---------------*/
COMMAND c_vucell  = {4,0,280,55,"UNIT CELL",
                    "To view the unit cell from any given direction "
                     ,(FPVI)vu_std_cell} ;
COMMAND c_vunucel = {285,0,575,55,"NEW UNIT CELL",
"View the unit cell that is being used by the calculation."
                     ,(FPVI)vu_new_cell} ;
COMMAND c_atom3d  = {580,0,845,55,"UNIMPLEMENTED",
                    "3D atom drawing routine for the frame-buffers   ",
                      (FPVI)r_atom3d} ;
/* -------------------- End DISPLAY UNIT CELLS Menu -----------------*/

/* -------------------- Begin CHANGE SYMMOP Menu --------------------*/
COMMAND ch_so     = {4,0,265,55,"CHANGE SYMMOP",
"First hit activates the variables above for change. Second hit deactivates"
                     ,(FPVI)chng_so} ;
COMMAND ad_so     = {270,0,535,55,"ADD SYMMOP",
     "Add a symmetry operator. It gets added to the end of the list "
                     ,(FPVI)add_so} ;
COMMAND de_so     = {540,0,805,55,"DELETE SYMMOP",
                    "To delete a symmetry operator from the list.",(FPVI)del_so} ;
COMMAND c_symop     = {460,0,700,55,"SHOW SYMM. OP",
                    "To display the list of the symmetry operators.",
                     (FPVI)show_symop} ;
COMMAND re_so     = {855,0,1010,55,"RETURN",
                     "Return to main menu",(FPVI)ret_so} ;
COMMAND fwd_so    = {870,640,1010,702,"PAGE +",
                     "Display of the next 40 symm. operators ",(FPVI)fw_so} ;
COMMAND rwd_so    = {870,538,1010,600,"PAGE -",
                     "Display of the previous 40 atom positions ",(FPVI)rw_so} ;
/* ------------------- End CHANGE SYMMOP Menu ----------------------*/


/* ------------------- Begin MAIN DISPLAY Menu ------------------------- */
/* ---- SOURCE ---- */
COMMAND c_expim   = {4,40,170,120,"EXP. IMAGE",
                    "Pick up a specified experimental image ",(FPVI)r_expim} ;
COMMAND c_image   = {4,150,170,245,"IMAGE",
                    "Pick up the computed Image ",(FPVI)r_image} ;
COMMAND c_diff    = {4,255,170,350,"DIFFR.PAT."," Pick up Diffr. Pt. "
                     ,(FPVI)r_diff} ;
COMMAND c_exwf    = {4,360,170,455,"EXIT-WF",
                     "Pick up the exit wave_function ",(FPVI)r_exwf} ;
COMMAND c_pot     = {4,465,170,560,"POTENTIAL",
                    "Pick up the integrated (projected)  Potential ",(FPVI)r_pot} ;

/* ---- OPERATIONS ----- */
COMMAND c_hist    = {380,465,520,560,"HISTOGR",
                    "Calculate the histogram distribution ",(FPVI)r_hist} ;
COMMAND c_histeq  = {380,360,520,455,"HIST.EQ.",
                    "Histogram equalize the image ",(FPVI)r_histeq} ;
COMMAND c_adj_cnt = {530,255,670,350,"ADJ.CNT",
                    "Adjust contrast and brightness levels."
                     ,(FPVI)r_adj_cntrst} ;
COMMAND c_filter  = {380,40,520,120,"UNUSED",
                    "Presently not used ",(FPVI)r_unass} ;
COMMAND c_fft     = {380,255,520,350,"FFT",
                    "Compute the FFT of the specified source ",(FPVI)r_fft} ;
COMMAND c_unused  = {380,150,520,245,"UNUSED",
                    "Currently unassigned",(FPVI)r_unass} ;
COMMAND c_add_cells = {530,465,670,560,"#UN.CLS",
         "Specify the number of unit cells to be displayed in each direction",
                      (FPVI)r_add_unit_cells} ;
COMMAND c_zoom      = {530,360,670,455,"ZOOM",
                     "Zoom the image by a given factor ",(FPVI)r_zoom} ;
COMMAND c_dsply   = {530,150,670,245,"DISPLAY",
                    "Display the result ",(FPVI)r_dsply} ;
COMMAND c_cancel  = {850,150,1010,245,"CANCEL",
                    "Cancel the sequence of commands ",(FPVI)r_cancel} ;
COMMAND c_exe     = {850,465,1010,560,"EXECUTE",
"Execute the sequence of commands; required to show the result of all \
specified operations",(FPVI)r_exe} ;
COMMAND c_lp       = {340,720,670,760,"LASERPRINTER",
                              "Output to the Laser Printer",
                              (FPVI)r_lp,OFF,OFF} ;
COMMAND c_terminal  = {4,720,330,760,"WORKSTATION","Output to the Workstation",
                       (FPVI)r_terminal,OFF,ON} ;
COMMAND c_semper    = {450,720,670,760,"SEMPER",
  " Output of images into SEMPER dump/restore format",(FPVI)r_semper,OFF,OFF} ;
COMMAND c_dis_toggle= {4,675,670,715,
                              "CHANGE DEFAULTS AND RUN MISC. FUNCTIONS",
             "Various commands to manipulate the display and change defaults ",
                       (FPVI)fb_crt_toggle} ;
COMMAND c_quantitative_menu  = {4,570,670,630,"QUANTITATIVE COMPARISON/REFINEMENT",
				"Run Quantitative Functions",
                       (FPVI)DisplayQuantitativeMenu} ;

/* ------------------- End MAIN DISPLAY Menu ------------------------- */


/* ------------------- Begin Quantitative Menu -------------------- */
COMMAND c_loadExperimentalImage  = {10,690,490,740,"Load Experimental Image",
				"Load An Experimental Image",
                       (FPVI)LoadExperimentalImage} ;
COMMAND c_loadStandardDeviationImage  = {510,690,990,740,"Load Standard Deviation Image",
				"Load Standard Deviation Image",
                       (FPVI)LoadStandardDeviationImage} ;
COMMAND c_compareImageWithSimulation  = {10,100,330,150,"Compare Image with Simulation",
				"Compare Experimental Image with Simulation",
                       (FPVI)CompareWithSimulation,OFF,OFF,ON} ;
COMMAND c_refineParameters  = {340,100,660,150,"Refine Parameters",
				"Refine Imaging Parameters",
                       (FPVI)ShowCompareAndRefineParameterPage,OFF,OFF,ON} ;
COMMAND c_refineStructure  = {670,100,990,150,"Refine Structure",
				"Refine Atomic Coordinates",
                       (FPVI)ShowCompareAndRefineStructurePage,OFF,OFF,ON} ;
COMMAND c_returnFromQuantitativeMenu   = {840,0,990,55,"RETURN",
                     "Return to miscellaneous menu",(FPVI)ReturnFromQuantitativeMenu} ;

/* ------------------- End Quantitative Menu -------------------- */


/* ------------------- Begin ADJUST CONTRAST Menu -------------------- */
COMMAND c_down_brite = {100,40,195,90,"DECR.",
                               "Decrease brightness of the image",
                               (FPVI)modify_cntrst} ;
COMMAND c_up_brite   = {200,40,295,90,"INCR.",
                               "Increase brightness of the image",
                                (FPVI)modify_cntrst} ;
COMMAND c_down_cntrst = {820,130,915,180,"DOWN",
                        "Decrease contrast in the image ",
                        (FPVI)modify_cntrst} ;
COMMAND c_up_cntrst = {920,130,1000,180,"UP",
                              "Increase contrast in the image",
                               (FPVI)modify_cntrst} ;
COMMAND c_blkwht    = {100,700,370,750,"SET BLACK-WHITE",
  "Manually set beginning and end point of contrast curve ",(FPVI)modify_cntrst} ;
/* ------------------- End ADJUST CONTRAST Menu ------------------------ */


/* -------------------- Begin CONSTRUCT PG-SEQUENCE Menu ------------- */
COMMAND c_deposit = {850,535,1010,580,"DEPOSIT",
"Deposit a certain thickness of a specified layer",(FPVI)r_deposit} ;
COMMAND c_insert  = {850,480,1010,525,"INSERT",
"Insert a specified layer thickness at a specified thickness",(FPVI)r_insert} ;
COMMAND c_repeat  = {850,425,1010,470,"REPEAT",
                           "Repeat the already specified sequence.",
                            (FPVI)r_repeat} ;
COMMAND c_remove  = {850,370,1010,415,"REMOVE",
"This activates the PG sequence numbers, so they can be deleted.",
                     (FPVI)r_remove} ;
COMMAND c_reset   = {850,315,1010,360,"RESET",
                     "Reset the specimen to 0 thickness",(FPVI)r_reset} ;
COMMAND c_def_lay = {850,680,1010,730,"DEF LAY",
                     "Define a new layer",(FPVI)r_def_layer} ;
COMMAND c_del_lay = {850,610,1010,660,"DEL LAY",
                     "Delete an already defined layer",(FPVI)r_del_layer} ;
COMMAND c_ret_lay = {850,0,1010,40,"RETURN","Return to main menu",
                            (FPVI)r_ret_lay} ;
COMMAND pg[MAXLAYERS] ;
COMMAND pgseq[MAXSLICES] ;
/* -------------------- End CONSTRUCT PG-SEQUENCE Menu ------------- */

/* ------------- Begin PERSP/NOPERS. in New Unit Cell Menu ---------------- */
COMMAND c_psp_3 = {285,0,430,55,"NO PERSP","Without perspective ",
                   (FPVI)nucel_nopersp} ;
COMMAND c_psp_4 = {430,0,575,55,"PERSP.","With perspective ",
                          (FPVI)nucel_persp} ;
/* ------------- End PERSP/NOPERS. in New Unit Cell Menu ---------------- */

/* ------------- Begin PERSP/NOPERS. in View the Unit Cell Menu --------- */
COMMAND c_psp_1 = {4,0,140,55,"NO PERSP","Without perspective ",
                          (FPVI)cel_nopersp} ;
COMMAND c_psp_2 = {140,0,280,55,"PERSP.","With perspective ",(FPVI)cel_persp} ;
/* ------------- End PERSP/NOPERS. in View the Unit Cell Menu ----------- */

/* -------------- Begin the UPDATE/NO_UPDATE Menu ----------------------- */
COMMAND c_upd_rename = {4,0,300,55,"UPDATE & RENAME",
                 "Update the atom file and rename it",(FPVI)r_upd_rename} ;
COMMAND c_upd = {700,0,1000,50,"UPDATE FILE","Updates the atom file",
                        (FPVI)r_upd} ;
COMMAND c_no_upd = {350,0,650,55,"DO NOT UPDATE","Exit without updating",
                    (FPVI)r_no_upd} ;
/* -------------- End the UPDATE/NO_UPDATE Menu ----------------------- */

/* -------------- Begin the UPDATE/NO_UPDATE Menu ----------------------- */
COMMAND c_use_file = {4,0,475,100,"USE DATA FILE",
   "Use this file. All associated files will be copied to your directory",
                      (FPVI)UsePoolFile} ;
COMMAND c_nouse_file = {525,0,1000,100,"DO NOT USE","Return",
                               (FPVI)DoNotUsePoolFile} ;
/* -------------- End the UPDATE/NO_UPDATE Menu ----------------------- */

/* -------------- Begin CRT-TOGGLE SWITCHES menu --------------------- */
/* -------------- Begin FB-TOGGLE SWITCHES menu --------------------- */
COMMAND c_erase = {4,724,240,760,"SET ERASE","",(FPVI)set_erase,OFF,ON} ;
COMMAND c_noerase = {240,724,480,760,"SET NOERASE","",(FPVI)set_noerase,
                            OFF,OFF} ;
COMMAND c_montage = {240,684,480,720,"SET MONTAGE","",(FPVI)set_montage,
                            OFF,OFF} ;
COMMAND c_nomontage = {4,684,240,720,"SET NOMONTAGE","",(FPVI)set_nomontage,
                              OFF,ON} ;
COMMAND c_req_pos = {240,644,480,680,"SET REQ_POS","",(FPVI)set_req_pos,
                            OFF,OFF} ;
COMMAND c_noreq_pos = {4,644,240,680,"SET NOREQ_POS","",(FPVI)set_noreq_pos,
                              OFF,ON} ;
COMMAND c_mont_space = {240,604,480,640,"MONTAGE-SPACE",
                       " Specify a seperation between images that are montaged",
                       (FPVI)set_mont_space,OFF,OFF} ;
COMMAND c_nomont_space = {4,604,240,640,"NOMONT-SPACE",
                    " Specify no seperation between images that are montaged",
                       (FPVI)set_nomont_space,OFF,ON} ;
COMMAND c_abs_scale = {240,564,480,600,"INT.ABS-SCALE",
                        "Specify min and max intensity values",
                         (FPVI)set_abs_scale,OFF,OFF} ;
COMMAND c_auto_scale = {4,564,240,600,"INT.AUTO-SCALE",
                        "Automatically scale min and max intensity values",
                         (FPVI)set_auto_scale,OFF,ON} ;
COMMAND c_ctf_autoscale = {4,524,240,560,"CTF-AUTOSCALE",
  "The X-axis is automatically scaled for each CTF plot",(FPVI)set_ctf_autoscale,
                           OFF,ON} ;
COMMAND c_ctf_absscale = {240,524,480,560,"CTF-ABS.SCALE",
  "The X-axis is set by the user for each CTF plot",(FPVI)set_ctf_absscale,
                           OFF,OFF} ;
COMMAND c_elScattFact = {4,484,240,520,"EL.SCATT.FACT.",
  "Perform the calc. of the proj. pot. using el. scatt. factors",(FPVI)set_elfactors,
                           OFF,ON} ;
COMMAND c_xrayScattFact = {240,484,480,520,"XRAY FACTORS",
  "Perform the calc. of the proj. pot. x-ray factors",(FPVI)set_xrayfactors,
                           OFF,OFF} ;
COMMAND c_recipspace = {4,484,240,520,"PG-REC_SP",
  "Perform the calc. of the proj. pot. in reciprocal space",(FPVI)set_recipspace,
                           OFF,ON} ;
COMMAND c_realspace = {240,484,480,520,"PG-REAL_SP",
  "Perform the calc. of the proj. pot. in real space",(FPVI)set_realspace,
                           OFF,OFF} ;
COMMAND c_set_aperture = {4,414,240,450,"APERTURE",
 "Diffraction plots are drawn with objective lens aperture superimposed",
                          (FPVI)set_aperture,OFF,ON} ;
COMMAND c_set_noaperture = {240,414,480,450,"NO_APERTURE",
 "Diffraction plots are drawn without objective lens aperture superimposed",
                          (FPVI)set_noaperture,OFF,OFF} ;
COMMAND c_set_titles = {4,374,240,410,"TITLES",
 "Cause titles to be output together with the image.-MONTAGE-has no titles",
                       (FPVI)set_titles,OFF,OFF} ;
COMMAND c_set_notitles = {240,374,480,410,"NO TITLES",
 "Supress titling of images. MONTAGE has no titles regardless of this switch",
                       (FPVI)set_notitles,OFF,ON} ;
COMMAND c_set_pseudo_slice = {4,334,240,370,"2D-POT.SLICE",
 "Use the average potential for each slice to avoid pseudo-ull-effects",
                              (FPVI)set_pseudo_slice,OFF,ON} ;
COMMAND c_set_ull_slice = {240,334,480,370,"3D-POT.SLICE",
 "Integrate over the 3-dim. potential to get the phasegrating for each slice",
                           (FPVI)set_ull_slice,OFF,OFF} ;
COMMAND c_set_min_int = {4,294,480,330,"SET MIN. INTENSITY (LENS)",
"Set the minimum intensity to include in the image calculation (thru the lens)",
                         (FPVI)set_min_int} ;
COMMAND c_set_min_fft_int = {4,254,480,290,"SET MIN.INT.TO DISPLAY(FFT)",
 "Set the minimum intensity to display in the diffraction pattern",
                         (FPVI)set_min_fft_int} ;
COMMAND c_set_camera_length = {4,214,480,250,"SET CAMERA LENGTH","",
                         (FPVI)set_camera_length} ;
COMMAND c_index = {4,174,480,210,"INDEX DIFFR.PT.",
                   "Index a newly drawn diff. patt.",(FPVI)fb_crt_index} ;
COMMAND c_set_dp_cntr = {4,134,480,170,"CHANGE CENTER OF DIFFR.PT.",
 "Change the x,y loc. of the center of diffr.pt. and opt.diff.pt",
                         (FPVI)set_diffpt_cntr} ;
COMMAND c_cloc = {4,94,480,130,"READ THE CURSOR POSITION",
                 "Readback of cursorposition",(FPVI)r_stemdxw} ;
COMMAND c_set_halftone = {4,54,240,90,"SHADING",
 "Cause atoms and diffraction patterns to be drawn as shaded spheres/circles.",
                       (FPVI)set_halftone,OFF,ON} ;
COMMAND c_set_solid = {240,54,480,90,"SOLID",
 "Cause atoms and diffraction patterns to be drawn as solid spheres/circles.",
                       (FPVI)set_solid,OFF,OFF} ;
/* ----------------  End left side of page ------------------------------ */
COMMAND c_erase_screen = {500,724,980,760,"ERASE THE DISPLAY","",
                          (FPVI)fb_crt_erase} ;
COMMAND c_text = {500,684,980,720,"WRITE TEXT ON THE DISPLAY",
                 "Write text on the image display",(FPVI)fb_crt_wr_txt} ;
COMMAND c_store = {500,644,980,680,"STORE PARTS OF THE DISPLAY",
                  "Store a portion of the image display in a file",
                   (FPVI)fb_crt_store_image} ;
COMMAND c_displ = {500,604,980,640,"DISPLAY STORED IMAGE",
                  "Display of a stored image (*.im)",(FPVI)fb_crt_display} ;
COMMAND c_lprint = {500,564,980,600,"PRINT A STORED IMAGE",
                  "Send a stored image (*.im) to the LaserWriter",
                   (FPVI)fb_crt_laser} ;
COMMAND c_screen = {500,524,980,560,"PRINT THE SCREEN",
                  "Print the Image screen to the LaserWriter",
                   (FPVI)fb_crt_screen} ;
COMMAND c_dir = {500,484,980,520,"LIST STORED IMAGE-FILES",
                "Directory of *.im files containing stored images",(FPVI)fb_crt_dir} ;
COMMAND c_set_laswrit_cntrst = {500,414,980,450,"SET CONTRAST FOR LASERWRITER",
"Specify the contrast and brightness for the LasWr. when printing stored files",
                      (FPVI)set_laswrit_cntrst} ;
COMMAND cSetDpTheta = {500,374,980,410,"SET DIV.ANGLE FOR DP",
	"Set The angle of Divergence to use for plotting Diffr. Pt.",
	(FPVI)set_dp_theta} ;
COMMAND cSetNoOverLayAtoms = {500,334,740,370,"IMAGE ONLY",
	"Do not superimpose atompositions on the image",(FPVI)SetNoOverLayAtoms,
	OFF,ON} ;
COMMAND cSetOverLayAtoms = {740,334,980,370,"OVERLAY ATOMS",
	"Superimpose atompositions on the image",(FPVI)SetOverLayAtoms,OFF,OFF} ;
COMMAND cSetAmplAutoScale = {500,294,740,330,"AUTOSCALE",
	"Automatic scaling for displaying Pendell plots",
	(FPVI)set_ampl_autoscale,OFF,ON} ;
COMMAND cSetAmplAbsScale = {740,294,980,330,"FIXED",
	"Fix the scale (User Input) when displaying Pendell. plots",
	(FPVI)set_ampl_absscale,OFF,OFF} ;
COMMAND cDisplayValues = {500,254,740,290,"DISPLAY",
	"Images, Diffr. Patt., Plots are displayed as usual",
	(FPVI)SetDisplayValues,OFF,ON} ;
COMMAND cPrintValues = {740,254,980,290,"->FILE",
	"Image Data, Diffr. Data, amplitudes, etc are stored in a file",
	(FPVI)SetPrintValues,OFF,OFF} ;
COMMAND cSetSubPhase = {500,214,740,250,"REL.PHASE",
"Subtract off the phase the part that comes from traversing a mean pot.",
	(FPVI)SetSubPhase,OFF,ON} ;
COMMAND cSetNoSubPhase = {740,214,980,250,"PHASE",
	"Do not subtract off the phase from traversing a mean pot.",
	(FPVI)SetNoSubPhase,OFF,OFF} ;
COMMAND cSetAsciiFile = {500,174,740,210,"ASCII FILE",
	"Output Printed data to ASCII File.",
	(FPVI)SetAsciiFile,OFF,ON} ;
COMMAND cSetBinaryFile = {740,174,980,210,"BINARY FILE",
	"Output Printed data to BINARY File.",
	(FPVI)SetBinaryFile,OFF,OFF} ;
COMMAND cSetPrintToFile = {740,134,980,170,"OUT->FILE",
	"Output data to PostscriptFile.",
	(FPVI)SetPrintToFile,OFF,OFF} ;
COMMAND cSetPrintToPrinter = {500,134,740,170,"OUT->PRINTER",
	"Output data to Printer.",
	(FPVI)SetPrintToPrinter,OFF,ON} ;
COMMAND cSetNormalMontage = {500,94,740,130,"NORM. MONT.",
	"Default montage sequence (Defocus: horizontal, Thickness: Vertical",
	(FPVI)SetNormalMontage,OFF,ON} ;
COMMAND cSetCustomMontage = {740,94,980,130,"CUSTOM",
	"Custom Sequence for use in montaging images.",
	(FPVI)SetCustomMontage,OFF,OFF} ;
COMMAND c_ret_switches = {800,35,980,90,"RETURN","",(FPVI)ret_switch} ;
/* -------------- End CRT-TOGGLE-SWITCHES menu ----------------------- */
/* -------------- End FB-TOGGLE-SWITCHES menu ----------------------- */

/* --------------- The general HELP command ---------------------------	*/
COMMAND c_help     = {965,744,1020,780,"Help",
  "Help on current menu options",
                    (FPVI)run_help} ;

/* -------------- Some unidentified RETURN commands ------------------ */
COMMAND c_ret5    = {850,0,1010,55,"RETURN"," ",(FPVI)r_ret5} ;
COMMAND c_ret6    = {850,40,1010,95,"RETURN"," ",(FPVI)r_ret6} ;
COMMAND c_ret7    = {850,40,1010,95,"RETURN"," ",(FPVI)r_ret7} ;
COMMAND c_ret8    = {850,40,1010,95,"RETURN"," ",(FPVI)r_ret8} ;
/* -------------- End some unidentified RETURN commands -------------- */

/* -------------- Begin UNIFORM/LAYERED STRUCTURE Menu -------------- */
COMMAND c_sngle = {10,320,470,420,"SINGLE STRUCTURE",
 "The structure is uniform along the beam direction",(FPVI)r_sngl_layered} ;
COMMAND c_layered = {550,320,1010,420,"LAYERED STRUCTURE",
  "The structure requires different phase grating sequences",(FPVI)r_sngl_layered} ;
COMMAND c_exit = {850,0,1010,55,"EXIT","Exit the program",(FPVI)r_exit} ;
/* -------------- Begin UNIFORM/LAYERED STRUCTURE Menu -------------- */

/* -------------- Begin the PICK A STRUCTURE FILE Menu -------------- */
COMMAND c_old_fl = {4,0,400,55,"USE DISPLAYED FILE",
  "Hit and proceed to point at the structure file you want to pick up",
                    (FPVI)r_old_fl} ;
COMMAND c_new_fl = {450,0,850,55,"CREATE NEW FILE",
                    "Prompts for input for a new structure file",(FPVI)r_new_fl} ;
COMMAND c_loc_fls = {4,745,175,780,"PERSONAL","Personal files",(FPVI)r_loc_fls,
                     OFF,ON} ;
COMMAND c_com_fls = {175,745,350,780,"COMMON",
"Files that can be used as a template for further work",(FPVI)r_com_fls} ;

COMMAND c_SetDirectory = {370,745,560,780,"SET DIRECTORY","Change Directory for Local Files",(FPVI)SetDirectory} ;

COMMAND c_lay_fls = {4,745,350,780,"LAYERED FILES","",(FPVI)r_lay_fls,OFF,ON} ;
COMMAND c_prev_page = {580,745,750,780,"PREV. PAGE",
                       "Displays the previous page of structure names",
                       (FPVI)r_prev_page} ;
COMMAND c_next_page = {760,745,930,780,"NEXT PAGE",
                      "Displays the next page of structure names",(FPVI)r_next_page} ;
COMMAND c_fl_exit = {870,0,1010,55,"RETURN","Returns from this menu",
                       (FPVI)r_fl_exit} ;
/* -------------- End the PICK A STRUCTURE FILE Menu -------------- */




COMMAND par_symop[]  =  {
                        {100,680,399,706,"","",(FPVI)mod_symop} ,
                        {100,650,399,676,"","",(FPVI)mod_symop} ,
                        {100,620,399,646,"","",(FPVI)mod_symop} ,
                        {100,590,399,616,"","",(FPVI)mod_symop} ,
                        {100,560,399,586,"","",(FPVI)mod_symop} ,
                        {100,530,399,556,"","",(FPVI)mod_symop} ,
                        {100,500,399,526,"","",(FPVI)mod_symop} ,
                        {100,470,399,496,"","",(FPVI)mod_symop} ,
                        {100,440,399,466,"","",(FPVI)mod_symop} ,
                        {100,410,399,436,"","",(FPVI)mod_symop} ,
                        {100,380,399,406,"","",(FPVI)mod_symop} ,
                        {100,350,399,376,"","",(FPVI)mod_symop} ,
                        {100,320,399,346,"","",(FPVI)mod_symop} ,
                        {100,290,399,316,"","",(FPVI)mod_symop} ,
                        {100,260,399,286,"","",(FPVI)mod_symop} ,
                        {100,230,399,256,"","",(FPVI)mod_symop} ,
                        {100,200,399,226,"","",(FPVI)mod_symop} ,
                        {100,170,399,196,"","",(FPVI)mod_symop} ,
                        {100,140,399,166,"","",(FPVI)mod_symop} ,
                        {100,110,399,136,"","",(FPVI)mod_symop} ,
                        {505,680,799,706,"","",(FPVI)mod_symop} ,
                        {505,650,799,676,"","",(FPVI)mod_symop} ,
                        {505,620,799,646,"","",(FPVI)mod_symop} ,
                        {505,590,799,616,"","",(FPVI)mod_symop} ,
                        {505,560,799,586,"","",(FPVI)mod_symop} ,
                        {505,530,799,556,"","",(FPVI)mod_symop} ,
                        {505,500,799,526,"","",(FPVI)mod_symop} ,
                        {505,470,799,496,"","",(FPVI)mod_symop} ,
                        {505,440,799,466,"","",(FPVI)mod_symop} ,
                        {505,410,799,436,"","",(FPVI)mod_symop} ,
                        {505,380,799,406,"","",(FPVI)mod_symop} ,
                        {505,350,799,376,"","",(FPVI)mod_symop} ,
                        {505,320,799,346,"","",(FPVI)mod_symop} ,
                        {505,290,799,316,"","",(FPVI)mod_symop} ,
                        {505,260,799,286,"","",(FPVI)mod_symop} ,
                        {505,230,799,256,"","",(FPVI)mod_symop} ,
                        {505,200,799,226,"","",(FPVI)mod_symop} ,
                        {505,170,799,196,"","",(FPVI)mod_symop} ,
                        {505,140,799,166,"","",(FPVI)mod_symop} ,
                        {505,110,799,136,"","",(FPVI)mod_symop} 
                        } ;
COMMAND par_atoms[]  =  { 
                        {165,680,215,706,""," ",(FPVI)mod_atom} ,
                        {250,680,330,706,""," ",(FPVI)mod_atom} ,
                        {400,680,480,706,""," ",(FPVI)mod_atom} ,
                        {530,680,610,706,""," ",(FPVI)mod_atom} ,
                        {660,680,740,706,""," ",(FPVI)mod_atom} ,
                        {760,680,820,706,""," ",(FPVI)mod_atom} ,
                        {165,650,215,676,""," ",(FPVI)mod_atom} ,
                        {250,650,330,676,""," ",(FPVI)mod_atom} ,
                        {400,650,480,676,""," ",(FPVI)mod_atom} ,
                        {530,650,610,676,""," ",(FPVI)mod_atom} ,
                        {660,650,740,676,""," ",(FPVI)mod_atom} ,
                        {760,650,820,676,""," ",(FPVI)mod_atom} ,
                        {165,620,215,646,""," ",(FPVI)mod_atom} ,
                        {250,620,330,646,""," ",(FPVI)mod_atom} ,
                        {400,620,480,646,""," ",(FPVI)mod_atom} ,
                        {530,620,610,646,""," ",(FPVI)mod_atom} ,
                        {660,620,740,646,""," ",(FPVI)mod_atom} ,
                        {760,620,820,646,""," ",(FPVI)mod_atom} ,
                        {165,590,215,616,""," ",(FPVI)mod_atom} ,
                        {250,590,330,616,""," ",(FPVI)mod_atom} ,
                        {400,590,480,616,""," ",(FPVI)mod_atom} ,
                        {530,590,610,616,""," ",(FPVI)mod_atom} ,
                        {660,590,740,616,""," ",(FPVI)mod_atom} ,
                        {760,590,820,616,""," ",(FPVI)mod_atom} ,
                        {165,560,215,586,""," ",(FPVI)mod_atom} ,
                        {250,560,330,586,""," ",(FPVI)mod_atom} ,
                        {400,560,480,586,""," ",(FPVI)mod_atom} ,
                        {530,560,610,586,""," ",(FPVI)mod_atom} ,
                        {660,560,740,586,""," ",(FPVI)mod_atom} ,
                        {760,560,820,586,""," ",(FPVI)mod_atom} ,
                        {165,530,215,556,""," ",(FPVI)mod_atom} ,
                        {250,530,330,556,""," ",(FPVI)mod_atom} ,
                        {400,530,480,556,""," ",(FPVI)mod_atom} ,
                        {530,530,610,556,""," ",(FPVI)mod_atom} ,
                        {660,530,740,556,""," ",(FPVI)mod_atom} ,
                        {760,530,820,556,""," ",(FPVI)mod_atom} ,
                        {165,500,215,526,""," ",(FPVI)mod_atom} ,
                        {250,500,330,526,""," ",(FPVI)mod_atom} ,
                        {400,500,480,526,""," ",(FPVI)mod_atom} ,
                        {530,500,610,526,""," ",(FPVI)mod_atom} ,
                        {660,500,740,526,""," ",(FPVI)mod_atom} ,
                        {760,500,820,526,""," ",(FPVI)mod_atom} ,
                        {165,470,215,496,""," ",(FPVI)mod_atom} ,
                        {250,470,330,496,""," ",(FPVI)mod_atom} ,
                        {400,470,480,496,""," ",(FPVI)mod_atom} ,
                        {530,470,610,496,""," ",(FPVI)mod_atom} ,
                        {660,470,740,496,""," ",(FPVI)mod_atom} ,
                        {760,470,820,496,""," ",(FPVI)mod_atom} ,
                        {165,440,215,466,""," ",(FPVI)mod_atom} ,
                        {250,440,330,466,""," ",(FPVI)mod_atom} ,
                        {400,440,480,466,""," ",(FPVI)mod_atom} ,
                        {530,440,610,466,""," ",(FPVI)mod_atom} ,
                        {660,440,740,466,""," ",(FPVI)mod_atom} ,
                        {760,440,820,466,""," ",(FPVI)mod_atom} ,
                        {165,410,215,436,""," ",(FPVI)mod_atom} ,
                        {250,410,330,436,""," ",(FPVI)mod_atom} ,
                        {400,410,480,436,""," ",(FPVI)mod_atom} ,
                        {530,410,610,436,""," ",(FPVI)mod_atom} ,
                        {660,410,740,436,""," ",(FPVI)mod_atom} ,
                        {760,410,820,436,""," ",(FPVI)mod_atom} ,
                        {165,380,215,406,""," ",(FPVI)mod_atom} ,
                        {250,380,330,406,""," ",(FPVI)mod_atom} ,
                        {400,380,480,406,""," ",(FPVI)mod_atom} ,
                        {530,380,610,406,""," ",(FPVI)mod_atom} ,
                        {660,380,740,406,""," ",(FPVI)mod_atom} ,
                        {760,380,820,406,""," ",(FPVI)mod_atom} ,
                        {165,350,215,376,""," ",(FPVI)mod_atom} ,
                        {250,350,330,376,""," ",(FPVI)mod_atom} ,
                        {400,350,480,376,""," ",(FPVI)mod_atom} ,
                        {530,350,610,376,""," ",(FPVI)mod_atom} ,
                        {660,350,740,376,""," ",(FPVI)mod_atom} ,
                        {760,350,820,376,""," ",(FPVI)mod_atom} ,
                        {165,320,215,346,""," ",(FPVI)mod_atom} ,
                        {250,320,330,346,""," ",(FPVI)mod_atom} ,
                        {400,320,480,346,""," ",(FPVI)mod_atom} ,
                        {530,320,610,346,""," ",(FPVI)mod_atom} ,
                        {660,320,740,346,""," ",(FPVI)mod_atom} ,
                        {760,320,820,346,""," ",(FPVI)mod_atom} ,
                        {165,290,215,316,""," ",(FPVI)mod_atom} ,
                        {250,290,330,316,""," ",(FPVI)mod_atom} ,
                        {400,290,480,316,""," ",(FPVI)mod_atom} ,
                        {530,290,610,316,""," ",(FPVI)mod_atom} ,
                        {660,290,740,316,""," ",(FPVI)mod_atom} ,
                        {760,290,820,316,""," ",(FPVI)mod_atom} ,
                        {165,260,215,286,""," ",(FPVI)mod_atom} ,
                        {250,260,330,286,""," ",(FPVI)mod_atom} ,
                        {400,260,480,286,""," ",(FPVI)mod_atom} ,
                        {530,260,610,286,""," ",(FPVI)mod_atom} ,
                        {660,260,740,286,""," ",(FPVI)mod_atom} ,
                        {760,260,820,286,""," ",(FPVI)mod_atom} ,
                        {165,230,215,256,""," ",(FPVI)mod_atom} ,
                        {250,230,330,256,""," ",(FPVI)mod_atom} ,
                        {400,230,480,256,""," ",(FPVI)mod_atom} ,
                        {530,230,610,256,""," ",(FPVI)mod_atom} ,
                        {660,230,740,256,""," ",(FPVI)mod_atom} ,
                        {760,230,820,256,""," ",(FPVI)mod_atom} ,
                        {165,200,215,226,""," ",(FPVI)mod_atom} ,
                        {250,200,330,226,""," ",(FPVI)mod_atom} ,
                        {400,200,480,226,""," ",(FPVI)mod_atom} ,
                        {530,200,610,226,""," ",(FPVI)mod_atom} ,
                        {660,200,740,226,""," ",(FPVI)mod_atom} ,
                        {760,200,820,226,""," ",(FPVI)mod_atom} ,
                        {165,170,215,196,""," ",(FPVI)mod_atom} ,
                        {250,170,330,196,""," ",(FPVI)mod_atom} ,
                        {400,170,480,196,""," ",(FPVI)mod_atom} ,
                        {530,170,610,196,""," ",(FPVI)mod_atom} ,
                        {660,170,740,196,""," ",(FPVI)mod_atom} ,
                        {760,170,820,196,""," ",(FPVI)mod_atom} ,
                        {165,140,215,166,""," ",(FPVI)mod_atom} ,
                        {250,140,330,166,""," ",(FPVI)mod_atom} ,
                        {400,140,480,166,""," ",(FPVI)mod_atom} ,
                        {530,140,610,166,""," ",(FPVI)mod_atom} ,
                        {660,140,740,166,""," ",(FPVI)mod_atom} ,
                        {760,140,820,166,""," ",(FPVI)mod_atom} ,
                        {165,110,215,136,""," ",(FPVI)mod_atom} ,
                        {250,110,330,136,""," ",(FPVI)mod_atom} ,
                        {400,110,480,136,""," ",(FPVI)mod_atom} ,
                        {530,110,610,136,""," ",(FPVI)mod_atom} ,
                        {660,110,740,136,""," ",(FPVI)mod_atom} ,
                        {760,110,820,136,""," ",(FPVI)mod_atom} ,
                      } ;

COMMAND parameter[] = {  {4,740,500,770,"INPUT FOR : "," ",(FPVI)modify_par},
                         {520,740,800,770,"SPACE GROUP # ","",(FPVI)modify_par},
                         {4,690,475,716,"A =    "," ",(FPVI)modify_par},
                         {4,660,475,686,"B =    "," ",(FPVI)modify_par},
                         {4,630,475,656,"C =    "," ",(FPVI)modify_par},
                         {520,690,1000,716,"ALPHA =  "," ",(FPVI)modify_par},
                         {520,660,1000,686,"BETA  =  "," ",(FPVI)modify_par},
                         {520,630,1000,656,"GAMMA =  "," ",(FPVI)modify_par},
                         {4,600,475,626,"Gmax = "," ",(FPVI)modify_par},
                         {520,600,1000,626,"Zone Axis : "," ",(FPVI)modify_par},
                         {4,570,475,596,"No. of Symmetry Operators :     ",
                          " ",(FPVI)modify_par},
                         {520,570,1000,596,"No. of slices per unit cell :  ",
                          " ",(FPVI)modify_par},
                         {4,540,475,566,"No. of atoms in the basis :     ",
                          " ",(FPVI)modify_par},
                         {520,540,1000,566,"No. of different atoms :       ",
                          " ",(FPVI)modify_par},
                         {4,510,475,536,"Microscope : "," ",(FPVI)modify_par},
                         {270,480,475,506,"Cs   = "," ",(FPVI)modify_par},
                         {270,450,475,476,"Del  = "," ",(FPVI)modify_par},
                         {270,420,475,446,"Th.  = "," ",(FPVI)modify_par},
                         {4,390,475,416,"Volt.  = "," ",(FPVI)modify_par},
                         {4,360,475,386,"Cent. of Laue circle:  h = ",
                          " ",(FPVI)modify_par},
                         {176,330,475,356,"k = "," ",(FPVI)modify_par},
                         {520,510,1000,536,"Foil Thickness : ",
                         " ",(FPVI)modify_par},
                         {520,480,1000,506,"Amplit. output for plotting :  ",
                          " ",(FPVI)modify_par},
                         {4,300,475,326,"Defocus : "," ",(FPVI)modify_par},
                         {4,270,475,296,"Aperture Radius   : "," ",(FPVI)modify_par},
                         {4,240,475,266,"Cent. of Obj. Aprt. :  h = ",
                          " ",(FPVI)modify_par},
                         {182,210,475,236,"k = "," ",(FPVI)modify_par},
                         {520,240,1000,266,"Cent. of Optic Axis :  h = ",
                          " ",(FPVI)modify_par},
                         {704,210,1000,236,"k = "," ",(FPVI)modify_par},
                      } ;

/* ----------   DEFINE THE ASSOCIATED MENUS -------------------------- */
COMMAND *m_use_pool_file[] = {&c_use_file,&c_nouse_file,&c_help,&null} ;
COMMAND *m_sel_sngl_lay[]  = {&c_sngle,&c_layered,&c_exit,&c_help,&null} ;
COMMAND *m_sel_sngl_str[]  = {&c_loc_fls,&c_com_fls,&c_SetDirectory,&c_prev_page,
                                     &c_next_page,
                              &c_old_fl,&c_new_fl,&c_fl_exit,&c_help,&null} ;
COMMAND *m_sel_lay_str[]   = {&c_lay_fls,&c_next_page,&c_prev_page,
                              &c_old_fl,&c_new_fl,&c_fl_exit,&c_help,&null} ;
COMMAND *m_sel_old_fl[82]  = {&c_old_fl} ;
COMMAND *m_upd_file[]      = {&c_upd_rename,&c_no_upd,&c_upd,&c_help,&null} ;
COMMAND *m_lay_pg[]        = {&c_def_lay,&c_del_lay,&c_deposit,&c_insert,
                              &c_remove,&c_repeat,&c_reset,&c_ret_lay,&c_help,
                              &null} ;
COMMAND *m_set_pg_seq[MAXLAYERS+7]  = {&c_deposit,&c_insert,&c_remove,&c_repeat,
                              &c_reset} ;
COMMAND *m_rem_pg_lay[MAXSLICES+2] = {&c_remove} ;
COMMAND *m_uc_psp_nopsp[]  = {&c_psp_1,&c_psp_2,&c_help,&null} ;
COMMAND *m_nuc_psp_nopsp[] = {&c_psp_3,&c_psp_4,&c_help,&null} ;
COMMAND *m_extra_lay_par[] = {&c_num_lay,&c_num_slc,&c_lay_names,
                                     &c_lay_thick,&c_help,&null} ; 
COMMAND *m_main_sngl_str[] = {&ch_par,&c_basis,&run_pg,&run_im,
                                     &c_display,
                              &run_ctf,&run_p,&c_atoms,&run_ms,&run_a,&v_file,
                              &exit_p,&c_help,&null } ;
COMMAND *m_main_lay_str[]  = {&ch_par,&c_v_pg,&c_unass,&run_im,
                                     &c_display,
                              &run_ctf,&run_p,&c_v_comp,&run_ms,&run_a,
                              &v_file,&exit_p,&c_help,&null} ;
COMMAND *m_ch_main_par[40] = {&ch_par};
COMMAND *m_view_atoms[]    = {&sh_at,&re_at,&fwd_at,&rwd_at,&c_page,&c_help,&null} ;
COMMAND *m_ch_atom[122]    = {&ch_at} ;

COMMAND *m_view_unit_cel[] = {&c_vucell,&c_vunucel,&c_ret5,&c_help,&null} ;

COMMAND *m_dspl_source[]   = {&c_pot,&c_exwf,&c_diff,&c_image,
                              &c_cancel,&c_ret6,&c_terminal,&c_lp,
                              &c_dis_toggle,&c_quantitative_menu,&c_help,&null} ;
COMMAND *m_dspl_oper[]     = {&c_pot,&c_exwf,&c_diff,&c_image,
                              &c_terminal,&c_lp,&c_hist,&c_histeq,
                              &c_fft,&c_unused,
                              &c_add_cells,&c_zoom,&c_adj_cnt,&c_dsply,
                              &c_exe,&c_cancel,&c_ret7,&c_help,&null} ;
COMMAND *m_set_br_cntrst[] = {&c_down_brite,&c_up_brite,&c_down_cntrst,
                              &c_up_cntrst,&c_blkwht,&c_ret8,&c_help,&null} ;
COMMAND *m_view_basis[]    = {&ch_at,&ad_at,&de_at,&c_symop,&re_basis,
                                     &fwd_at,&rwd_at,&c_page,&c_help,&null} ;
COMMAND *m_ch_bas_at[122]  = {&ch_at} ;
COMMAND *m_view_symop[]      = {&ch_so,&ad_so,&de_so,&fwd_so,&rwd_so,
                                       &re_so,&c_help,&null} ;
COMMAND *m_ch_symop[42]    = {&ch_so} ;
COMMAND *m_quantitativeMenu[] = {&c_loadExperimentalImage,&c_loadStandardDeviationImage,
	&c_compareImageWithSimulation,&c_refineParameters,&c_refineStructure,
	&c_returnFromQuantitativeMenu,&c_help,&null} ;

COMMAND *m_crt_toggle[]    = 
	{&c_noerase,&c_erase,&c_nomontage,
	&c_montage,
	&c_req_pos,&c_noreq_pos,&c_nomont_space,
	&c_mont_space,&c_auto_scale,&c_abs_scale,
	&c_ctf_autoscale,&c_ctf_absscale,
	&c_elScattFact,&c_xrayScattFact,
	&c_set_aperture,&c_set_noaperture,
	&c_set_titles,&c_set_notitles,
	&c_set_pseudo_slice,&c_set_ull_slice,
	&c_set_min_int,
	&c_set_min_fft_int,&c_set_camera_length,
	&c_index,&c_set_dp_cntr,
	&c_cloc,&c_set_halftone,&c_set_solid,
	&c_erase_screen,&c_text,
	&c_store,&c_displ,&c_lprint,&c_screen,&c_dir,
	&c_set_laswrit_cntrst,&cSetDpTheta,
	&cSetNoOverLayAtoms,&cSetOverLayAtoms,
	&cSetAmplAutoScale,&cSetAmplAbsScale,
	&cDisplayValues,&cPrintValues,
	&cSetSubPhase,&cSetNoSubPhase,
	&cSetAsciiFile,&cSetBinaryFile,
	&cSetPrintToPrinter,&cSetPrintToFile,
	&cSetNormalMontage,&cSetCustomMontage,
	&c_ret_switches,&c_help,&null} ;
	
COMMAND *m_fb_toggle[]     = 
	{&c_noerase,&c_erase,&c_nomontage,
	&c_montage,
	&c_req_pos,&c_noreq_pos,&c_nomont_space,
	&c_mont_space,&c_auto_scale,&c_abs_scale,
	&c_ctf_autoscale,&c_ctf_absscale,
	&c_elScattFact,&c_xrayScattFact,
	&c_set_aperture,&c_set_noaperture,
	&c_set_titles,&c_set_notitles,
	& c_set_pseudo_slice,&c_set_ull_slice,
	&c_set_min_int,
	&c_set_min_fft_int,&c_set_camera_length,
	&c_index,&c_set_dp_cntr,
	&c_cloc,&c_set_halftone,&c_set_solid,
	&c_erase_screen,&c_text,
	&c_store,&c_displ,&c_lprint,&c_screen,&c_dir,
	&c_set_laswrit_cntrst,&cSetDpTheta,
	&cSetNoOverLayAtoms,&cSetOverLayAtoms,
	&cSetAmplAutoScale,&cSetAmplAbsScale,
	&cDisplayValues,&cPrintValues,
	&cSetSubPhase,&cSetNoSubPhase,
	&cSetAsciiFile,&cSetBinaryFile,
	&cSetPrintToPrinter,&cSetPrintToFile,
	&cSetNormalMontage,&cSetCustomMontage,
	&c_ret_switches,&c_help,&null} ;
COMMAND *m_pick_atom[11] ;
/* -------------------------   END DEFINITIONS -------------------------- */

MENUS gMenuList[] =
	{
		&m_sel_sngl_lay[0],
		&m_sel_sngl_str[0],
		&m_sel_lay_str[0],
		&m_sel_old_fl[0],
		&m_main_sngl_str[0],
		&m_ch_main_par[0],
		&m_view_basis[0],
		&m_ch_bas_at[0],
		&m_view_symop[0],
		&m_ch_symop[0],
		&m_view_atoms[0],
		&m_ch_atom[0],
		&m_view_unit_cel[0],
		&m_uc_psp_nopsp[0],
		&m_nuc_psp_nopsp[0],
		&m_dspl_source[0],
		&m_dspl_oper[0],
		&m_set_br_cntrst[0],
		&m_main_lay_str[0],
		&m_lay_pg[0],
		&m_set_pg_seq[0],
		&m_rem_pg_lay[0],
		&m_extra_lay_par[0],
		&m_use_pool_file[0],
		&m_upd_file[0],
		&m_crt_toggle[0],
		&m_fb_toggle[0],
		&m_pick_atom[0],
		&m_quantitativeMenu[0]
	} ;
#endif

