// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
void DrawControl(COMMAND *control) {
    Rect	tRect ;
    short 	x,y,width ;
    extern	uLong	gWhitePixel,gBlackPixel ;

    tRect = gToolControl[tool]->rect ;
    InsetRect(&tRect,1,1) ;
    EraseRect(&tRect) ;
    PenSize(2,2) ;
    SetFgColor(gWhitePixel) ;
    DrawLine(tRect.left,tRect.bottom,tRect.left,tRect.top) ;
    DrawLine(tRect.left,tRect.top,tRect.right,tRect.top) ;
    SetFgColor(gBlackPixel) ;
    DrawLine(tRect.right,tRect.top,tRect.right,tRect.bottom) ;
    DrawLine(tRect.right,tRect.bottom,tRect.left,tRect.bottom) ;
    PenSize(1,1) ;
    width = StringWidth(gToolControl[tool]->text) ;
    x = (tRect.left+tRect.right)/2-width/2 ;
    y = (tRect.top+tRect.bottom)/2 + 8 ;
    DrawText(x,y,gToolControl[tool]->text) ;
}
void HighlightTool(ToolType tool) {
    Rect	tRect ;
    short 	x,y,width ;
    extern	uLong	gWhitePixel,gBlackPixel,gDarkerGray ;

    tRect = gToolControl[tool]->rect ;
    InsetRect(&tRect,1,1) ;
    SetFgColor(gDarkerGray) ;
    FillRect(&tRect) ;
    PenSize(2,2) ;
    SetFgColor(gBlackPixel) ;
    DrawLine(tRect.left,tRect.bottom,tRect.left,tRect.top) ;
    DrawLine(tRect.left,tRect.top,tRect.right,tRect.top) ;
    SetFgColor(gWhitePixel) ;
    DrawLine(tRect.right,tRect.top,tRect.right,tRect.bottom) ;
    DrawLine(tRect.right,tRect.bottom,tRect.left,tRect.bottom) ;
    PenSize(1,1) ;
    width = StringWidth(gToolControl[tool]->text) ;
    x = (tRect.left+tRect.right)/2-width/2 ;
    y = (tRect.top+tRect.bottom)/2 + 8 ;
    /* SetFgColor(gBlackPixel) ; */
    DrawText(x,y,gToolControl[tool]->text) ;
}
void UnHighlightTool(ToolType tool) {
    DrawTool(tool) ;
}

