// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include "funcdefs.h"
#include "menudef.h"
#include "devices.h"
#include "globals.h"
void eraser(long ix1,long iy1,long ix2,long iy2) {
    long xl,yl,xh,yh,width,height ;
    Rect tRect ;
    unsigned long oldFg,GetBkColor() ;

    tRect = gCurrentPort->GetPortRect() ;
    oldFg = GetFgColor() ;
    SetFgColor(GetBkColor()) ;

    yl = Terminal.yres - iy2 ;
    yh = Terminal.yres - iy1 ;
    ix1 /= 2 ;
    ix2 /= 2 ;
    yl /= 2 ;
    yh /= 2 ;
    xl = ix1 ;
    width = ix2 - ix1 + 1 ;
    height = yh - yl + 1 ;
    SetRect(&tRect,xl,yl,xl+width,yl+height) ;
    FillRect(&tRect) ;
    SetFgColor(oldFg) ;
}   
