#ifndef __FUNCDEFS__
#define __FUNCDEFS__
#include <stdio.h>
#include "types.h"
#include "menudef.h"
#include "atoms.h"
#include "layers.h"

#include "XDrivers.h"

void enableast() ;
void cntrlctrap() ;
long abandn() ;
void AdjustGamma(long *np,long *mp,long nx,long ny);
void AdjustSampling(long *np,long *mp,long nx,long ny) ;
void PlotAmplitudes() ;
void set_refl(long i) ;
void set_ampl() ;
void set_int() ;
void set_many() ;
void set_one();
void set_phs() ;
void ApplySymmetries() ;
void atom3d() ;
long atomno(char *cp) ;
void ball3d(short *atma,short *atmb,short *atmc,short *atmr,long natom) ;
void FUpdateRect(long x1,long y1,long x2,long y2) ;
void boks(long xl,long yl,long xh,long yh) ;
void construct() ;
void draw_screen() ;
void erase_window() ;
void erase_cnstrct_menu() ;
void erase_cmnd_line() ;
void ret_cnstrct();
void action1() ;
void add_x_unit_cells() ;
void add_y_unit_cells() ;
void dis_new_cell() ;
void celext(long *np,long *mp,long nx,long ny,short *ierr);
void cfft(long *np,long *mp) ;
void cfftinv(long *np,long *mp) ;
void change_cursor() ;
void reset_cursor() ;
void change_par() ;
void close_ps_file() ;
void close_semper_file() ;
void clr_display() ; 
void condense(float *array,long length) ;
void r_insert_col() ;
void r_remove_col() ;
void r_move_col() ;
void r_change_col() ;
void get_atom_position(float *x_coord,float *y_coord) ;
void get_atom_index(float x_coord,float y_coord,long *index) ;
void set_toleranse() ;
void check_button_1() ;
void displ_pick_atom(long atoms_at_site,long *index_array) ;
void r_adj_cntrst() ;
void lbl_brite_bar(long xl,long yl,long xh,long yh) ;
void lbl_contr_bar(long xl,long yl,long xh,long yh) ;
void draw_brite_bar(long xl,long yl,long xh,long yh);
void draw_contr_bar(long xl,long yl,long xh,long yh) ;
void draw_cntrst_curve() ;
void plot_cntrst(long xo,long yo,long xm,long ym) ;
void modify_cntrst(long i) ;
void cp_abs(long ix,long iy) ;
void cpage() ;
void create_file() ;
void ctfplot() ;
void dcl(char *input_command) ;
long get_spcgrp_number() ;
long get_event() ;
void assm_spcgrp(long spcgrp_number) ;
void generate_spcgrp(char  *spacegroup) ;
void encode_symop(char *string,struct GENERATOR *sym_op) ;
void apply_gen(struct GENERATOR *oper,struct GENERATOR *source,struct GENERATOR *dest) ;
long ident(struct GENERATOR *p_sym) ;
long new_symop(struct GENERATOR *p_symop,long num_symop) ;
void decode_spcgrp(char *string,long *pnum_gen,long *pinversion) ;
void get_inverse(struct GENERATOR *source,struct GENERATOR *dest) ;
void decode_gen(long rot,long trnsl,struct GENERATOR *sym_op) ;
void decode_symop(long j) ;
void diffr(long *np,long *mp) ;
void dispfft(long *pnp,long *pmp) ;
void displ_hist(long *np,long *mp) ;
void displ_menu() ;
void erase_self() ;
void erase_remain_menu() ;
void displ_msg(long i) ;
void displ_var() ;
void display(COMMAND *item) ;
void DrawControl(COMMAND *control) ;
void r_sngle_structure(char *structname,char *status) ;
void r_lay_structure(char *structname,char *status) ;
void r_display() ;
void r_ret8() ;
void r_dispfft(long *np,long *mp) ;
void r_dsply() ;
void dsply(long *np,long *mp) ;
void r_cancel() ;
void r_exe() ;
void SetCustomMontageSequence() ;
void DoAdvertise() ;
void dis_at() ;
void r_ret5() ;
void cel_persp()  ;
void cel_nopersp() ;
void vu_std_cell() ;
void vu_new_cell() ;
void nucel_persp() ;
void nucel_nopersp() ;
void r_atom3d() ;
void draw_circle(long x,long y,long rad) ;
void gDrawPixel(long x,long y) ;
void gDrawLine(long x1,long y1,long x2,long y2) ;
void gMoveTo(long ix,long iy) ;
void gDrawChar(long x,long y,char c) ;
void gDrawCircle(long x,long y,long rad) ;
void gSetFgColor(long value) ;
void gFillCircle(long x,long y,long rad) ;
void gDrawRect(long xlow,long ylow,long xhi,long yhi) ;
void gDrawText(long x,long y,char *text) ;
void gDrawImageLine(long x,long y,long n,unsigned char *imageline) ;
long gReadImageLine(long x,long y,long n,unsigned char *imageline) ;
long gDrawImage(unsigned char *image,long x,long y,long width,long height) ;
long gReadImage(unsigned	char *image,long x,long y,long width,long height) ;
void LandScape() ;
void echo_char(long x,long y,char c) ;
void erase_message() ;
void err(long i) ;
void err_disp(long i) ;
void err_seq(long i) ;
void err_io(long i) ;
void err_io_ds(long i) ;
void ExitX() ;
void fb_crt_toggle() ;
void fb_crt_erase() ;
void fb_crt_ergra() ;
void fb_crt_erim() ;
void fb_crt_store_image() ;
void fb_crt_display() ;
void fb_crt_laser() ;
void fb_crt_mod_lut() ;
void fb_crt_wr_txt() ;
void fb_crt_displ(char *out,long *np,long *mp,long *ixp,long *iyp) ;
void fb_crt_dir() ;
void set_chann_1() ;
void set_chann_2() ;
void fb_crt_index() ;
void r_stemdxw() ;
void fb_crt_screen() ;
void set_min_int() ;
void ret_switch() ;
void set_erase() ;
void set_noerase() ;
void set_montage() ;
void set_nomontage() ;
void set_req_pos() ;
void set_noreq_pos() ;
void erase_screen() ;
void set_camera_length() ;
void set_min_fft_int() ;
void set_abs_scale() ;
void set_auto_scale() ;
void set_mont_space() ;
void set_nomont_space() ;
void set_ctf_autoscale() ;
void set_ctf_absscale() ;
void set_pseudo_slice() ;
void set_ull_slice() ;
void set_titles() ;
void set_notitles() ;
void set_aperture() ;
void set_noaperture() ;
void set_diffpt_cntr() ;
void set_laswrit_cntrst() ;
void set_elfactors() ;
void set_xrayfactors() ;
void set_recipspace() ;
void set_realspace() ;
void SetNoOverLayAtoms() ;
void SetOverLayAtoms() ;
void set_dp_theta() ;
void set_ampl_absscale() ;
void set_ampl_autoscale() ;
void SetDisplayValues() ;
void SetPrintValues() ;
void SetSubPhase() ;
void SetNoSubPhase() ;
void SetAsciiFile() ;
void SetBinaryFile() ;
void SetPrintToFile() ;
void SetPrintToPrinter() ;
void SetNormalMontage() ;
void SetCustomMontage() ;
void set_halftone() ;
void set_solid() ;
void CalculateProjectedPotential(float *zvg,long *noz,long jmax) ;
void AtomicFormFactor(float usq,long *noz,long j,long ino,float *elfrmf) ;
void fft2d(float *data,long n,long m,long isign) ;
void fft1d(float *data,float *table,long m,long inc) ;
void binrev(float *c,long m,long inc) ;
void r_sngl_layered(long i) ;
void r_old_fl() ;
void set_file(long i) ;
void copy_files(char *whichFile) ;
void r_fl_exit() ;
void displ_files() ;
void r_exit() ;
void r_prev_page() ;
void r_next_page() ;
void r_new_fl() ;
void r_loc_fls() ;
void r_com_fls() ;
void r_lay_fls() ;
void r_scan_structure(char *structname) ;
void r_use_file() ;
void r_nouse_file() ;
void read_fls(long k) ;
void ScanDirectory(char *filename) ;
void fill_area(long xlow,long ylow,long xhi,long yhi) ;
void fill_circle(long x,long y,long rad,long intens) ;
void get_atoms() ;
void get_atoms() ;
long get_char_size() ;
void get_microscopes() ;
float get_float(float defaultValue) ;
long get_int(long defaultValue) ;
char * GetNumber() ;
void EchoChar(char c) ;
long ReadString(char *buffer,long numChar) ;
char *get_snumber() ;
void r_diff() ;
void r_exwf() ;
void r_image() ;
void r_pot() ;
void get_symop() ;
void get_ttfs(char *buffer,float *low_value,float *high_value,float *increment) ;
void GetImage(long *np,long *mp) ;
void GetPotential(long *np,long *mp) ;
void GetXEvents() ;
void DoMouseDown(XEvent *event) ;
void ChangeWindowSize(XConfigureRequestEvent *eventP) ;
void getxim(long *np,long *mp) ;
void GetExitWave(long *np,long *mp) ;
void set_ctm(float size,float angle) ;
void hafton(long *np,long *mp) ;
void ws_image(char *out,long nmax,long mmax) ;
void OverLayAtoms(long xlow,long ylow,long width,long height) ;
void histog(long *np,long *mp) ;
void r_hist() ;
void histeq_c(long *np,long *mp) ;
void r_histeq() ;
void set_ohkl_nhkl(float r[3][3]) ;
void CalculateImages(long *nobeam,float *sum,float *range,long *ierr) ;
void SetLensParameters(float *cs1,float *div1,float *cs,float *div,float *gmax,
		long *nbeam,long *mbeam,long *nz) ;
void SetImageIntensities(float *out,long jmax) ;
void ScaleImageIntensities(long *pnp,long *pmp,float *prange,long *ierr) ;
void contrst(long *pnp,long *pmp,float *pcntrst,float *prange,float *pbrite) ;
void histeq(long *pnp,long *pmp) ;
void ApplyObjectiveLens(float *zphi,float *ihk,float cs,float theta,long nbeam,long mbeam,
	long jmax,long *nobeam,long *num_beam,float *sum,float *wrkspc,long maxRefl) ;
void CrossTransferFunction(float h1,float k1,float h2,float k2,float u1sq,float u2sq,
	float astsq,float bstsq,float abga,float *xcoeff) ;
long in_zone(long i,long ij,long ik,long izone[3]) ;
void r_v_comp() ;
void SetSequence() ;
void r_deposit() ;
void r_insert() ;
void r_repeat() ;
void r_reset() ;
void r_def_layer() ;
void r_del_layer() ;
void displ_lay() ;
void displ_spec() ;
void r_ret_lay() ;
void mod_pg(long num) ;
void rem_pg(long i) ;
void do_repeat() ;
void do_reset() ;
void mmfft(float *data,long n,long m,float *rtime) ;
void mmffti(float *data,long n,long m,float *rtime) ;
void mod_atom(long i) ;
void modify_par(long i) ;
void DoMultisliceCalculation() ;
void SetMsliceParameters() ;
void PrintMsliceOutput() ;
void StoreAmplitudes() ;
void CalculatePropagator(float *zprop,float dz) ;
void CalculateExitWavefunction(float *zphi,float *zphsgr,float *zprop,long jmax) ;
void ApplyPhasegrating(float *zphi,float *zphsgr,long jmax) ;
void ApplyPropagator(float *zphi,float *zprop,long n,long m,long jmax,short iamp,long islice) ;
void SetPhasegrating(float *rphsgr,float slcth,float sigma,long jmax) ;
void SetNewHKL(short ioldh,short ioldk,short ioldl,long *inewh,long *inewk,long *inewl) ;
void SetPendellosungData(float *zphi,long n,long m,long i) ;
long near(float x) ;
void CalculateProjectedCell(float *av,float *bv,float *cv,long ihkl[][3],float *gsq,
	long ic,float rm[3][3],long *inx,long *iny,long *inz) ;
void rotmat(float *v1,float *v2,float *v3,float rm[3][3]) ;
long not_equiv(float x,float y,float z,long icount,long ndx) ;
void off_highlight() ;
void on_highlight() ;
void on_off(COMMAND *item) ;
FILE *open_ps_file(char *filename) ;
void open_semper_file(char *filename) ;
void packfb(float *data,long *n) ;
void pattern(long xlow,long ylow,long xhi,long yhi,long num) ;
void pgflnm(char *string1,char *string2) ;
void ExpandUnitCell(float *x0,float *y0,float *z0,short *iaz0,float *dw0,float *occ0,
	short *nt0,float *x,float *y,float *z,short *iaz,float *dw,float *occ,short *nt,
	long *natom,long *inx,long *iny,long *inz,float r[3][3]) ;
void CalculatePhasegrating(long *ierr) ;
void SetPhasegratingParameters(char name[MAXTYPES][8],long *noz) ;
void WritePhasegratingOutput(char name[MAXTYPES][8]) ;
void Find3DHKLIndicies(long ih,long ik,long il,long *jh,long *jk,long *jl,float r[3][3]) ;
void ViewOriginalUnitCell(float *rview,long *ierr) ;
void SetProjectedCell(long *ierr) ;
void SortAtoms(float *x,float *y,float *z,short *iz,float *dw,float *occ,short *ntype,long n) ;
void SortGVectors(float *f,float *g,short *ihk,long n) ;
void SortAtomsOnZ(float *x,float *y,float *z,float *r,long *icolor,long n) ;
void ProjectedCellEqualsOriginal() ;
void ViewNewUnitCell() ;
void DrawNewUnitCell(float *rview,long *ierr) ;
void AddUnitCellAtoms(float x[][3],float *x0,float *y0,float *z0,short *iz0,
	long num_atoms,long *nview_atoms) ;
void TranslateIntoUnitCell(float *x,float *y,float *z,long natom) ;
void TransformAtomCoordinates(float *x,float *y,float *z,long n,float r[3][3]) ;
void SetOriginalUnitCellParameters(long *ierr) ;
void SortHKLVectors(long ihkl[][3],float *gsq,long n) ;
void CrossProduct(float *v1,float *v2,float vol,float *v3) ;
void DotProduct(float *v1,float *v2,float a,float b,float c,
	float csa,float csb,float csg,float *dot) ;
void SetHKLTransformationMatrix(float *v1,float *v2,float *v3,float r[3][3]) ;
void SetPerpendicularReflections(long ihkl[][3],float *gsq,long *ic,long *iuvw) ;
void SetCoordinateTransformationMatrix(float *ruvw,float siang,float csang,float a,float b,float c,
	float sial,float sibe,float siga,float csal,float csbe,float csga,float r[3][3]) ;
void TransfVectorToProjectedCell(float *x,float *xtr,float r[3][3]) ;
void pr_help_msg(COMMAND *item) ;
void r_remove() ;
void rd_image(unsigned char *image,long order,long *ierror) ;
long read_file(FILE *fp) ;
void read_symop(long i) ;
long requested(FPV function) ;
void r_ret6() ;
void r_ret7() ;
void rewrite_file(char *fl_name) ;
void run_ampli() ;
void run_ctfplot() ;
void run_dcl() ;
void r_expim() ;
void r_fft() ;
void r_filter() ;
void filter(long *np,long *mp) ;
void run_prog() ;
void run_p_pg() ;
void run_phsgrt() ;
void run_mslice() ;
void run_p_im() ;
void run_image() ;
void ReportFileOpenError(char *filename) ;
void run_shell() ;
void dcl(char *input_command) ;
void r_add_unit_cells() ;
void add_unit_cells(long *np,long *mp) ;
void r_zoom() ;
void zoom_c(long *np,long *mp) ;
long semdat() ;
long semdet() ;
long semdro(float *a,long *i,long *j,long *k,long *mode,long *ix1,
	long *iy1,float *bot,float *top) ;
long semdri(float *a,long *j,long *mode,long *ix,long *iy,float *bot,
	float *top) ;
long semdln(long *ix1,long *iy1,long *ix2,long *iy2) ;
long semfil(long *ix1,long *iy1,long *ix2,long *iy2) ;
long sempat() ;
long semdtx(long *itext,long *nchar,long *ix,long *iy) ;
long semdxw(long *ix1,long *iy1) ;
long semder(long *opcode) ;
long semdfl() ;
void keys() ;
void semdvc() ;
void semdpt(long *,long *) ;
void keys() ;
void semdvc() ;
void semdpt(long *,long *) ;
void send_ps_file() ;
void send_to_laser(char *out,long ncol,long nrow) ;
void set_blkwht(long xo,long yo,long xm,long ym) ;
void set_char_size(long size) ;
void set_menu(long number) ;
long set_microscope(char *string) ;
void set_nz() ;
void set_video_normal() ;
void set_video_reverse() ;
void set_video_off() ;
void SetCalculationState() ;
void SetCalculationDimensions(float *pa,float *pb,float *pgmax,long *pn,long *pm) ;
void setup_trnsf() ;
void chng_at() ;
void chng_so() ;
void mod_symop(long i) ;
void show_at() ;
void show_symop() ;
void show_basis() ;
void fw_at();
void fw_so() ;
void rw_at() ;
void r_page() ;
void rw_so() ;
void add_so() ;
void add_symop() ;
void del_at() ;
void del_so() ;
void ret_at() ;
void ret_so() ;
void ret_basis() ;
void del_atom() ;
void del_symop() ;
void displ_atoms(AtomRecPtr unit) ;
void displ_symop() ;
void add_atom() ;
void add_at() ;
void sort(AtomRecPtr unit,long n) ;
void sound_bell() ;
void cell3c(float *av,float *bv,float *cv) ;
void DrawAtoms(float *xp,float *yp,float *zp,float *r,
	long *icolor,long number) ;
void DrawAtomCircles(short *ix,short *iy,short *iz,short *ir,
	long *ic,long n) ;
void stemdln(long x1,long y1,long x2,long y2) ;
void stemdpt(long x1,long y1) ;
void stemdro(char *a,long *i,long *j,long *k,long *mode,long *ix,
	long *iy,float *bot,float *top) ;
void stemdri(char *a,long *j,long *mode,long *ix,long *iy,
	float *bot,float *top) ;
void stemder(long *opcode) ;
void stemdxw(long *x,long *y) ;
void stemfil(long x1,long y1,long x2,long y2) ;
void stemdtx(long *x,long *y,long *itext,long *len) ;

void switch_display(long iswitch) ;
void switch_on(COMMAND *item) ;
void r_terminal() ;
void r_lp() ;
void r_semper() ;
long temdxw(long *px,long *py) ;
void temdln(long x1,long y1,long x2,long y2) ;
void temdpt(long x1,long y1) ;
void temdtx(long x,long y,char *text) ;
void temfil(long xlow,long ylow,long xhi,long yhi) ;
void temdro(char *buffer,long *i,long *j,long *k,long *mode,
	long *ix,long *iy,float *bot,float *top) ;
void temdri(char *a,long *j,long *mode,long *ix,long *iy,
	float *bot,float *top) ;
void temder() ;
void titles(long *np,long icx,long iy) ;
long types(AtomRecPtr unit,long natom) ;
void open_semper_file() ;
void qiow() ;
void terminateNcemss() ;
void r_upd() ;
void r_no_upd() ;
void r_upd_rename() ;
void view_o_file()  ;
void view_outfile(FILE *filep) ;
void write_message(char *text) ;
void write_par(long i) ;
void write_postscript_file(char *postscript_file,char *out,
	long *ncol,long *nrow) ;
void wrt_image(unsigned char *image,long *ierror) ;
void eraser(long,long,long,long) ;
void DrawPixel(long x,long y) ;
void DrawLine(long x1,long y1,long x2,long y2) ;
void MoveTo(long ix,long iy) ;
void DrawString(char *text) ;
void DrawChar(long x,long y,char c) ;
void DrawRect(long xlow,long ylow,long xhi,long yhi) ;
void DrawText(long x,long y,char *text) ;
void DrawImageLine(long x,long y,long n,unsigned char *imageline) ;
void RDrawRect(Rect *tRect) ;
void FrameRect(Rect *tRect) ;
void FillRect(Rect *tRect) ;
void EraseRect(Rect *tRect) ;
void EraseCircle(short x,short y,short rad) ;
void ClearDisplay() ;
void GetPort(GrafPtr *port) ;
void SetPort(GrafPtr port) ;
void SetRect(Rect *tRect,short x1,short y1,short x2,short y2) ;
Boolean PtInRect(Point *pt,Rect *tRect) ;
void OffsetRect(Rect *tRect,short x,short y) ;
void InsetRect(Rect *tRect,short x,short y) ;
void DrawCircle(short x,short y,short rad) ;
void FillCircle(short x,short y,short rad) ;
unsigned long GetFgColor() ;
unsigned long GetBkColor() ;
void SetFgColor(unsigned long value) ;
void SetBkColor(unsigned long value) ;
void TextSize(short size) ;
void TextFace(short face) ;
void PenSize(short width,short height) ;
void PenNormal() ;
void SetWatchCursor() ;
void InitCursor() ;
void SetTrackingMode() ;
void UnSetTrackingMode() ;
Boolean Button() ;
void GetMouse(Point *where) ;
long StringWidth(char *text) ;
void UnionRect(Rect *srcRect1,Rect *srcRect2,Rect *destRect) ;
Boolean RectISectRect(Rect *aRect,Rect *bRect) ;
void ClipImage(long *np,long *mp,long *nmax,long *mmax) ;
void ZoomImage(long *np,long *mp,float zoom_fact,short *ierr) ;
void UpdateWindow(XEvent *event) ;
void UpdateFromOffscreen(GrafPtr dest,GrafPtr source) ;
void UpdateFromOffScreenRect(GrafPtr dest,GrafPtr source,Rect *tRect) ;
void UpdateScreen() ;
void UpdateImageScreen() ;
void DrawCommandLine() ;
void SetOffscreenPort(OffScreenPtr portPtr) ;
void UnSetOffscreenPort(OffScreenPtr portPtr) ;
void CopyBits(GrafPtr source,GrafPtr dest,Rect *srcRect,Rect *dstRect,
	CopyMode mode = srcCopy) ;
void UnHighlightControl(COMMAND *control) ;
void HighlightControl(COMMAND *control) ;
MENUS	GetFirstMenuItem() ;
void	SetMenu(long theMenuID) ;
void	SetFirstMenuItem(MENUS *menuitemlistPtr) ;
void	DisplayMenu() ;
long	GetCurrentMenu();
void	PutMessage(char *) ;
void 	EnableControl(COMMAND *control) ;
void 	DisableControl(COMMAND *control) ;
void	ActivateButton(FL_OBJECT *button) ;
void	DeactivateButton(FL_OBJECT *button) ;

#endif

