// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include "ttypes.h"
extern FILE *psfile ;
void erase_message() ;
void write_message(char *) ;
FILE *open_ps_file(char *filename) ;
FILE *open_ps_file(char *filename) {
  /* ------------------------------------------------------ */
  /* Open a Postscript output file for generating graphics  */
  /* and return a filepointer to the file. return NULL if   */
  /* unsucessful					    */
  /* ------------------------------------------------------ */
	extern CharRecord CharRc ;	

	if((psfile=fopen(filename,"w")) != NULL)
		{
		fprintf(psfile,"%!PS Postscript R.Kilaas") ;
		fprintf(psfile,"\n/%s findfont",CharRc.fontname) ;
		fprintf(psfile,"\n%d scalefont",CharRc.fontsize) ;
		fprintf(psfile,"\nsetfont") ;
                fprintf(psfile,"\n/cbitDepth 8 def") ;
		fprintf(psfile,"\n/inch {72 mul} def") ;
    		fprintf(psfile,"\ngsave") ;
		fprintf(psfile,
"\n/Spaper /Lpaper 8.5 inch 11 inch dtransform 3 -1 roll exch def def") ;
		fprintf(psfile,
"\n/Landscape {90 rotate 0 -8.5 inch translate /Spaper Spaper neg def} def") ;
                fprintf(psfile,"\n/DrawImageLine") ;
		fprintf(psfile,"\n{") ;
		fprintf(psfile,"\ngsave") ;
		fprintf(psfile,
			"\ntranslate /cbitHt exch def /cbitWidth exch def") ;
		fprintf(psfile,"\ncbitWidth cbitHt scale") ;
		fprintf(psfile,"\n/pixlstr cbitWidth string def") ;
		/* fprintf(psfile,"\n{2 mul} settransfer") ; */
		fprintf(psfile,"\ncbitWidth cbitHt cbitDepth") ;
		fprintf(psfile,"\n[cbitWidth 0 0 cbitHt 0 0]") ;
		fprintf(psfile,
			"\n{currentfile pixlstr readhexstring pop} image") ;
		fprintf(psfile,"\ngrestore") ;
		fprintf(psfile,"\n} bind def") ;
		}
        erase_message() ;
        write_message("Writing the Postscript file.....") ;
	return(psfile) ;
  }
